// Arcadeflow - v 5.4
// Attract Mode Theme by zpaolo11x
//
// Based on carrier.nut scrolling module by Radek Dutkiewicz (oomek)
// Including code from the KeyboardSearch plugin by Andrew Mickelson (mickelson)

local AFVERSION = "5.4"

if (FeVersionNum < 250) fe.overlay.splash_message ("Arcadeflow requires at least Attract Mode v2.5.0")

// for debug purposes
local DEBUG = false

function debugpr (instring){
   if (DEBUG) print (instring)
}

function testpr (instring){
   print ("\n"+instring+"\n")
}
function testprc (instring){
   print (instring+"\n")
}

fe.load_module("file")
fe.do_nut("pic_functions.nut")

local frm = {
   orderx = 0
   preliner = "  ○ "
   prelinerh = "● "
   postliner = "                                                                                                  "
}

class UserConfig </ help="" />{
   </ label= frm.postliner, help=" ", options = " ", order=frm.orderx++ /> paramxx0 = " "

	</ label=frm.prelinerh + "GENERAL" + frm.postliner, help=" ", options = " ", order=frm.orderx++ /> paramx1 = " "
		</ label=frm.preliner + "Box Art mode" + frm.postliner, help="Show box art or flyers instead of screen captures by default (can be configured with menu or hotkey)", options="Yes, No", order=frm.orderx++ /> boxartmode ="No"    
      </ label=frm.preliner + "Context menu button" + frm.postliner, help="Chose the button to open the game context menu", options="select, custom1, custom2, custom3, custom4, custom5, custom6", order=frm.orderx++ /> overmenubutton="select"
      </ label=frm.preliner + "Utility menu button" + frm.postliner, help="Chose the button to open the utility menu", options="disabled, up, custom1, custom2, custom3, custom4, custom5, custom6", order=frm.orderx++ /> utilitymenubutton="up"
	   </ label=frm.preliner + "Switch thumbnail mode button" + frm.postliner, help="Chose the button to use to switch from snapshot mode to box art mode", options="none, custom1, custom2, custom3, custom4, custom5, custom6", order=frm.orderx++ /> switchmodebutton="custom3"
   	</ label=frm.preliner + "Rows in horizontal" + frm.postliner, help = "Number of rows to use in 'horizontal' mode", options="1-Small, 1, 2, 3", order = frm.orderx++ /> horizontalrows = "2"
		</ label=frm.preliner + "Rows in vertical" + frm.postliner, help = "Number of rows to use in 'vertical' mode", options="1, 2, 3", order = frm.orderx++ /> verticalrows = "3"
		</ label=frm.preliner + "Clean layout" + frm.postliner, help = "Reduce game data shown on screen", options="Yes, No", order = frm.orderx++ /> cleanlayout = "No"
		</ label=frm.preliner + "Display System Name" + frm.postliner, help = "Shows the System name under the game title", options="Yes, No", order = frm.orderx++ /> showsysname = "Yes"		
		</ label=frm.preliner + "Scrollbar style" + frm.postliner, help = "Select how the scrollbar should look", options="Timeline, Scrollbar, LabelList", order = frm.orderx++ /> scrollertype = "Timeline"
		</ label=frm.preliner + "Screen rotation" + frm.postliner, help = "Rotate screen", options="None, Left, Right, Flip", order = frm.orderx++ /> baserotation = "None"
      </ label=frm.preliner + "Low resolution" + frm.postliner, help = "Optimize theme for low resolution screens, 1 row layout forced, increased font size and cleaner layout", options="Yes, No", order = frm.orderx++ /> lowres = "No"
	</ label= frm.postliner, help=" ", options = " ", order=frm.orderx++ /> paramxx1 = " "

	</ label=frm.prelinerh + "DISPLAYS MENU MODE" + frm.postliner, help=" ", options =" ", order=frm.orderx++ /> paramx11 = " "
		</ label=frm.preliner + "Displays Rows in horizontal" + frm.postliner, help = "Number of rows to use in 'horizontal' Displyas Menu mode", options="1-Small, 1, 2, 3", order = frm.orderx++ /> dmhorizontalrows = "2"
		</ label=frm.preliner + "Displays Rows in vertical" + frm.postliner, help = "Number of rows to use in 'vertical' Displyas Menu mode", options="1, 2, 3", order = frm.orderx++ /> dmverticalrows = "3"
		</ label=frm.preliner + "Generate missing display name art" + frm.postliner, help="If no display title is present, the layout can generate it", options="Yes, No", order=frm.orderx++ /> dmmissingwheel = "Yes"
   </ label= frm.postliner, help=" ", options = " ", order=frm.orderx++ /> paramxx11 = " "

	</ label=frm.prelinerh + "PERFORMANCE & FX" + frm.postliner, help=" ", options =" ", order=frm.orderx++ /> paramx10 = " "
     	</ label=frm.preliner + "Low Spec mode" + frm.postliner, help="Reduce most visual effects to boost speed on lower spec systems", options="Yes, No", order=frm.orderx++ /> lowspecmode ="No"    
		</ label=frm.preliner + "Resolution W x H" + frm.postliner, help = "Define a custom resolution for your layout independent of screen resolution. Format is WIDTHxHEIGHT, leave blank for default resolution", order = frm.orderx++ /> customsize = ""
		</ label=frm.preliner + "Smooth shadow" + frm.postliner, help = "Enable smooth shadow under game title and data in the GUI", options="Yes, No", order = frm.orderx++ /> datashadowsmooth = "Yes"
		</ label=frm.preliner + "Frosted glass" + frm.postliner, help = "Enable a frosted glass effect for overlay menus", options="Yes, No", order = frm.orderx++ /> frostedglass = "Yes"
		</ label=frm.preliner + "Glow effect" + frm.postliner, help="Add a glowing halo around the selected game thumbnail", options="Yes, No", order=frm.orderx++ /> snapglow ="Yes"
		</ label=frm.preliner + "Logo smooth shadow" + frm.postliner, help="Enable smooth shadows under game logo", options="Yes, No", order=frm.orderx++ /> logoshadow ="Yes"
		</ label=frm.preliner + "Thumb gradient" + frm.postliner, help="Blurs the artwork behind the game logo so it's more readable", options="Yes, No", order=frm.orderx++ /> snapgradient="Yes"
   </ label= frm.postliner, help=" ", options = " ", order=frm.orderx++ /> paramxx10 = " "


	</ label=frm.prelinerh + "THUMBNAILS" + frm.postliner, help=" ", options =" ", order=frm.orderx++ /> paramx2 = " "
		</ label=frm.preliner+"Aspect ratio" + frm.postliner, help="Chose wether you want cropped, square snaps or adaptive snaps depending on game orientation", options ="Adaptive, Square", order = frm.orderx++ /> cropsnaps = "Horizontal-Vertical"
		</ label=frm.preliner+"Video thumbs" + frm.postliner, help="Enable video overlay on snapshot thumbnails", options="Yes, No", order=frm.orderx++ /> thumbvideo ="Yes"
		</ label=frm.preliner+"Video delay multiplier" + frm.postliner, help="Increase video load delay", options="1, 2,3,4,5", order=frm.orderx++ /> thumbvidelay ="1"
		</ label=frm.preliner+"Generate missing title art" + frm.postliner, help="If no game title is present, the layout can generate it", options="Yes, No", order=frm.orderx++ /> missingwheel = "Yes"
		</ label=frm.preliner+"New game indicator" + frm.postliner, help="Games not played are marked with a glyph", options="Yes, No", order=frm.orderx++ /> newgame = "Yes"
		</ label=frm.preliner+"Show tag indicator" + frm.postliner, help="Shows a tag attached to thumbnails that contains any tag", options="Yes, No", order=frm.orderx++ /> tagshow = "Yes"
		</ label=frm.preliner+"Custom tag name" + frm.postliner, help="You can see a tag glyph overlayed to the thumbs, chose the tag name to use", order=frm.orderx++ /> tagname = ""
		</ label=frm.preliner+"Game Boy color correction" + frm.postliner, help="Apply a colorized palette to Game Boy games", options="Classic, Pocket, Light, None", order=frm.orderx++ /> gbgreencolor = "Classic"
   </ label= frm.postliner, help=" ", options = " ", order=frm.orderx++ /> paramxx2 = " "

	</ label=frm.prelinerh + "BACKGROUND" + frm.postliner, help=" ", options =" ", order=frm.orderx++ /> paramx3 = " "
		</ label=frm.preliner+"Overlay color" + frm.postliner, help="Setup theme luminosity overlay, Basic is slightly muted, Dark is darker, Light has a white overlay and dark text, Pop keeps the colors unaltered", options="Basic, Dark, Light, Pop", order=frm.orderx++ /> colortheme="Pop"
		</ label=frm.preliner+"Custom BG image" + frm.postliner, help="Insert custom background art path (use grey.png for blank background, vignette.png for vignette overlay)", order=frm.orderx++ /> bgblurred=""
		</ label=frm.preliner+"Background snap" + frm.postliner, help="Add a faded game snapshot to the background", options="Yes, No", order=frm.orderx++ /> layersnap ="No"
		</ label=frm.preliner+"Animate BG snap" + frm.postliner, help="Animate video on background", options="Yes, No", order=frm.orderx++ /> layervideo ="No"
	</ label= frm.postliner, help=" ", options = " ", order=frm.orderx++ /> paramxx3 = " "

	</ label=frm.prelinerh + "LOGO" + frm.postliner, help=" ", options =" ", order=frm.orderx++ /> paramx4 = " "
		</ label=frm.preliner+"Enable splash logo" + frm.postliner, help="Enable or disable the AF start logo", options="Yes, No",order = frm.orderx++/> splashlogo = "Yes"
		</ label=frm.preliner+"Custom splash logo" + frm.postliner, help="Insert the path to a custom AF splash logo (or keep blank for default logo)", order = frm.orderx++/> splashlogofile = ""
	</ label= frm.postliner, help=" ", options = " ", order=frm.orderx++ /> paramxx4 = " "

	</ label=frm.prelinerh + "ATTRACT MODE" + frm.postliner, help=" ", options =" ", order=frm.orderx++ /> paramx5 = " "
		</ label=frm.preliner+"Enable attract mode" + frm.postliner, help="Enable or disable attract mode at layout startup", options="From start, Inactivity only, Disabled",order = frm.orderx++/> amenable = "Inactivity only"
		</ label=frm.preliner+"Background music" + frm.postliner, help="Path to a music file to play in background", order = frm.orderx++/> amtune = ""		
		</ label=frm.preliner+"Enable game sound" + frm.postliner, help="Enable game sounds during attract mode", options="Yes, No",order = frm.orderx++/> amsound = "Yes"		
      </ label=frm.preliner+"Attract mode timer [s]" + frm.postliner, help="Inactivity timer before attract mode is enabled", order = frm.orderx++/> amtimer = 120
		</ label=frm.preliner+"Game change time [s]" + frm.postliner, help="Time interval between each game change", order = frm.orderx++/> amchangetimer = 10
		</ label=frm.preliner+"Attract message" + frm.postliner, help="Text to show during attract mode", order = frm.orderx++/> ammessage = " - PRESS ANY KEY - "
	</ label= frm.postliner, help=" ", options = " ", order=frm.orderx++ /> paramxx5 = " "

	</ label=frm.prelinerh + "SEARCH" + frm.postliner, help=" ", options =" ", order=frm.orderx++ /> paramx6 = " "
		</ label=frm.preliner+"Search entry method" + frm.postliner, help="Use keyboard or on-screen keys to enter search string", options="Keyboard, Screen keys", order=frm.orderx++ /> searchmeth = "Screen keys"
		</ label=frm.preliner+"Immediate search" + frm.postliner, help="Live update results while searching", options="Yes, No", order=frm.orderx++ /> livesearch = "Yes"
	</ label= frm.postliner, help=" ", options = " ", order=frm.orderx++ /> paramxx6 = " "

	</ label=frm.prelinerh + "HISTORY" + frm.postliner, help=" ", options =" ", order=frm.orderx++ /> paramx7 = " "
		</ label=frm.preliner+"Scanline effect" + frm.postliner, help="Select scanline effect: Scanlines = default scanlines, Aperture = aperture mask, Half Resolution = reduced scanline resolution to avoid moiree, None = no scanline", options = "Scanlines, Half Resolution, Aperture, None", order=frm.orderx++ /> scanlinemode="Aperture"
		</ label=frm.preliner+"LCD effect" + frm.postliner, help="Select LCD effect for handheld games: Matrix = see dot matrix, Half Resolution = see matrix at half resolution, None = no effect", options = "Matrix, Half Resolution, None", order=frm.orderx++ /> lcdmode="Half Resolution"
		</ label=frm.preliner+"Text panel style" + frm.postliner, help="Select the look of the history text panel", options = "White panel, Background", order=frm.orderx++ /> historypanel="White panel"
		</ label=frm.preliner+"Game panel style" + frm.postliner, help="Select the look of the history game panel", options = "Dark, Standard", order=frm.orderx++ /> darkpanel="Standard"
      </ label=frm.preliner+"History.dat" + frm.postliner, help="History.dat location.", order=frm.orderx++ /> dat_path="$HOME/mame/dats/history.dat"
		</ label=frm.preliner+"Index clones" + frm.postliner, help="Set whether entries for clones should be included in the index. Enabling this will make the index significantly larger", order=frm.orderx++, options="Yes, No" /> index_clones="Yes"
		</ label=frm.preliner+"Generate index" + frm.postliner, help="Generate the history.dat index now (this can take some time)", is_function=true, order=frm.orderx++ />generate="generate_index"
	</ label= frm.postliner, help=" ", options = " ", order=frm.orderx++ /> paramxx7 = " "

	</ label=frm.prelinerh + "AUDIO" + frm.postliner, help=" ", options =" ", order=frm.orderx++ /> paramx8 = " "
		</ label = frm.preliner + "Theme sound" + frm.postliner, help = "Enable audio sounds when browsing and moving around the theme", options = "Yes, No", order = frm.orderx++ /> themeaudio = "Yes"
      </ label=frm.preliner+"Audio in videos (thumbs)" + frm.postliner, help="Select wether you want to play audio in videos on thumbs", options="Yes, No", order=frm.orderx++ /> audiovidsnaps="No"
		</ label=frm.preliner+"Audio in videos (history)" + frm.postliner, help="Select wether you want to play audio in videos on history detail page", options="Yes, No", order=frm.orderx++ /> audiovidhistory="No"
	</ label= frm.postliner, help=" ", options = " ", order=frm.orderx++ /> paramxx8 = " "

	</ label=frm.prelinerh + "DEBUG" + frm.postliner, help=" ", options =" ", order=frm.orderx++ /> paramx9 = " "
		</ label = frm.preliner + "FPS counter" + frm.postliner, help = "DEBUG FPS COUNTER", options = "Yes, No", order = frm.orderx++ /> fpson = "No"
	</ label= frm.postliner, help=" ", options = " ", order=frm.orderx++ /> paramxx9 = " "

}

/// Layout start  


local transdata = ["StartLayout", "EndLayout", "ToNewSelection","FromOldSelection","ToGame","FromGame","ToNewList","EndNavigation","ShowOverlay","HideOverlay","NewSelOverlay","ChangedTag"]

local native_resolution = {
   "pc" : [320,200],
   "amiga" : [320,200],
   "atari st": [320,200],
   "msx": [256,192],
   "2600" : [160,192],
   "atari 2600" : [160,192],
   "vcs 2600" : [160,192],
   "atari vcs 2600" : [160,192],
   "nes" : [256,240],
   "nintendo entertainment system" : [256,240],
   "famicom" : [256,240],
   "nintendo famicom" : [256,240],
   "game boy" : [160,144],
   "nintendo game boy" :  [160,144],
   "game boy color" : [160,144],
   "nintendo game boy color" : [160,144],
   "genesis" : [320,224],
   "sega genesis" : [320,224],
   "sega megadrive" : [320,224],
   "megadrive" : [320,224],
   "snes" : [256,224],
   "super nintendo" : [256,224],
   "super nintendo entertainment system" : [256,224],
   "super famicom" : [256,224],
   "nintendo super famicom" : [256,224],
   "game gear" : [160,144],
   "sega game gear" : [160,144],
   "master system" : [256 , 192],
   "sega master system" : [256 , 192],
   "lynx" :[160,102],
   "atari lynx" :[160,102],
   "game boy advance" : [240,160],
   "nintendo game boy advance" : [240,160],
   "neo geo" : [320 , 224],
   "neo geo pocket" :[160,152],
   "turbografx" : [256,224],
   "turbografx-16" : [256,224],
   "pc engine" : [256,224],
   "turboexpress" : [400,270],
   "pc engine gt" : [400,270],
   "nec turbografx-16" : [256,224],
   "nec turbografx" : [256,224],
   "nec pc engine" : [256,224],
   "nec turboexpress" : [400,270],
   "nec pc engine gt" : [400,270]
}

dofile( fe.script_dir + "file_util.nut" )

local my_config = fe.get_config()

local prf = {

   LOWSPECMODE =  (my_config["lowspecmode"] == "Yes"),
   LOGOSHADOW = (my_config["logoshadow"] == "Yes"),

   BOXARTMODE = (my_config["boxartmode"] == "Yes"),

   OVERMENUBUTTON = my_config["overmenubutton"],
   UTILITYMENUBUTTON = my_config["utilitymenubutton"],
   SWITCHMODEBUTTON = my_config["switchmodebutton"],
   HORIZONTALROWS = my_config["horizontalrows"],
   VERTICALROWS = my_config["verticalrows"].tointeger(),
   
   DMHORIZONTALROWS = my_config["dmhorizontalrows"],
   DMVERTICALROWS = my_config["dmverticalrows"].tointeger(),
   SHOWSYSNAME = (my_config["showsysname"] == "Yes"),
   CLEANLAYOUT = (my_config["cleanlayout"] == "Yes"),

   DATASHADOWSMOOTH = (my_config["datashadowsmooth"] == "Yes"),
   BASEROTATION = my_config["baserotation"],
   FROSTEDGLASS = (my_config["frostedglass"] == "Yes"),
   LOWRES = (my_config["lowres"] == "Yes"),
   CUSTOMSIZE = my_config["customsize"],
   SCROLLERTYPE = my_config["scrollertype"],
   STRIPARTICLE = true,

   CROPSNAPS = (my_config["cropsnaps"] == "Square"),
   SNAPGLOW = (my_config["snapglow"] == "Yes"),
   MISSINGWHEEL = (my_config["missingwheel"] == "Yes"),
   DMMISSINGWHEEL = (my_config["dmmissingwheel"] == "Yes"),
   THUMBVIDEO = (my_config["thumbvideo"] == "Yes"),
   THUMBVIDELAY = my_config["thumbvidelay"].tointeger(),
   SNAPGRADIENT = (my_config["snapgradient"] == "Yes"),
   NEWGAME = (my_config["newgame"] == "Yes"),
   TAGSHOW = (my_config["tagshow"] == "Yes"),
   TAGNAME =  my_config["tagname"],
   GBGREENCOLOR = my_config["gbgreencolor"],
   GBGREENON = true,

   COLORTHEME = my_config["colortheme"],
   BGBLURRED = my_config["bgblurred"],
   LAYERSNAP = (my_config["layersnap"] == "Yes"),
   LAYERVIDEO = (my_config["layervideo"] == "Yes"),

   SPLASHON = (my_config["splashlogo"] == "Yes"),
   SPLASHLOGOFILE = ( my_config["splashlogofile"] == "" ? "aflogow3.png" : my_config["splashlogofile"]),

   AMENABLE = (my_config["amenable"] != "Disabled"),
   AMSTART = (my_config["amenable"] == "From start"),
   AMTUNE = my_config["amtune"],
   AMSOUND = (my_config["amsound"] == "Yes"),
   AMTIMER = my_config["amtimer"],
   AMCHANGETIMER = my_config["amchangetimer"],
   AMMESSAGE = my_config["ammessage"],

   KEYBOARD = (my_config["searchmeth"] == "Keyboard"),
   LIVESEARCH = (my_config["livesearch"] == "Yes"),

   SCANLINEMODE = my_config["scanlinemode"],
   HISTORYPANEL = (my_config["historypanel"] == "White panel" ),
   DARKPANEL = ( my_config["darkpanel"] == "Dark" ),

   THEMEAUDIO = (my_config["themeaudio"] == "Yes"),
   AUDIOVIDSNAPS = (my_config["audiovidsnaps"] == "Yes"),
   AUDIOVIDHISTORY = (my_config["audiovidhistory"] == "Yes"),

   FPSON = (my_config["fpson"] == "Yes"),

   DISPLAYLISTON = false,
   DISPLAYMENUON = null,

   LCDMODE = my_config["lcdmode"],

   SLIMLINE = false
}

if ( (prf.OVERMENUBUTTON == prf.UTILITYMENUBUTTON) || (prf.OVERMENUBUTTON == prf.SWITCHMODEBUTTON) || (prf.UTILITYMENUBUTTON == prf.SWITCHMODEBUTTON) ) fe.overlay.splash_message ("WARNING: Conflict in Arcadeflow button assignment")


try {prf.AMTIMER = prf.AMTIMER.tointeger()}
catch (err) {prf.AMTIMER = 120}

try {prf.AMCHANGETIMER = prf.AMCHANGETIMER.tointeger()}
catch (err) {prf.AMCHANGETIMER = 10}

if (prf.BASEROTATION == "None") fe.layout.base_rotation = RotateScreen.None
else if (prf.BASEROTATION == "Left") fe.layout.base_rotation = RotateScreen.Left
else if (prf.BASEROTATION == "Right") fe.layout.base_rotation = RotateScreen.Right
else if (prf.BASEROTATION == "Flip") fe.layout.base_rotation = RotateScreen.Flip

local DISPLAYTABLE = {}
try{
   DISPLAYTABLE = fe.nv["AF_Display_Type"]
}
catch (err) {}

local regsys = {
   LCD = regexp(@"([Pp][Cc]\s*[Ee]ngine\s*[Gg][Tt])|([Vv]ita)|([Dd][Ss])|(3[Dd][Ss])|(PSP\s*Go)|([Gg]ame\s*[Bb]oy)|([Gg]ame\s*[Gg]ear)|([Ll]ynx)|([Tt]urbo\s*[Ee]xpress)|([Gg]amate)|([Ss]upervision)|([Nn]omad)|([Nn]eo\s*[Gg]eo\s*[Pp]ocket)|([Ww]onder\s*[Ss]wan)|([Pp]lay\s*[Ss]tation\s*[Pp]ortable)")
   MONO = regexp(@"([Gg]ame\s*[Bb]oy$)|([Gg]ame\s*[Bb]oy\s*[Pp]ocket$)")
}

function islcd (offset,regexpress){
   local name = null
   local output = null
   if ( (fe.list.size > 0)){
      name = split(fe.game_info( Info.System,offset ),";")
      if (name == "") return false
      try { output = (regexpress.search(name[0]) != null)}
      catch (err) {return false}
      return output
   }
   return false
}

// Displays Menu detection 
prf.DISPLAYMENUON = (fe.list.display_index == -1)
local displaystore = fe.list.display_index

if (prf.DISPLAYMENUON) {
   prf.CROPSNAPS = true
   prf.OVERMENUBUTTON = ""
   prf.SCROLLERTYPE = "Scrollbar"
   prf.THUMBVIDEO = false
   prf.LAYERSNAP = false
   prf.MISSINGWHEEL = prf.DMMISSINGWHEEL
}

try {
   prf.BOXARTMODE = ( (DISPLAYTABLE[fe.displays[fe.list.display_index].name] == "BOXES") ? true : false )
}
catch (err){}

if (prf.LOWSPECMODE){
   prf.FROSTEDGLASS = false
   prf.DATASHADOWSMOOTH = false
   prf.LOGOSHADOW = false
   prf.SNAPGRADIENT = false
   prf.SNAPGLOW = false
}

// cleanup frosted glass screen grabs
local dir0 = {
   dir = DirectoryListing( FeConfigDirectory )
   fpos01 = null
   fpos02 = null
}

// workaround when no screenshots are present in the folder
if (file_exist(FeConfigDirectory+"screen.png") == false){
	fe.signal ("screenshot")
}

foreach ( f in dir0.dir.results ){
	dir0.fpos01 = f.find(".png")
	dir0.fpos02 = f.find("frostgrab")
	if ((dir0.fpos01 != null) && (dir0.fpos02 != null)){
		remove(f)
	}
}

// Background and data crossfade stack

local bgvidsurf = null

local bgs = {
   stacksize = (prf.LOWSPECMODE ? 3 : 5)
   bgpic_array = []
   bgvid_array = []
   alphapos = []
   bg_lcd = []
   bg_mono = []
}

local dat = {
   stacksize = (prf.LOWSPECMODE ? 3 : 5)
   var_array = []
   cat_array = []
   but_array = []
   ctl_array = []
   ply_array = []
   mainctg_array = []
   manufacturer_array = []
   manufacturername_array = []
   gamename_array = []
   gamesubname_array = []
   gameyear_array = []
   alphapos = []
}

// Initialize variables
local var = 0

// Fade data: [0 - FADE COUNTER, 1 - FADE VALUE, 2 - FADE STARTER, 3 - FADE INCREASER, 4 - FADE EASER]
// FADE COUNTER counts from 0 to 1 (if FADE INCREASER > 0) or from 1 to 0 (FADE INCREASER < 0) linearly
// FADE VALUE is a fade value calculated from FADE COUNTER based on FADE EASER: 0.0 linear, n.0 ease start, -n.0 ease stop
// FADE STARTER is the counter value at which the fade is when changing fade, 
// it should be equal to FADE VALUE and FADE COUNTER when initializing the variable, 
// is used for incremental non-linear fading and shouldn't be touched if not by startfade function

local flowT = {
   overmenu = [0.0,0.0,0.0,0.0,0.0]
   history = [0.0,0.0,0.0,0.0,0.0]
   histtext = [0.0,0.0,0.0,0.0,0.0]
   data = [0.0,0.0,0.0,0.0,0.0]
   logo = [1.0,1.0,1.0,0.0,0.0]
   fg = [1.0,1.0,1.0,0.0,0.0]
   attract = [1.0,1.0,1.0,0.0,0.0]
   gametoblack = [0.0,0.0,0.0,0.0,0.0]
   blacker = [1.0,1.0,1.0,0.0,0.0]
   historydata = [0.0,0.0,0.0,0.0,0.0]
   historyscroll = [0.0,0.0,0.0,0.0,0.0]
   historyblack = [0.0,0.0,0.0,0.0,0.0]
   frostfade = [1.0,1.0,1.0,0.0,0.0,0.0]
}

local scrollreset = false

local noshader = fe.add_shader( Shader.Empty )

// Search parameters
local search_base_rule = "Title"
local backs = {
   index = -1
   corrector = -1
}

local tags = {
   menu = false
   decor = false
   decortr = false
}

local column ={
   stop = 0
   start = 0
   offset = 0
}

local squarizer = true

// Apply color theme
local themeT = {
   themeoverlaycolor = 255
   themeoverlayalpha = 80
   themetextcolor = 255
   themehistorytextcolor = 90
   themeshadow = 50
   listboxbg = 200
   listboxalpha = 15
}

local satin = {
   rate = 0.9
   vid = 50
}

if (prf.COLORTHEME == "Basic"){
	themeT.themeoverlaycolor = 255
	themeT.themeoverlayalpha = 80
	themeT.themetextcolor = 255
	themeT.themehistorytextcolor = 90
	themeT.themeshadow = 50
   themeT.listboxbg = 200
   themeT.listboxalpha = 15
}
if (prf.COLORTHEME == "Dark"){
	themeT.themeoverlaycolor = 0
	themeT.themeoverlayalpha = 110*0 + 140
	themeT.themetextcolor = 230
	themeT.themehistorytextcolor = 90
	themeT.themeshadow = 80
   themeT.listboxbg = 200
   themeT.listboxalpha = 15
}
if (prf.COLORTHEME == "Light"){
	themeT.themeoverlaycolor = 255
	themeT.themeoverlayalpha = 190
	themeT.themetextcolor = 90
	themeT.themehistorytextcolor = 90
	themeT.themeshadow = 50
   themeT.listboxbg = 200
   themeT.listboxalpha = 150
}
if (prf.COLORTHEME == "Pop"){
	themeT.themeoverlaycolor = 255
	themeT.themeoverlayalpha = 0
	themeT.themetextcolor = 255
	themeT.themehistorytextcolor = 90
   themeT.themeshadow = 70
   themeT.listboxbg = 200
   themeT.listboxalpha = 15
}

// Math functions

function round(x, y) {
	return (x.tofloat()/y+(x>0?0.5:-0.5)).tointeger()*y
}

function max(x,y){
   return (x > y ? x : y)
}

function min(x,y){
   return (x < y ? x : y)
}

function absf (n) {
   return (n > 0 ? n : -n)
}

function hsl2rgb (H,S,L){
   local C = (1.0 - absf(2.0 * L - 1.0)) * S
   local X = C * (1.0 - absf( ((H*1.0/60.0) % 2 ) - 1.0 ))
   local m = L - C/2.0
   local R1 = null
   local G1 = null
   local B1 = null

   if      ((H >= 0)   && (H < 60))  {R1 = C ; G1 = X ; B1 = 0}
   else if ((H >= 60)  && (H < 120)) {R1 = X ; G1 = C ; B1 = 0}
   else if ((H >= 120) && (H < 180)) {R1 = 0 ; G1 = C ; B1 = X}
   else if ((H >= 180) && (H < 240)) {R1 = 0 ; G1 = X ; B1 = C}
   else if ((H >= 240) && (H < 300)) {R1 = X ; G1 = 0 ; B1 = C}
   else if ((H >= 300) && (H < 360)) {R1 = C ; G1 = 0 ; B1 = X}
   
   local OUT ={
      R = (R1 + m) 
      G = (G1 + m)   
      B = (B1 + m) 
   }
   return (OUT)
}

// UI sounds
local snd = {
   ticksound = fe.add_sound("mouse3.mp3")
   wooshsound = fe.add_sound("woosh4.mp3")
   attracttune = fe.add_sound(prf.AMTUNE)
}

// parameters for slowing down key repeat on left-right scrolling
local count = {
   right = 0
   left = 0
   move = 3
   forceleft = false
   forceright = false
}

local globalposnew = 0
local	surfacePos = 0

// GAME BOY green tints in HSL format (H = 0 360, SL = 0 1)

local rgb = {
   a = hsl2rgb(150,0.5,0.2)
   b = hsl2rgb(70,0.50,0.6)
}

if (prf.GBGREENCOLOR == "Pocket"){
   rgb.a = hsl2rgb(90,0.05,0.10)
   rgb.b = hsl2rgb(66,0.26,0.7)
}

if (prf.GBGREENCOLOR == "Light"){
rgb.a = hsl2rgb(160,0.9,0.15)
rgb.b = hsl2rgb(160,0.7,0.5)
}

if (prf.GBGREENCOLOR == "None") prf.GBGREENON = false

// Horizontal rows definition
if (prf.DISPLAYMENUON) {
   if (prf.DMHORIZONTALROWS == "1-Small"){
      prf.DMHORIZONTALROWS = 1
      prf.SLIMLINE = true
   }
   else {
      prf.DMHORIZONTALROWS = prf.DMHORIZONTALROWS.tointeger()
      prf.SLIMLINE = false      
   }
}
else {
   if (prf.HORIZONTALROWS == "1-Small"){
      prf.HORIZONTALROWS = 1
      prf.SLIMLINE = true
   }
   else {
      prf.HORIZONTALROWS = prf.HORIZONTALROWS.tointeger()
      prf.SLIMLINE = false
   }
}

// layout preferences
local rows = (prf.DISPLAYMENUON ? prf.DMHORIZONTALROWS : prf.HORIZONTALROWS)

local vertical = false

// font definition
local uifonts = {
   gui = "Roboto-Allcaps.ttf"
   general = "Roboto-Bold.ttf"
   condensed = "Roboto-Condensed-Bold.ttf"
   lite = "Roboto-Regular.ttf"
   arcade = "CPMono_Black.otf"
   arcadeborder = "CPMono_BlackBorder2.otf"
}

//screen layout definition
local scr = {
   w = ScreenWidth
   h = ScreenHeight
}

if (prf.CUSTOMSIZE != ""){
	try {
		scr.w = split(prf.CUSTOMSIZE,"xX")[0]
		scr.h = split(prf.CUSTOMSIZE,"xX")[1]
		scr.w = scr.w.tointeger()
		scr.h = scr.h.tointeger()
	}
	catch ( err ) { fe.overlay.splash_message("Wrong syntax in screen resolution");prf.CUSTOMSIZE = "";scr.w = ScreenWidth; scr.h = ScreenHeight }
}

local flw = scr.w
local flh = scr.h

local realrotation = ( fe.layout.base_rotation + fe.layout.toggle_rotation ) % 4
local rotate90 = ((realrotation % 2) != 0)

if (rotate90){
	flw = scr.h
	flh = scr.w
}

if (flh>flw) vertical = true
if (vertical) prf.SLIMLINE = false
if (vertical) rows = (prf.DISPLAYMENUON ? prf.DMVERTICALROWS : prf.VERTICALROWS)

rows = (prf.LOWRES ? 1 : rows)

fe.layout.width = flw
fe.layout.height = flh
fe.layout.preserve_aspect_ratio = true
fe.layout.page_size = rows
fe.layout.font = uifonts.general

local scalerate = (vertical ? flw : flh)/1200.0

local header_h = (prf.LOWRES ? 260*scalerate : 200*scalerate ) // content
local header_h2 = (prf.LOWRES ? 330*scalerate : (((rows == 1) && (!prf.SLIMLINE))? 250*scalerate : 200*scalerate))
local footer_h = (prf.LOWRES ? 150*scalerate : 100*scalerate ) // content
local footer_h2 = (prf.LOWRES ? 150*scalerate : (((rows == 1) && (!prf.SLIMLINE)) ? 150*scalerate : 100*scalerate)) //spacer

// multiplier of padding space (normally 1/6 of thumb area)
local padding_scaler = 1.0/6.0

local height = (flh - header_h2 - footer_h2)/(rows + rows*padding_scaler + padding_scaler)
if ((prf.SLIMLINE) ){
   height = (flh - header_h2 - footer_h2)/(2.0 + 2.0*padding_scaler + padding_scaler)
   footer_h = 1.5*footer_h
}
local width = height

local padding = height * padding_scaler
local widthpadded = width + 2 * padding
local heightpadded = height + 2 * padding

local verticalshift = height*16.0/480.0

//calculate number of columns
local cols = (1 + 2*(floor (( flw/2 + width/2 - padding) / (height + padding))))
// add safeguard tiles
cols += 2

// carrier sizing in general layout
local carrierT = {
	x = -(cols*(height + padding) + padding - flw) * 0.5,
	y = header_h2 + (((prf.SLIMLINE) ) ? height*0.5 : 0 ),
	w = cols*(height + padding) + padding,
	h = rows*height + rows*padding + padding
}

// selector and zooming data
local selectorscale = (rows == 1 ? (vertical ? 1.15 : 1.45) : ((prf.SCROLLERTYPE == "LabelList") ? 1.4 : 1.5) )

local whitemargin = 0.15

local selectorwidth = selectorscale * widthpadded

// correction data for non-centered first tiles
local deltacol = (cols - 3)/2
local centercorrection0 = - deltacol*(width + padding) -(flw - (carrierT.w - 2*(width + padding))) / 2 - padding*(1 + selectorscale*0.5) - width/2 + selectorwidth/2
local centercorrection = 0
local centercorrectionshift = centercorrection0

// transitions speeds
local spdT = {
   scrollspeed = 0.92
   zoomspeed = 0.87
   bgfadespeed = 0.88
   letterspeed = 0.85
   dataspeedin = 0.92
   dataspeedout = 0.88
   displayspeed = 0.9
   displayzoomspeed = 0.92
}

// Video delay parameters to skip fade-in
local vidstarter = 10000
local delayvid = vidstarter - 60*prf.THUMBVIDELAY
local fadevid = delayvid - 20

// Fading letter and scroller sizes
local lettersize = {
   name = 250 * scalerate
   display = 120 * scalerate / 0.711
}

local footermargin = 200 * scalerate
local scrollersize = 2 * floor (20 * scalerate * 0.5) + 1

// Blurred backdrop definition
local bgT = {
	x = 0
	y = (flh - flw) / 2.0
	w = flw
}

// Picture background definition
local bgpicT = {
	x = 0,
	y = 0,
	w = flw,
	h = flh,
	ar = 1
}

if (vertical){
	bgT.x = (flw - flh) / 2
	bgT.y = 0
	bgT.w = flh
}

// parameters for changing scroll jump spacing
local scrolljump = false
local scrollstep = rows
local sortjump = false

// keys definition for on screen keyboard 
local key_names = { "a": "a", "b": "b", "c": "c", "d": "d", "e": "e", "f": "f", "g": "g", "h": "h", "i": "i", "j": "j", "k": "k", "l": "l", "m": "m", "n": "n", "o": "o", "p": "p", "q": "q", "r": "r", "s": "s", "t": "t", "u": "u", "v": "v", "w": "w", "x": "x", "y": "y", "z": "z", "1": "Num1", "2": "Num2", "3": "Num3", "4": "Num4", "5": "Num5", "6": "Num6", "7": "Num7", "8": "Num8", "9": "Num9", "0": "Num0", "<": "Backspace", " ": "Space", "-": "Clear", "~": "Done","_":"Nope" }
local key_rows = ["abcdefghi123", "jklmnopqr456", "stuvwxyz_789", "- <0","~"]
if (vertical) key_rows = ["1234567890","abcdefghij","klmnopqrst","uvwxyz____","- <","~"]
local key_selected = [0,0]
local s_text = ""

// Frosted glass variables
local frg = {
   grabdither = 0
   grabticker = 0
   oldgrabnum = 0
   grabpath = ""
   firstpath = ""
   grabsignal = ""
   immediatesignal = false
   numgrabs = 0
   createdgrabs = []  
}


/// Misc functions  

// Detect if strip article is needed
function detectstriparticle(){
   if ((fe.filters.len() == 0) || ((fe.filters[fe.list.filter_index].sort_by == Info.Title) || (fe.filters[fe.list.filter_index].sort_by == Info.NoSort))){
      for (local i = 0 ; i < fe.list.size; i++){
         if (fe.game_info( Info.Title, i ).find("The") == 0) {
            //testpr(fe.game_info( Info.Title, i-1 ))
            //testpr(fe.game_info( Info.Title, i ))
            local s = fe.game_info( Info.Title, i-1 )
            //testpr (s[0].tochar())
            prf.STRIPARTICLE = !(s[0].tochar() == "T")
            break
         } 
      }
   }
}

// wrap around value witin range 0 - N
function wrap( i, N ) {
   while ( i < 0 ) { i += N }
   while ( i >= N ) { i -= N }
   return i
}

// scrap articles from names
function nameclean (s){
   //testpr("CLEAN") TEST54
   if (s.find("The ") == 0) s = s.slice(4,s.len())
   else if (s.find("Vs. The ") == 0) s = s.slice(8,s.len())
   else if (s.find("Vs. ") == 0) s = s.slice(4,s.len())
   else if (s.find("Vs ") == 0) s = s.slice(3,s.len())
   return s
}

// scale a picture with origin at the center
function picscale (obj,scale){
   obj.width = obj.width * scale
   obj.height = obj.height * scale
   obj.origin_x = obj.width * 0.5
   obj.origin_y = obj.height * 0.5
}

// resize a picture with origin at the center
function picsize (obj,sizex,sizey,offx,offy){
   obj.origin_x = obj.width * 0.5 + offx * obj.width
   obj.origin_y = obj.height * 0.5 + offy * obj.height
   obj.width = sizex
   obj.height = sizey
   obj.origin_x = obj.width * 0.5 + offx * obj.width
   obj.origin_y = obj.height * 0.5 + offy * obj.height
}

function recalculate( str ) {
	if ( str.len() == 0 ) return ""
	str = str.tolower()
	local words = split( str, " " )
	local temp=""
	foreach ( idx, w in words ) {
		//print("searching: " + w )
		//if ( idx > 0 ) temp += " "
		//foreach( c in w )
		//  if ( c != " " ) temp += ( "1234567890".find(c.tochar()) != null ) ? c.tochar() : "[" + c.tochar().toupper() + c.tochar().tolower() + "]"
		if ( temp.len() > 0 )
		temp += " "
		local f = w.slice( 0, 1 )
		temp += ( "1234567890".find(f) != null ) ? "[" + f + "]" + w.slice(1) : "[" + f.toupper() + f.tolower() + "]" + w.slice(1)
	}
	return temp
}

// gets the first letter of the game name, # if it's a number
function gameletter( offset ) {
  // return "X"
   if ((fe.filters.len() > 0) && (fe.list.filter_index < fe.filters.len())){
      if (fe.filters[fe.list.filter_index].sort_by == Info.Year){
         local s = fe.game_info( Info.Year, offset )
         return s
      }
      else if (fe.filters[fe.list.filter_index].sort_by == Info.Manufacturer){
         local s = fe.game_info( Info.Manufacturer, offset )
         if (s == "<unknown>") return "?"
         if (s.find ( "bootleg") != null) return "*"
         if (s != "") return s.slice(0,1)
         else return ""		
      }
      else if (fe.filters[fe.list.filter_index].sort_by == Info.Category){
         local s = fe.game_info( Info.Category, offset )
         if (s == "") return "?"
         s = split( s, "/" )
         return strip(s[0])	
         }
      else {
         local s = fe.game_info( Info.Title, offset )
         if ((s == null) || (s == "")) s = "-"
         //testpr("Z letter")
         if (prf.STRIPARTICLE) s = nameclean (s)

         local s2 ="?"
         if (s.len() > 0)  s2 = s.slice(0,1)
         
         if ("'1234567890".find (s2) != null ){
            s2="#"
         }
         return s2
      }
   }
   else {
      local s = fe.game_info( Info.Title, offset )
      if ((s == null) || (s == "")) s = "-"
      //testpr("Z letter")
         if (prf.STRIPARTICLE) s = nameclean (s)
      
      local s2 ="?"
      if (s.len() > 0)  s2 = s.slice(0,1)
      
      if ("'1234567890".find (s2) != null ){
         s2="#"
      }
      return s2
   }
}

function gameyearstring (offset){
   local s0 = fe.game_info( Info.Year, offset )
   if (s0 != ""){
      return ("© " + s0 + "  ")
   }
   else return ("")

}

// gets the first part of the game name
function gamename1 ( offset ) {
	local s = split( fe.game_info( Info.Title, offset ), "(" )	
	if ( s.len() > 0 ) {
		return s[0]
	}
	return ""
}

function gamename2( offset ) {
	local s0 = split(fe.game_info( Info.Title, offset ),"(")
	if (s0.len() > 0) {
      s0 = strip(s0[0])
      local s1 = split( s0, "/" )
	   if ( s1.len() > 1 )  {
	   	return strip(s1[0])+"\n"+strip(s1[1])
	   }
      else {
         return s0
      }
   }
   else
      return ""
}

function wrapme(testo , lim_col, lim_row){

   // INITIALIZE OUTPUT VARIABLE
   local out = {
      text = ""
      rows = 0
      cols = 0
   }
   
   if (testo == "") return (out)

   local col0 = lim_col
   testo = testo.toupper()
   local segmentfind = testo.find (" - ")
   //-testpr("TEXT:"+ testo +"SEGMENT:"+segmentfind)
   if (segmentfind) testo = testo.slice(0,segmentfind)

   testo = split(testo,"(,")

	if (testo.len() > 0) {
      testo = strip(testo[0])
      testo = split( testo, "/" )
      testo = testo [0]
   }
   else
      testo = ""

   // WORD SPLITTING AND LENGTH
   local textarray = split(testo," ")
   local lenarray = textarray.map(function(value){
      return value.len()
   })

   // CALCULATION OF MAX WORD LENGTH
   local maxword = 0
   for (local i = 0 ; i < textarray.len();i++){
      if (textarray[i].len() > maxword) maxword = textarray[i].len()
   }

   // SIMPLE ROWS CASE
   out.rows = textarray.len()
   out.cols = maxword

   for (local i = 0 ; i < lim_row ; i++){
      if (textarray.len() == i+1) {
         out.text = textarray[0]
         for (local ii = 1 ; ii <= i ; ii++){
            out.text = out.text +"\n" + textarray[ii]
         }
         return out
      }
   }

   local coltrick = ceil(testo.len()/(lim_row - 0.2))
   local colsize = (coltrick > col0 ? coltrick : col0)
   
   if (colsize < maxword) colsize = maxword

   local curline = textarray[0]
   local finline = curline
   out.text = ""
   out.rows = 0
   out.cols = 0
   local starter = 1
   
   while ((curline.len() < colsize) && (textarray.len()>1)){
      curline = curline + " " + textarray[starter]
      finline = curline
      starter ++
   }
   if (curline.len() > colsize) colsize = curline.len()

   for (local i = starter ; i < textarray.len() ; i++){
      
      curline = curline + " " + textarray[i]
      
      if (curline.len() > colsize){
         out.text = out.text + finline+"\n"
         out.rows ++
         finline = curline = textarray[i]
         if (finline.len() > colsize){
            out.text = out.text + finline.slice (0,colsize)+"\n"
            out.rows ++
            curline = finline = finline.slice (colsize,finline.len())            
         }
      }
      else {
         finline = curline
      }
   }

   out.cols = colsize
   out.text = out.text + curline
   out.rows ++

   return out
}

function gamemanufacturer( offset ) {
   local s0 = fe.game_info( Info.Manufacturer, offset )
   local s1 = split( s0, "/" )
   if ( s1.len() > 1 )  {
      return strip(s1[0])+"\n"+strip(s1[1])
   }
   else {
      return s0
   }
}

function gameplaycount( offset ) {
	local s = fe.game_info( Info.PlayedCount, offset )
	if ( s.len() > 0 ) {
		return s[0]
	}
	return ""
}

// gets the second part of the game name, after the "("
function gamesubname( offset ) {
   local system = split ( fe.game_info (Info.System,offset) ,";" )
   local system2 = ""
   if ( system.len() > 0 ) {
		if ((system[0] != "CRT") && (system[0] != "LCD") )system2 = system[0]
	}

	local s = split( fe.game_info( Info.Title, offset ), "(" )
	local s2 = ""
   local s3 = ""
	if ( s.len() > 1 ) {
      for (local i = 1 ; i<s.len() ; i++){
         s2 = split(s[i],")")
         s3 = s3 + " " + s2[0]
      }
		return ( ((system2 == "") || (!prf.SHOWSYSNAME)) ?  strip(s3) : system2 + " - " + strip(s3))
	}
	return system2
}

function maincategory( offset ) {
	local sout = ""
	local s0 = fe.game_info( Info.Category, offset )
	if (s0 == "") return "" 
	local s = split( s0, "/" )
	if ( s.len() > 1 ) {
		sout = strip(s[0]).toupper()
	}
	else sout = strip(s0).toupper()

	switch (sout){
      case "ADVENTURE": return "ADVNT"
      case "ROLE-PLAYING": return "RPG" 
      case "ACTION": return "ACTION"
		case "PLATFORM": return "PLATFRM"
		case "MULTIPLAY": return "MULTI"
		case "BALL & PADDLE": return "PADDLE"
		case "FIGHTER":	return "FIGHT"
		case "BEATEMUP":	return "BEAT"
		case "DRIVING":	return "DRIVE"
		case "MAZE":	return "MAZE"
		case "MISC.": return "MISC"
		case "CASINO": return "CASINO"
		case "SHOOTER": return "SHOOT"
		case "SHOOTEMUP": return "SHOOT"
		case "PUZZLE": return "PUZZLE"
		case "SPORTS": return "SPORT"
		case "WHAC-A-MOLE": return "WHAC-M"
		case "MISCELLANEOUS": return "MISC"
      case "FLYING": return "FLYIN"
      case "STRATEGY": return "STRAT"
      case "SIMULATION": return "SIMUL"
      case "GUN": return "GUN"
      case "BOARDGAMES": return "BOARD"
      default: return ""
	}
}

function updatescreen(){
   local path = FeConfigDirectory
   local dir = DirectoryListing( path )
   local picname = ""
   local fpos1 = null
   local fpos2 = null
   local picnum = 0
   local picout = 0

   foreach ( f in dir.results ){
      fpos1 = f.find(".png")
      fpos2 = f.find("screen")
      if ((fpos1 != null) && (fpos2 != null)){
         picnum = f.slice(fpos2+6,fpos1)

         if (picnum == "") picnum = "0"
         picnum = picnum.tointeger()
         if (picout < picnum ) picout = picnum
      }
   }
   picname = FeConfigDirectory + "screen" + picout +".png"
   return picout
}

function getsnap(signalin){
   frostshaders(true)

   frg.oldgrabnum = updatescreen()
   fe.signal("screenshot")
   frg.oldgrabnum ++
   frg.firstpath = FeConfigDirectory + "screen" + frg.oldgrabnum +".png"
   frg.numgrabs ++
   frg.grabpath = FeConfigDirectory + "frostgrab" + frg.numgrabs +".png"
   frg.createdgrabs.push (frg.grabpath)
   frg.grabticker = 1
   frg.grabsignal = signalin

}

detectstriparticle()

/// Background image creation  

local whitepic = fe.add_image("white.png",0,0,1,1)
whitepic.visible = false

local commonground = fe.add_image("grey.png",0,0,flw,flh)
commonground.zorder = -3

local smallsize = 26
local blursize = 1/26.0

local xsurf1 = fe.add_surface(smallsize,smallsize)

local bgpic = null

for (local i = 0; i < bgs.stacksize; i++){
	bgs.alphapos.push (0)
   bgpic = xsurf1.add_image("transparent.png",0,0,smallsize,smallsize)
	bgpic.alpha = 255
	bgpic.trigger = Transition.EndNavigation
   // TEST  VA TOLTO DAVVERO?
	//bgpic.video_flags = Vid.ImagesOnly
	bgpic.smooth = true
   //bgpic.mipmap = 1
	bgpic.preserve_aspect_ratio = false

   local bgs_shader = fe.add_shader (Shader.Fragment, "gbgreen.glsl")
   bgs_shader.set_texture_param("texture")
   bgs_shader.set_param("green",false)   
   bgs_shader.set_param("color1",rgb.a.R,rgb.a.G,rgb.a.B)   
   bgs_shader.set_param("color2",rgb.b.R,rgb.b.G,rgb.b.B)   
   bgpic.shader = bgs_shader

	bgs.bgpic_array.push(bgpic)
   bgs.bg_lcd.push (false)
   bgs.bg_mono.push (false)
}

local xsurf2 = fe.add_surface(smallsize,smallsize)

local bg_surface = fe.add_surface(flw,flh)
bg_surface.alpha=255

local shader_bg = {
   h = fe.add_shader( Shader.Fragment, "gauss_kernsigma_o.glsl" )
   v = fe.add_shader( Shader.Fragment, "gauss_kernsigma_o.glsl" )
}

shader_bg.h.set_texture_param( "texture")
shader_bg.h.set_param("kernelData", 9.0, 2.2)
shader_bg.h.set_param("offsetFactor", blursize, 0.0)
xsurf1.shader = shader_bg.h

shader_bg.v.set_texture_param( "texture")
shader_bg.v.set_param("kernelData", 9.0, 2.2)
shader_bg.v.set_param("offsetFactor", 0.0, blursize)
xsurf2.shader = shader_bg.v

xsurf2.visible = false
xsurf2 = bg_surface.add_clone(xsurf2)
xsurf2.visible = true

xsurf1.visible = false
xsurf1 = xsurf2.add_clone(xsurf1)
xsurf1.visible = true

xsurf2.set_pos(bgT.x,bgT.y,bgT.w,bgT.w)

local pixelgrid = null
local bgvidsize = 90.0

function squarebg(){
	for (local i = 0; i < bgs.stacksize ; i++){
		if ((!prf.BOXARTMODE) || ((prf.BOXARTMODE) && (prf.LAYERSNAP))){

         bgs.bgpic_array[i].shader.set_param("green", (bgs.bg_mono[i] ? prf.GBGREENON : false) )

         if (!(bgs.bg_lcd[i])){
            if (bgs.bgpic_array[i].texture_width >= bgs.bgpic_array[i].texture_height){
			      bgs.bgpic_array[i].subimg_x = bgs.bgpic_array[i].texture_width * 1/8.0
			      bgs.bgpic_array[i].subimg_width = bgs.bgpic_array[i].texture_width * 3/4.0
            }
            else {
               bgs.bgpic_array[i].subimg_y = bgs.bgpic_array[i].texture_height * 1/8.0
               bgs.bgpic_array[i].subimg_height = bgs.bgpic_array[i].texture_height * 3/4.0
            }
            if (prf.LAYERSNAP){
               if (bgs.bgvid_array[i].texture_width >= bgs.bgvid_array[i].texture_height){
                  bgs.bgvid_array[i].subimg_x = bgs.bgvid_array[i].texture_width * 1/8.0
                  bgs.bgvid_array[i].subimg_width = bgs.bgvid_array[i].texture_width * 3/4.0
               }
               else
               {
                  bgs.bgvid_array[i].subimg_y = bgs.bgvid_array[i].texture_height * 1/8.0
                  bgs.bgvid_array[i].subimg_height = bgs.bgvid_array[i].texture_height * 3/4.0
               }
            }
         }
         else {
            if (bgs.bgpic_array[i].texture_width >= bgs.bgpic_array[i].texture_height){
               bgs.bgpic_array[i].subimg_width = bgs.bgpic_array[i].texture_height
               bgs.bgpic_array[i].subimg_x = 0.5*(bgs.bgpic_array[i].texture_width - bgs.bgpic_array[i].subimg_width)
            }
            else {
               bgs.bgpic_array[i].subimg_height = bgs.bgpic_array[i].texture_width
               bgs.bgpic_array[i].subimg_y = 0.5*(bgs.bgpic_array[i].texture_height - bgs.bgpic_array[i].subimg_height)
            }
            if (prf.LAYERSNAP){

               if (bgs.bgvid_array[i].texture_width >= bgs.bgvid_array[i].texture_height){
                  bgs.bgvid_array[i].subimg_width = bgs.bgvid_array[i].texture_height
                  bgs.bgvid_array[i].subimg_x = 0.5*(bgs.bgvid_array[i].texture_width - bgs.bgvid_array[i].subimg_width)
               }
               else{
                  bgs.bgvid_array[i].subimg_height = bgs.bgvid_array[i].texture_width
                  bgs.bgvid_array[i].subimg_y = 0.5*(bgs.bgvid_array[i].texture_height - bgs.bgvid_array[i].subimg_height)
               }
            }
         }
      }
      else {

         bgs.bgpic_array[i].shader.set_param("green",false)

                  // BOXART MODE ON
         if (bgs.bgpic_array[i].texture_width > bgs.bgpic_array[i].texture_height){
			   bgs.bgpic_array[i].subimg_width = bgs.bgpic_array[i].texture_height
			   bgs.bgpic_array[i].subimg_x = 0.5*(bgs.bgpic_array[i].texture_width - bgs.bgpic_array[i].texture_height)
         }
         else if (bgs.bgpic_array[i].texture_width < bgs.bgpic_array[i].texture_height)
         {
			   bgs.bgpic_array[i].subimg_height = bgs.bgpic_array[i].texture_width
			   bgs.bgpic_array[i].subimg_y = 0.5*(bgs.bgpic_array[i].texture_height - bgs.bgpic_array[i].texture_width)
 
         }
      }
      if (prf.DISPLAYMENUON){
         if (bgs.bgpic_array[i].texture_width >= bgs.bgpic_array[i].texture_height){
			   bgs.bgpic_array[i].subimg_x = 0.5*(bgs.bgpic_array[i].texture_width - bgs.bgpic_array[i].texture_height)
			   bgs.bgpic_array[i].subimg_width = bgs.bgpic_array[i].texture_height
		   }
		   else
		   {
			   bgs.bgpic_array[i].subimg_y = 0.5*(bgs.bgpic_array[i].texture_height - bgs.bgpic_array[i].texture_width)
			   bgs.bgpic_array[i].subimg_height = bgs.bgpic_array[i].texture_width
		   }
      }
	}
}

if (prf.LAYERSNAP){
	bgvidsurf = fe.add_surface(bgvidsize,bgvidsize)

	for (local i = 0; i < bgs.stacksize; i++){
		local bgvid = null

		if (!prf.LAYERVIDEO) {
			bgvid = bgvidsurf.add_clone(bgs.bgpic_array[i])
			//bgvid.video_flags = Vid.ImagesOnly
		}
		else if (i == bgs.stacksize - 1 ){
			bgvid = bgvidsurf.add_artwork("snap",0,0,bgvidsize,bgvidsize)
			bgvid.video_flags = Vid.NoAudio
		}
		else{
			bgvid = bgvidsurf.add_clone(bgs.bgpic_array[i])
//			bgvid.video_flags = Vid.NoAudio // TEST 
         //bgvid.video_flags = Vid.ImagesOnly
			bgvid.visible = false
		}
		
		bgvid.set_pos(0,0,bgvidsize,bgvidsize)
		bgvid.preserve_aspect_ratio = false
		bgvid.trigger = Transition.EndNavigation
		bgvid.smooth = true
		bgs.bgvid_array.push(bgvid)
	}

	bgvidsurf.smooth = false

	bgvidsurf.alpha = satin.vid

	bgvidsurf.set_pos(bgT.x,bgT.y,bgT.w,bgT.w)

	pixelgrid = fe.add_image("grid128x.png",bgT.x,bgT.y,bgT.w,bgT.w*128.0/bgvidsize)
	pixelgrid.alpha = 50

   bgvidsurf.zorder = pixelgrid.zorder = -2
}

local bgpicture = null

if (prf.BGBLURRED != "")	{
	bgpicture = bg_surface.add_image(prf.BGBLURRED,0,0,flw,flh)
	bgpicture.visible = false
	bgpicT.ar = (bgpicture.texture_width*1.0) / bgpicture.texture_height

	if (bgpicT.ar >= flw/(flh*1.0)){
		bgpicT.h = flh
		bgpicT.w = bgpicT.h * bgpicT.ar
		bgpicT.y = 0
		bgpicT.x = - (bgpicT.w - flw)*0.5
	}
	else {
		bgpicT.w = flw
		bgpicT.h = bgpicT.w / bgpicT.ar*1.0
		bgpicT.y = - (bgpicT.h - flh)*0.5
		bgpicT.x = 0
	}
	bgpicture=bg_surface.add_image (prf.BGBLURRED,bgpicT.x,bgpicT.y,bgpicT.w,bgpicT.h)
	bgpicture.visible=true
}

local bgoverlay = bg_surface.add_text("",0,0,flw,flh)
bgoverlay.set_bg_rgb(themeT.themeoverlaycolor,themeT.themeoverlaycolor,themeT.themeoverlaycolor)
bgoverlay.bg_alpha = themeT.themeoverlayalpha

bg_surface.zorder = -3

/// Carrier - variables definition  

local	tilesTable = []
local	snapzTable = []
local	logozTable = []
local	loshzTable = []
local	favezTable = []
local	donezTable = []
local nw_mxTable = []
local tg_mxTable = []
local	sh_hzTable = []
local	sh_vzTable = []
local sh_sqTable = []
local	vidszTable = []
local gradzTable = []
local	vid2zTable = []
local bd_mxTable = []
local glomxTable = []
local txt1zTable = []
local txt2zTable = []
local txshzTable = []

local offseTable = []

local	tilesTablePos = {
   X = []
   Y = []
   Offset = 0
}
local tilesTableZoom = []
local vidszTableFade = []
local vidpos = []
local vidindex = []

local	corrector = 0

local	newfocusindex = 0
local	oldfocusindex = 0

//local	vidpos = 0
local fade = {
   letter = 0
   display = 0
   displayzoom = 0
}

local	searchtext = ""

/// Carrier - constructor  

local tiles = {
   count = cols*rows
   offscreen = (vertical ? 3 * rows : 4 * rows)
   total = null
}
tiles.total = tiles.count + 2*tiles.offscreen

local surfacePosOffset = (tiles.offscreen/rows) * (width+padding)


// scroller definition
local scrolline = fe.add_image ("white.png",footermargin,flh - footer_h*0.5 - 1, flw-2*footermargin,  1 )
//scrolline.alpha = 255
scrolline.set_rgb(themeT.themetextcolor,themeT.themetextcolor,themeT.themetextcolor)

local scrollineglow = fe.add_image ("whitedisc2.png",footermargin, flh - footer_h*0.5 - 10*scalerate -1 ,flw-2*footermargin, 20*scalerate + 1)
scrollineglow.visible = false
scrollineglow.alpha = 200
scrollineglow.set_rgb(themeT.themetextcolor,themeT.themetextcolor,themeT.themetextcolor)

local scroller = fe.add_image ("whitedisc.png",footermargin - scrollersize*0.5,flh-footer_h*0.5-(scrollersize + 1 )*0.5,scrollersize,scrollersize)
scroller.set_rgb(themeT.themetextcolor,themeT.themetextcolor,themeT.themetextcolor)

local scroller2 = fe.add_image ("whitedisc2.png",scroller.x - scrollersize*0.5, scroller.y-scrollersize*0.5,scrollersize*2,scrollersize*2)
scroller2.visible = false
scroller2.alpha = 200
scroller2.set_rgb(themeT.themetextcolor,themeT.themetextcolor,themeT.themetextcolor)

if (prf.SCROLLERTYPE == "LabelList") scroller2.alpha = scrollineglow.alpha = scroller.alpha = scrolline.alpha = 0
local labelstrip = fe.add_image("wbox2.png")
labelstrip.visible = false

local labelsurf = fe.add_surface (flw,flh)


local searchdata = fe.add_text (fe.list.search_rule,0,flh-footer_h*0.5,flw,footer_h*0.5)
searchdata.align = Align.Centre
searchdata.set_rgb( 255, 255, 255)
searchdata.word_wrap = true
searchdata.char_size = 25*scalerate
searchdata.visible = true
searchdata.font = uifonts.gui
searchdata.set_rgb(themeT.themetextcolor,themeT.themetextcolor,themeT.themetextcolor)

local snap_glow = []
local loshz = null
local txshz = null
local txt1z = null
local txt2z = null
local logosurf1 = null
local logosurf2 = null
local shader_lg = null

local gradsurf1 = null
local gradsurf2 = null
local gradz = null
local vidsz = null
local vidgreenshader = null
local shader_gr = null

/// Carrier - tile creation loop  

local logo = {
   w = null
   h = null
   margin = null
   shw = null
   shh = null
   shscale = null
   shcharsize = null

   txtlinespacing = null
   txtcharspacing = null
   txtfont = null
   txtmargin = null
   txtalign = null
}

logo.w = 240.0
logo.h = 120.0
logo.margin = 20.0
logo.shcharsize = 35.0

logo.shw = logo.w + 2 * logo.margin
logo.shh = logo.h + 2 * logo.margin

logo.shscale = 0.35

logo.txtlinespacing = 0.6
logo.txtcharspacing = 0.7
logo.txtfont = uifonts.arcade
logo.txtmargin = 0
logo.txtalign = Align.MiddleCentre
      
for ( local i = 0; i < tiles.total; i++ ) {

   local gradsizer = 8
   local gradscaler = 1

   if (prf.SNAPGRADIENT){
      gradsurf1 = fe.add_surface (gradsizer, gradsizer)

      gradz = gradsurf1.add_image("transparent.png",0,0,gradsizer,gradsizer)
      gradz.preserve_aspect_ratio = false
      //gradz.video_flags = Vid.ImagesOnly

      vidsz = gradsurf1.add_image("transparent.png",0,0,gradsizer,gradsizer)
      vidsz.preserve_aspect_ratio = false
      vidsz.mipmap = 1
      
      vidgreenshader = fe.add_shader (Shader.Fragment, "gbgreen.glsl")
      vidgreenshader.set_texture_param("texture")
      vidgreenshader.set_param("green",false)
      vidgreenshader.set_param("color1",rgb.a.R,rgb.a.G,rgb.a.B)   
      vidgreenshader.set_param("color2",rgb.b.R,rgb.b.G,rgb.b.B)    
      vidsz.shader = vidgreenshader

      //vidsz.visible = false
      if (!prf.AUDIOVIDSNAPS) vidsz.video_flags = Vid.NoAudio

      gradsurf2 = fe.add_surface (gradsizer, gradsizer)

      shader_gr = {
         h = fe.add_shader( Shader.Fragment, "gauss_kernsigma_o.glsl" )
         v = fe.add_shader( Shader.Fragment, "gauss_kernsigma_o.glsl" )
      }
      
      shader_gr.h.set_texture_param( "texture")
      shader_gr.h.set_param("kernelData", 7.0, 2.5)
      shader_gr.h.set_param("offsetFactor", 1.0/gradsizer, 0.0)
      gradsurf1.shader = shader_gr.h

      shader_gr.v.set_texture_param( "texture")
      shader_gr.v.set_param("kernelData", 7.0, 2.5)
      shader_gr.v.set_param("offsetFactor", 0.0, 1.0/gradsizer)
      gradz.shader = shader_gr.v

      gradsurf1.visible = false
      gradsurf1 = gradsurf2.add_clone (gradsurf1)
      gradsurf1.visible = true
         
      gradsurf2.set_pos (gradsizer*gradscaler*i , 0,gradsizer*gradscaler,gradsizer*gradscaler)
      gradsurf2.visible = false
   }
   else {
      gradz = fe.add_image("transparent.png",0,0,gradsizer,gradsizer)
      gradz.preserve_aspect_ratio = false
      //gradz.video_flags = Vid.ImagesOnly

      vidsz = fe.add_image("transparent.png",0,0,gradsizer,gradsizer)
      vidsz.preserve_aspect_ratio = false
      vidsz.mipmap = 1   

      vidgreenshader = fe.add_shader (Shader.Fragment, "gbgreen.glsl")
      vidgreenshader.set_texture_param("texture")
      vidgreenshader.set_param("green",false)
      vidgreenshader.set_param("color1",rgb.a.R,rgb.a.G,rgb.a.B)   
      vidgreenshader.set_param("color2",rgb.b.R,rgb.b.G,rgb.b.B)    
      vidsz.shader = vidgreenshader

      if (!prf.AUDIOVIDSNAPS) vidsz.video_flags = Vid.NoAudio

   }




   if (prf.LOGOSHADOW){
      logosurf2 = fe.add_surface (logo.shw*logo.shscale,logo.shh*logo.shscale)

      loshz = logosurf2.add_image ("transparent.png",logo.margin*logo.shscale,logo.margin*logo.shscale,logo.w*logo.shscale,logo.h*logo.shscale)

      txshz = logosurf2.add_text("...",loshz.x,loshz.y,loshz.width,loshz.height)
      txshz.char_size = logo.shcharsize*logo.shscale
      txshz.word_wrap = true 
      txshz.align = logo.txtalign
      txshz.font = logo.txtfont
      txshz.margin = logo.txtmargin
      txshz.line_spacing = logo.txtlinespacing
      txshz.char_spacing = logo.txtcharspacing
      txshz.set_rgb (0,0,0)
      txshz.alpha = 150
      
      logosurf1 = fe.add_surface (logo.shw*logo.shscale,logo.shh*logo.shscale)

      shader_lg = {
         v = fe.add_shader( Shader.Fragment, "gauss_kernsigma_o.glsl" )
         h = fe.add_shader( Shader.Fragment, "gauss_kernsigma_o.glsl" )
      }
   
      shader_lg.v.set_texture_param( "texture")
      shader_lg.v.set_param("kernelData", 5.0 , 1.75)
      shader_lg.v.set_param("offsetFactor", 0.0000, 1.0/(logo.shh*logo.shscale))
      logosurf2.shader = shader_lg.v

      shader_lg.h.set_texture_param( "texture")
      shader_lg.h.set_param("kernelData", 5.0 , 1.75)
      shader_lg.h.set_param("offsetFactor", 1.0/(logo.shw*logo.shscale), 0.0)
      logosurf1.shader = shader_lg.h


      logosurf2.visible = false
      logosurf2 = logosurf1.add_clone (logosurf2)
      logosurf2.visible = true

      logosurf1.visible = false
   }
   // main tile object
   local obj = fe.add_surface(widthpadded*selectorscale,heightpadded*selectorscale)
   obj.origin_x = obj.width * 0.5   
   obj.origin_y = obj.height * 0.5

   obj.zorder = -2
   
   local sh_hz = obj.add_image ("sh_h_7.png",0,0,widthpadded*selectorscale,heightpadded*selectorscale)
   local sh_vz = obj.add_image ("sh_v_7.png",0,0,widthpadded*selectorscale,heightpadded*selectorscale)
   local sh_sq = obj.add_image ("sh_sq_7b.png",0,0,widthpadded*selectorscale,heightpadded*selectorscale)
   sh_hz.alpha = sh_vz.alpha = sh_sq.alpha = 230
   
   if (prf.CROPSNAPS) {
      sh_hz.visible = sh_vz.visible = false
   }
   else{
      sh_sq.visible = false
   }

   local glomx = obj.add_image ("glowx5d.png",0,-selectorscale*verticalshift,widthpadded*selectorscale,selectorscale*heightpadded)
   glomx.alpha = 0

   if (prf.CROPSNAPS) {
      glomx.file_name = "glow_sq3.png"
      glomx.set_pos (0,-selectorscale*verticalshift,widthpadded*selectorscale,selectorscale*heightpadded) 
   }
   
   local bd_mx = obj.add_image ("white.png",selectorscale*padding*(1.0-whitemargin),selectorscale*(-verticalshift + height/8.0 + padding*(1.0 - whitemargin)),selectorscale*(width + padding*2.0*whitemargin),selectorscale*(height*(3/4.0)+padding*2.0*whitemargin))
   bd_mx.set_rgb(255,255,255)
   bd_mx.alpha = 0
   if (prf.CROPSNAPS) {
      bd_mx.set_pos (selectorscale*padding*(1.0-whitemargin),selectorscale*(-verticalshift + padding*(1.0 - whitemargin)),selectorscale*(width + padding*2.0*whitemargin),selectorscale*(height + padding*2.0*whitemargin))
   }   

   local snapz = obj.add_clone(gradz)

   if(!prf.SNAPGRADIENT) gradz.visible = false

   snapz.preserve_aspect_ratio = false
   // snapz.video_flags = Vid.ImagesOnly
   snapz.set_pos (selectorscale*padding,selectorscale*(padding-verticalshift),selectorscale*width,selectorscale*height)
   
   local snap_avg = null

   if (prf.SNAPGRADIENT){
      snap_avg = fe.add_shader( Shader.Fragment, "powersampler3.glsl" )
      snap_avg.set_texture_param( "texture",snapz)
      snap_avg.set_texture_param( "texture2",gradsurf2)
      snap_avg.set_param ("green",false)
      snap_avg.set_param("color1",rgb.a.R,rgb.a.G,rgb.a.B)   
      snap_avg.set_param("color2",rgb.b.R,rgb.b.G,rgb.b.B)  
   }
   else {
      snap_avg = fe.add_shader (Shader.Fragment, "gbgreen.glsl")
      snap_avg.set_texture_param("texture")
      snap_avg.set_param("green",false)
      snap_avg.set_param("color1",rgb.a.R,rgb.a.G,rgb.a.B)   
      snap_avg.set_param("color2",rgb.b.R,rgb.b.G,rgb.b.B)    
   }

   if (prf.SNAPGRADIENT) {
      if (prf.CROPSNAPS) 
         snap_avg.set_param ("limits",0.25,0.75)
      else
         snap_avg.set_param ("limits",0.20,0.75)
   }

   if (prf.SNAPGRADIENT) snap_avg.set_param ("enabled",true)

   snapz.shader = snap_avg
   
   snap_glow.push (null)

   if (prf.SNAPGLOW){
      snap_glow[i] = fe.add_shader( Shader.Fragment, "powerglow3_XP.glsl" )
      snap_glow[i].set_texture_param( "texture", (prf.SNAPGRADIENT ? gradsurf2 : whitepic) )
      snap_glow[i].set_texture_param( "textureglow",glomx)
      snap_glow[i].set_param ("vertical",false)
      snap_glow[i].set_param ("enabled",true)
      if (prf.CROPSNAPS) 
         snap_glow[i].set_param ("cropsnap",true)
      else
         snap_glow[i].set_param ("cropsnap",false)

      glomx.shader = noshader
   }
   else{
      glomx.visible = false
   }

   local vid2z = obj.add_clone(vidsz)
   vid2z.set_pos (selectorscale*padding,selectorscale*(padding-verticalshift),selectorscale*width,selectorscale*height)
   vid2z.preserve_aspect_ratio = true
   //vidsz.visible = false
   if (!prf.SNAPGRADIENT) vidsz.visible = false
  // if (!prf.AUDIOVIDSNAPS) vid2z.video_flags = Vid.NoAudio

   local nw_mx = obj.add_image ("nw_1.png",selectorscale*padding,selectorscale*(padding-verticalshift+height*6.0/8.0),width*selectorscale/8.0,height*selectorscale/8.0)
   nw_mx.visible = false
   nw_mx.alpha = ((prf.NEWGAME == true)? 220 : 0)
   if (prf.CROPSNAPS) {
      nw_mx.set_pos(selectorscale*padding,selectorscale*(padding-verticalshift+height*7.0/8.0),width*selectorscale/8.0,height*selectorscale/8.0)
   }

   local tg_mx = obj.add_image ("tagx.png",0,0,width*selectorscale/6.0,height*selectorscale/6.0)
   tg_mx.visible = false
   tg_mx.alpha = ((prf.TAGSHOW == true)? 255 : 0) 
   if (prf.CROPSNAPS) {
      tg_mx.set_pos(selectorscale*padding,selectorscale*(padding-verticalshift+height*7.0/8.0),width*selectorscale/8.0,height*selectorscale/8.0)
   }

   local donez = obj.add_image("completed.png",selectorscale*padding,selectorscale*(padding-verticalshift),selectorscale*width*0.8,selectorscale*height*0.8)
   donez.visible = false
   donez.preserve_aspect_ratio = false

   local favez = obj.add_image("starred.png",selectorscale*(padding+width/2),selectorscale*(padding+height/2-verticalshift),selectorscale*width/2,selectorscale*height/2)
   favez.visible = false
   favez.preserve_aspect_ratio = false

   if (prf.LOGOSHADOW){
      logosurf1 = obj.add_clone (logosurf1)
      logosurf1.preserve_aspect_ratio = true
      logosurf1.visible = true

      if (!prf.CROPSNAPS)
         logosurf1.set_pos (selectorscale*padding*0.5,selectorscale*(padding*0.4*0.5-verticalshift),selectorscale*(width+padding),selectorscale*(height*0.5+padding))
      else
         logosurf1.set_pos (selectorscale*padding,selectorscale*(padding-verticalshift),selectorscale*width,selectorscale*width*logo.shh/logo.shw)
   }

   if(!prf.LOGOSHADOW) {
      loshz = obj.add_image ("transparent.png",logo.margin*logo.shscale,logo.margin*logo.shscale,logo.w*logo.shscale,logo.h*logo.shscale)

   }

   local logoz = obj.add_clone (loshz)

   logoz.preserve_aspect_ratio = true

	if (!prf.CROPSNAPS)
      logoz.set_pos (selectorscale*padding,selectorscale*(padding*0.6-verticalshift),selectorscale*width,selectorscale*height*0.5)
   else
      logoz.set_pos (selectorscale*(padding+width*logo.margin/logo.shw),selectorscale*(padding-verticalshift+width*(15/20.0)*logo.margin/logo.shw),selectorscale*width*logo.w/logo.shw,selectorscale*height*logo.h/logo.shw)
   
   if (!prf.LOGOSHADOW){
      loshz.set_pos(logoz.x - scalerate*12,logoz.y,logoz.width+24*scalerate,logoz.height+20*scalerate)
      
      txshz = obj.add_text("...",loshz.x,loshz.y,loshz.width,loshz.height)
      txshz.char_size = logo.shcharsize*(88.0/40.0)*scalerate
      txshz.word_wrap = true 
      txshz.align = logo.txtalign
      txshz.font = logo.txtfont
      txshz.margin = logo.txtmargin
      txshz.line_spacing = logo.txtlinespacing
      txshz.char_spacing = logo.txtcharspacing
      txshz.set_rgb (0,0,0)
      txshz.alpha = 150
      }

      txt2z = obj.add_text("...",logoz.x,logoz.y,logoz.width,logoz.height)
      txt2z.char_size = logo.shcharsize*(88.0/40.0)*scalerate
      txt2z.word_wrap = true 
      txt2z.align = logo.txtalign
      txt2z.font = uifonts.arcadeborder
      txt2z.margin = logo.txtmargin
      txt2z.line_spacing = logo.txtlinespacing*0.6/0.6
      txt2z.char_spacing = logo.txtcharspacing
      txt2z.set_rgb (80,80,80)
      txt2z.alpha = 120
      
      txt2z.set_rgb (150,150,150)
      txt2z.alpha = 255

      txt2z.set_rgb (135,135,135)
      txt2z.alpha = 255

      //txshz = obj.add_text("[Title]",selectorscale*(padding +height*(1.0/8.0)),selectorscale*(padding+height*(1.0/8.0)),selectorscale*width*3.0/4.0,selectorscale*height*3.0/4.0)
      txt1z = obj.add_text("...",logoz.x,logoz.y,logoz.width,logoz.height)
      txt1z.char_size = logo.shcharsize*(88.0/40.0)*scalerate
      txt1z.word_wrap = true 
      txt1z.align = logo.txtalign
      txt1z.font = logo.txtfont
      txt1z.margin = logo.txtmargin
      txt1z.line_spacing = logo.txtlinespacing
      txt1z.char_spacing = logo.txtcharspacing
      //txt1z.set_bg_rgb(200,0,0)
      //txt1z.bg_alpha = 50

   loshz.alpha = 150
   loshz.preserve_aspect_ratio = true
   loshz.set_rgb(0,0,0)

   tilesTablePos.X.push((width+padding) * (i/rows) + padding + obj.width*0.5)
   tilesTablePos.Y.push((width+padding) * (i%rows) + padding + carrierT.y + verticalshift + obj.height*0.5)
   tilesTableZoom.push ([0.0,0.0,0.0,0.0,0.0])
   vidszTableFade.push ([0.0,0.0,0.0,0.0,0.0])
   vidpos.push (0)
   vidindex.push (0)

   obj.preserve_aspect_ratio = false
   
   vidsz.alpha = vid2z.alpha = 0

   tilesTable.push (obj)
   snapzTable.push (snapz)
   logozTable.push (logoz)
   loshzTable.push (loshz)
   favezTable.push (favez)
   donezTable.push (donez)
   sh_hzTable.push (sh_hz)
   sh_vzTable.push (sh_vz)
   sh_sqTable.push (sh_sq)
   nw_mxTable.push (nw_mx)
   tg_mxTable.push (tg_mx)
   vidszTable.push (vidsz)
   vid2zTable.push (vid2z)
   gradzTable.push (gradz)
   bd_mxTable.push (bd_mx)
   glomxTable.push (glomx)
   txt1zTable.push (txt1z)
   txt2zTable.push (txt2z)
   txshzTable.push (txshz)
   offseTable.push (0)
}

surfacePos = 0.5

/// Foreground panel surface  
local fg_surface = fe.add_clone(bg_surface)
fg_surface.zorder = 0

//fg_surface.alpha = 120
//fg_surface.set_pos(bgT.x,bgT.y,bgT.w,bgT.w)

/// Data surface construction  

local data_surface = fe.add_surface (flw,flh)

local filterdata = data_surface.add_text ( (prf.CLEANLAYOUT ? "" : (prf.DISPLAYMENUON ? "DISPLAYS": "[FilterName]")),0,flh-footer_h,footermargin,footer_h)
filterdata.align = Align.Centre
filterdata.set_rgb( 255, 255, 255)
filterdata.word_wrap = true
filterdata.char_size = (prf.LOWRES ? 35*scalerate/0.711 : 25*scalerate/0.711)
filterdata.visible = true
filterdata.font = uifonts.gui
filterdata.set_rgb(themeT.themetextcolor,themeT.themetextcolor,themeT.themetextcolor)
//filterdata.set_bg_rgb (200,10,10)

local filternumbers = data_surface.add_text ( (prf.CLEANLAYOUT ? "" :"[ListEntry]\n[ListSize]"),flw-footermargin,flh-footer_h,footermargin,footer_h)
filternumbers.align = Align.Centre
filternumbers.set_rgb( 255, 255, 255)
filternumbers.word_wrap = true
filternumbers.char_size = (prf.LOWRES ? 35*scalerate/0.711 : 25*scalerate/0.711)
filternumbers.visible = true
filternumbers.font = uifonts.gui
filternumbers.set_rgb(themeT.themetextcolor,themeT.themetextcolor,themeT.themetextcolor)

local separatorline = data_surface.add_image("white.png",flw-footermargin+footermargin*0.3, flh-footer_h + footer_h*0.5,footermargin*0.4,1)
separatorline.set_rgb(themeT.themetextcolor,themeT.themetextcolor,themeT.themetextcolor)
separatorline.visible = !((prf.CLEANLAYOUT))

local displayname = data_surface.add_text("[DisplayName]",-flw*0.5,flh*0.5-300*0.5*scalerate/0.711,flw*2.0,300*scalerate/0.711)
displayname.char_size = lettersize.display
displayname.word_wrap = true
displayname.alpha = 0


// fading letter
local letterobj = data_surface.add_text("[!gameletter]",0,carrierT.y,flw,carrierT.h)
letterobj.alpha = 0
letterobj.char_size = lettersize.name
letterobj.font = uifonts.gui
letterobj.set_rgb(themeT.themetextcolor,themeT.themetextcolor,themeT.themetextcolor)
letterobj.margin = 0
letterobj.align = Align.MiddleCentre
if (prf.DISPLAYMENUON) letterobj.visible = false

local blsize = {
   mini = 45 * scalerate,
   catp = 110 * scalerate,
   subt = 35 * scalerate,
   posy = 137 * scalerate,
   manu = 145 * scalerate,
   dath = 25 * scalerate

}

if (prf.LOWRES) {
   blsize = {
      mini = 60 * scalerate,
      catp = 150 * scalerate,
      subt = 45 * scalerate,
      posy = 180 * scalerate,
      manu = 150 * scalerate,
      dath = 40 * scalerate
   }
}

// category image
local game_catpicT = {
	x = 30 * scalerate,
	y = 20 * scalerate,
	w = blsize.catp,
	h = blsize.catp
}

// players image, controller image, button image 
local game_plypicT = {
	x = blsize.catp + 2.0 * game_catpicT.x,
	y = blsize.posy,
	w = blsize.mini,
	h = blsize.mini
}

local game_ctlpicT = {
	x = game_plypicT.x + (blsize.mini + 10 * scalerate),
	y = game_plypicT.y,
	w = blsize.mini,
	h = blsize.mini
}

local game_butpicT = {
	x = game_plypicT.x + 2 * (blsize.mini + 10 * scalerate),
	y = game_plypicT.y,
	w = blsize.mini * 1.25,
	h = blsize.mini
}

// main game category
local game_maincatT = {
	x = 20 * scalerate,
	y = header_h - 20 * scalerate - blsize.subt,
	w = game_plypicT.x - 2 * 20 * scalerate,
	h = blsize.subt
}

// right side: manufacturer and year 
local game_manufacturerpicT = {
	x = flw - 2 * blsize.manu - 30 * scalerate,
	y = (prf.LOWRES ? 20*scalerate : 10 * scalerate),
	w = 2 * blsize.manu,
	h = blsize.manu
}
local game_yearT = {
	x = game_manufacturerpicT.x,
	y = header_h - 20 * scalerate - blsize.dath,
	w = game_manufacturerpicT.w,
	h = blsize.dath
}

// game main name and subname
local game_mainnameT = {
	x = game_plypicT.x,
	y = game_catpicT.y,
	w = flw - game_plypicT.x - game_manufacturerpicT.w - 30*scalerate - 5 * scalerate,
	h = game_catpicT.h
}

local game_subnameT = {
	x = game_butpicT.x + game_butpicT.w + 15 * scalerate,
	y = game_maincatT.y,
	w = flw - game_butpicT.x - game_butpicT.w - 15 *scalerate - game_manufacturerpicT.w - 30*scalerate - 5 * scalerate,
	h = blsize.subt
}

local bwtoalpha = fe.add_shader( Shader.Fragment, "bwtoalpha.glsl" )
bwtoalpha.set_texture_param( "texture")

local txtoalpha = fe.add_shader( Shader.Fragment, "txtoalpha.glsl" )
txtoalpha.set_texture_param( "texture")

for (local i = 0; i < dat.stacksize; i++){

	local game_catpic = data_surface.add_image("white.png",game_catpicT.x, game_catpicT.y, game_catpicT.w, game_catpicT.h)
   if (prf.DISPLAYMENUON) game_catpic.file_name = "category_images/sprite_4.png"
	game_catpic.smooth = false
	game_catpic.preserve_aspect_ratio = true
	game_catpic.set_rgb(themeT.themetextcolor,themeT.themetextcolor,themeT.themetextcolor)
	game_catpic.shader = bwtoalpha
	//game_catpic.fix_masked_image()

	local game_butpic = data_surface.add_image("white.png",game_butpicT.x, game_butpicT.y, game_butpicT.w, game_butpicT.h)
	game_butpic.smooth = true
	game_butpic.preserve_aspect_ratio = true
	game_butpic.set_rgb(themeT.themetextcolor,themeT.themetextcolor,themeT.themetextcolor)
	game_butpic.shader = bwtoalpha
	// game_catpic.mipmap = 1
	
	local game_plypic = data_surface.add_image("white.png",game_plypicT.x, game_plypicT.y, game_plypicT.w, game_plypicT.h)
	game_plypic.smooth = true
	game_plypic.preserve_aspect_ratio = true
	game_plypic.set_rgb(themeT.themetextcolor,themeT.themetextcolor,themeT.themetextcolor)
	game_plypic.shader = bwtoalpha
	// game_plypic.mipmap = 1

	local game_ctlpic = data_surface.add_image("white.png",game_ctlpicT.x, game_ctlpicT.y, game_ctlpicT.w, game_ctlpicT.h)
	game_ctlpic.smooth = true
	game_ctlpic.preserve_aspect_ratio = true
	game_ctlpic.set_rgb(themeT.themetextcolor,themeT.themetextcolor,themeT.themetextcolor)
	game_ctlpic.shader = bwtoalpha
	// game_ctlpic.mipmap = 1

	local game_maincat = data_surface.add_text("[!maincategory]",game_maincatT.x,game_maincatT.y,game_maincatT.w,game_maincatT.h)
	game_maincat.align = Align.MiddleCentre
	game_maincat.word_wrap = true
	game_maincat.set_rgb(themeT.themetextcolor,themeT.themetextcolor,themeT.themetextcolor)
	game_maincat.char_size = (game_maincatT.h - 10*scalerate)/0.711
	game_maincat.font = uifonts.condensed
	game_maincat.alpha = 255
	game_maincat.margin = 0
	game_maincat.line_spacing = 0.8
   //	game_maincat.set_bg_rgb (255,0,0)
	

	local game_mainname = data_surface.add_text( "[!gamename2]", game_mainnameT.x, game_mainnameT.y, game_mainnameT.w, game_mainnameT.h )
   game_mainname.align = Align.MiddleLeft
	game_mainname.word_wrap = true
	game_mainname.set_rgb(themeT.themetextcolor,themeT.themetextcolor,themeT.themetextcolor)
	game_mainname.char_size = (game_mainnameT.h - 10*scalerate)*0.5/0.711
	game_mainname.line_spacing = 0.670000068
	game_mainname.margin = 0
	game_mainname.font = uifonts.gui
	game_mainname.alpha = 255
	// game_mainname.set_bg_rgb(200,0,0)
	game_mainname.visible = true

	local game_subname = data_surface.add_text( "[!gamesubname]", (prf.CLEANLAYOUT ? game_mainnameT.x : game_subnameT.x), game_subnameT.y, game_subnameT.w, game_subnameT.h )
	game_subname.align = Align.TopLeft
	game_subname.word_wrap = false
	game_subname.set_rgb(themeT.themetextcolor,themeT.themetextcolor,themeT.themetextcolor)
	game_subname.char_size = game_subnameT.h/0.711
	game_subname.font = uifonts.gui
	game_subname.alpha = 255
	game_subname.margin = 0
   //	game_subname.set_bg_rgb(200,100,0)


	local game_manufacturerpic = data_surface.add_image("white.png",game_manufacturerpicT.x - i*200*0, game_manufacturerpicT.y, game_manufacturerpicT.w, game_manufacturerpicT.h)
	if (prf.DISPLAYMENUON) game_manufacturerpic.file_name = "aflogomini3.png"
   // game_manufacturerpic.mipmap = 1
	game_manufacturerpic.smooth = true
	game_manufacturerpic.preserve_aspect_ratio = false
	game_manufacturerpic.set_rgb(themeT.themetextcolor,themeT.themetextcolor,themeT.themetextcolor)
	game_manufacturerpic.shader = bwtoalpha

	local game_manufacturername = data_surface.add_text("[!gamemanufacturer]",game_manufacturerpicT.x - i*200*0, game_manufacturerpicT.y, game_manufacturerpicT.w, game_manufacturerpicT.h)
   // game_manufacturerpic.mipmap = 1
	game_manufacturername.align = Align.MiddleCentre
	game_manufacturername.set_rgb( 255, 255, 255)
	game_manufacturername.word_wrap = true
	game_manufacturername.char_size = 0.2*game_manufacturerpicT.h/0.711
	game_manufacturername.visible = false
	game_manufacturername.font = uifonts.gui
	game_manufacturername.margin = 0
	game_manufacturername.set_rgb(themeT.themetextcolor,themeT.themetextcolor,themeT.themetextcolor)


	local game_year = data_surface.add_text( "[!gameyearstring]", game_yearT.x, game_yearT.y, game_yearT.w, game_yearT.h)
   if (prf.DISPLAYMENUON) game_year.msg = "v" + AFVERSION
	game_year.align = Align.TopCentre
	game_year.set_rgb( 255, 255, 255)
	game_year.word_wrap = false
	game_year.char_size = game_yearT.h/0.711
	game_year.visible = true
	game_year.font = uifonts.gui
	game_year.margin = 0
	game_year.set_rgb(themeT.themetextcolor,themeT.themetextcolor,themeT.themetextcolor)
   //	game_year.set_bg_rgb(200,000,100)
	
   if (prf.CLEANLAYOUT){
      game_manufacturerpic.visible = game_maincat.visible = game_year.visible = game_manufacturername.visible = game_catpic.visible = game_butpic.visible = game_ctlpic.visible = game_plypic.visible = false
   }
   
	dat.var_array.push(0)
	dat.alphapos.push (1)
	dat.cat_array.push(game_catpic)
	dat.but_array.push (game_butpic)
	dat.ply_array.push (game_plypic)
	dat.ctl_array.push (game_ctlpic)
	dat.mainctg_array.push(game_maincat)
	dat.manufacturer_array.push(game_manufacturerpic)
 	dat.manufacturername_array.push(game_manufacturername)
	dat.gamename_array.push(game_mainname)
	dat.gamesubname_array.push(game_subname)
	dat.gameyear_array.push(game_year)


}

// Creation of data shadow

local sh_scaler = (vertical ? 400.0 / data_surface.width : 400.0 / data_surface.height)

local shader_tx = {
   h = fe.add_shader( Shader.Fragment, "gauss_kernsigma_o.glsl" )
   v = fe.add_shader( Shader.Fragment, "gauss_kernsigma_o.glsl" )
}

shader_tx.v.set_texture_param( "texture")
shader_tx.v.set_param("kernelData",9,3.0)
shader_tx.v.set_param("offsetFactor",0.000,1.0/(flh*sh_scaler))

shader_tx.h.set_texture_param( "texture")
shader_tx.h.set_param("kernelData",9,3.0)
shader_tx.h.set_param("offsetFactor",1.0/(flw*sh_scaler),0.000)

local data_surface_sh = fe.add_surface(data_surface.width * sh_scaler , data_surface.height * sh_scaler)
local data_surface_sh1 = data_surface_sh.add_clone(data_surface)
data_surface_sh1.set_pos (0 , 0 , data_surface.width * sh_scaler , data_surface.height * sh_scaler)

data_surface_sh.set_rgb(0,0,0)
data_surface_sh1.set_rgb(0,0,0)

if (prf.DATASHADOWSMOOTH){
   data_surface_sh.shader = shader_tx.v
   data_surface_sh1.shader = shader_tx.h
}

data_surface_sh.alpha = themeT.themeshadow

data_surface_sh.zorder =-1

data_surface_sh.set_pos(4*scalerate,7*scalerate,data_surface.width,data_surface.height)

/// Frosted glass surface  

local frostpic = {
   size = 96.0 *0+64.0
   w = null
   h = null
}

if (!vertical){
	frostpic.w = frostpic.size
	frostpic.h = frostpic.size * flh/flw
}
else {
	frostpic.w = frostpic.size * flw/flh
	frostpic.h = frostpic.size
}

local displayAR = ScreenWidth*1.0/ScreenHeight
local screenAR = scr.w*1.0/scr.h
local layoutAR = flw*1.0/flh
if (rotate90) displayAR = 1.0/displayAR

local frost_picT = {
	x = null,
	y = null,
	w = null,
	h = null
}

if (displayAR > layoutAR){
	frost_picT.h = frostpic.h
	frost_picT.w = frostpic.h*displayAR
	frost_picT.x = (frostpic.w - frost_picT.w)*0.5
	frost_picT.y = 0
}
else{
	frost_picT.w = frostpic.w
	frost_picT.h = frostpic.w/displayAR
	frost_picT.x = 0
	frost_picT.y = (frostpic.h - frost_picT.h)*0.5
}

local frost = {
   surf1 = null
   surf2 = null
   pic = null
   surface = null
   top = null
   scaler = null
}

local flipshader = null
local shader_fr = null

if (prf.FROSTEDGLASS){
   frost.scaler = frostpic.w*1.0/flw
   
   frost.surface = fe.add_surface(flw*frost.scaler,(flh-header_h-footer_h)*frost.scaler)
	frost.surf1 = frost.surface.add_surface(frostpic.w,frostpic.h)
	frost.pic = frost.surf1.add_image("transparent.png",frost_picT.x,frost_picT.y,frost_picT.w,frost_picT.h)

	flipshader = fe.add_shader( Shader.Vertex, "flipper_v.glsl" )
	// flipshader.set_texture_param( "texture")
	flipshader.set_param("rotation",realrotation)

	shader_fr = {
      v = fe.add_shader( Shader.VertexAndFragment, "flipper_v.glsl","gauss_kernsigma_o.glsl" )
      h = fe.add_shader( Shader.Fragment, "gauss_kernsigma_o.glsl" )
   }
   
	shader_fr.v.set_texture_param( "texture")
	shader_fr.v.set_param("kernelData", 13.0, 2.5)
   shader_fr.v.set_param("rotation",realrotation)
   shader_fr.v.set_param("offsetFactor", rotate90 ? 1.0/frost_picT.h : 0.0, rotate90 ? 0.0 : 1.0/frost_picT.h)
 
	shader_fr.h.set_texture_param( "texture")
	shader_fr.h.set_param("kernelData", 13.0, 2.5)
	shader_fr.h.set_param("offsetFactor", 1.0/frostpic.w, 0.000)

	frost.surf1.set_pos(0,-header_h*frost.scaler,flw*frost.scaler,flh*frost.scaler)

	frost.surface.set_pos(0,header_h,flw,flh-header_h-footer_h)

	frost.surface.alpha = 0
}

function frostshaders (turnon){
		if (turnon){
			frost.top.shader = flipshader
         frost.top.visible = true
			frost.surf1.shader = shader_fr.h
			frost.pic.shader = shader_fr.v
         
		}
		else{
			frost.top.shader = noshader
         frost.top.visible = false
			frost.surf1.shader = noshader
			frost.pic.shader = noshader			
		}
}



/// Controls Overlays (Listbox)  


local overlay ={
   charsize = null
   rowsize = null
   labelsize = null
   labelcharsize = null
   rows = null
}

overlay.charsize = (prf.LOWRES ? floor( 65*scalerate ) : floor( 50*scalerate ))
overlay.rowsize = (prf.LOWRES ? (overlay.charsize*2.5) : (overlay.charsize*3))
overlay.labelsize = (overlay.rowsize * 1)
overlay.labelcharsize = overlay.charsize * 1
overlay.rows = floor((flh-header_h-footer_h - overlay.labelsize)/overlay.rowsize)

if (floor(overlay.rows / 2.0)*2.0 == overlay.rows ) overlay.rows ++

// Overlay area background
local overlay_background = fe.add_text ("", 0 , header_h, flw, flh-header_h-footer_h)
overlay_background.set_bg_rgb(themeT.listboxbg,themeT.listboxbg,themeT.listboxbg)
overlay_background.bg_alpha = themeT.listboxalpha

local overlay_listbox = fe.add_listbox( 0, header_h+overlay.labelsize, flw, flh-header_h-footer_h-overlay.labelsize )
overlay_listbox.rows = overlay.rows
overlay_listbox.char_size = overlay.charsize
overlay_listbox.bg_alpha = 0
overlay_listbox.set_rgb(themeT.themetextcolor-5,themeT.themetextcolor-5,themeT.themetextcolor-5)
overlay_listbox.set_bg_rgb( 0, 0, 0 )
overlay_listbox.set_sel_rgb( 50, 50, 50 )
overlay_listbox.set_selbg_rgb( 250,250,250 )
overlay_listbox.selbg_alpha = 255
overlay_listbox.font = uifonts.gui

local overlay_label = fe.add_text( "dummy", 0, header_h, flw, overlay.labelsize )
overlay_label.char_size = overlay.labelcharsize
overlay_label.set_rgb(themeT.themetextcolor-5,themeT.themetextcolor-5,themeT.themetextcolor-5)
overlay_label.align = Align.Centre
overlay_label.font = uifonts.gui

local shader1 = fe.add_image ("wgradient.png",0,flh-footer_h,flw,50*scalerate)

local shader2 = fe.add_image ("white.png",padding,header_h+overlay.labelsize-2,flw-2*padding,2)

local shader3 = fe.add_image ("wgradient2.png",0,header_h-50*scalerate,flw,50*scalerate)

shader1.alpha = 50
shader2.alpha = 255
shader3.alpha = 50
shader1.set_rgb(0,0,0)
shader3.set_rgb(0,0,0)

overlay_background.visible = overlay_listbox.visible = overlay_label.visible = shader1.visible = shader2.visible = shader3.visible =  false

fe.overlay.set_custom_controls( overlay_label, overlay_listbox )

function overlay_show(){
	if (prf.FROSTEDGLASS) {
		frost.surface.alpha = 255 
      frostshaders(true)
   }
	else {
		fg_surface.alpha = 255*satin.rate
   }

   overlay_background.visible = overlay_listbox.visible = overlay_label.visible = shader1.visible = shader2.visible = shader3.visible =  true
}

function overlay_hide(){
	if (prf.FROSTEDGLASS) {
		frost.surface.alpha = 0
		frostshaders(false) 
	}
	else {
		fg_surface.alpha = 0
   }

   if (prf.FROSTEDGLASS) frg.grabdither = 2 
   overlay_background.visible = overlay_listbox.visible = overlay_label.visible = shader1.visible = shader2.visible = shader3.visible =  false
}




/// Context Menu  

//local overmenuwidth = (vertical ? flw * 0.7 : flh * 0.7)
local overmenuwidth = selectorwidth * 0.9
local overmenu = fe.add_image("overmenu3.png",flw*0.5-overmenuwidth*0.5,flh*0.5-overmenuwidth*0.5,overmenuwidth,overmenuwidth)
overmenu.visible = false
overmenu.alpha = 0

function overmenu_visible(){
	return ((overmenu.visible) && (flowT.overmenu[3] >= 0))
}

function overmenu_show(){
	overmenu.y = flh*0.5*0 + header_h2 + heightpadded*0.5 -overmenuwidth*0.5 - corrector * (heightpadded - padding)
	if (rows == 1 ) overmenu.y = flh*0.5*0 + header_h2 + heightpadded*0.5 - overmenuwidth*0.5
   if (prf.SLIMLINE == true) overmenu.y =  header_h + (flh-header_h-footer_h)*0.5 - overmenuwidth*0.5
	overmenu.x = flw*0.5 - overmenuwidth*0.5 + centercorrection
	if(prf.THEMEAUDIO) snd.wooshsound.playing=true
	overmenu.visible = true
	flowT.overmenu = startfade (flowT.overmenu , 0.095,0.0)
}

function overmenu_hide(strict){
	if(prf.THEMEAUDIO) snd.wooshsound.playing=true
	if(strict) overmenu.visible = false
	flowT.overmenu = startfade (flowT.overmenu , -0.095,-3.0)
}

/// Frosted Image Overlay  

if (prf.FROSTEDGLASS){

   if (displayAR > layoutAR){
      frost.top = fe.add_image("transparent.png",(flh/frostpic.h)*frost_picT.x,0,flw*1.0*displayAR/layoutAR , flh)
      }
   else{
      frost.top = fe.add_image("transparent.png",0,(flw/frostpic.w)*frost_picT.y,flw,flh -2*(flw/frostpic.w)*frost_picT.y)
   }

   frost.top.preserve_aspect_ratio = false
   frost.top.visible = false
}


/// Search Module  

local search_surface = fe.add_surface(flw, flh)
local keys = null
keys = {}
local search_text = null
local key_low = 100

search_surface.preserve_aspect_ratio = true
search_surface.alpha = 255*0

//select( config.keys.selected[0], config.keys.selected[1] )

function search_toggle() {
	search_surface.alpha = ( search_surface.alpha == 0 ) ? 255: 0

	//clear text when shown
	if ( search_visible() ){ 
		if (search_text.msg == "") search_text.msg = search_base_rule + ": "
		search_clear()
	}
	
	if ((search_visible() == false) && (fe.list.search_rule == "")) {
		if (backs.index != -1) {
			fe.list.search_rule == ""
			fe.list.index = backs.index
			//corrector = backs.corrector
			backs.index = -1
		}
	}
	
}

function search_clear()
{
	s_text = ""
	search_text.msg = search_base_rule + ": "
   search_update_rule()
}

//get current visibility
function search_visible() {
	return (search_surface.alpha == 255)
}

function search_select_relative( rel_col, rel_row )
{
	search_select( key_selected[0] + rel_col, key_selected[1] + rel_row )
}

function search_select( col, row )
{
	row = ( row < 0 ) ? key_rows.len() - 1 : ( row > key_rows.len() - 1 ) ? 0 : row
	col = ( col < 0 ) ? key_rows[row].len() - 1 : ( col > key_rows[row].len() - 1 ) ? 0 : col
	local previous = key_rows[key_selected[1]][key_selected[0]].tochar()
	local selected = key_rows[row][col].tochar()

	keys[previous].set_rgb( key_low,key_low,key_low )
	keys[previous].alpha = 255
	keys[selected].set_rgb( 255,255,255 )
	keys[selected].alpha = 255
	key_selected = [ col, row ]
}

function search_type( c )
{
	if ( c == "<" )
		s_text = ( s_text.len() > 0 ) ? s_text.slice( 0, s_text.len() - 1 ) : ""
	else if ( c == "-" )
      search_clear()
	else if ( c == "~" )
	{
		//search_update_rule ()
		//backs.index = -1
		if (!prf.LIVESEARCH) search_update_rule()
		search_toggle()
		return
	}
	else if (c != "_")
		s_text = s_text + c
	search_text.msg = search_base_rule + ": " + s_text 
	if (prf.LIVESEARCH) search_update_rule()
}

function search_update_rule(){
	try
	{
		local rule = search_base_rule + " contains " + recalculate (s_text)
		fe.list.search_rule = ( s_text.len() > 0 ) ? rule : ""
		corrector = (rows == 1 ? -1 : 0)
		if (fe.list.search_rule == "") {
			searchdata.msg = ""
			fe.list.index = backs.index
		}
		else
		searchdata.msg = fe.list.search_rule
		
	} catch ( err ) { print( "Unable to apply filter: " + err ); }
}

function draw_osd() {
	
	//draw the search surface bg
	local bg = search_surface.add_image("kbg2.png", 0, 0, search_surface.width, search_surface.height)
	bg.alpha = 230
	
	//draw the search text object
	local osd_search = {
		x = ( search_surface.width * 0 ) * 1.0,
		y = ( search_surface.height * 0.2 ) * 1.0,
		width = ( search_surface.width * 1 ) * 1.0,
		height = ( search_surface.height * 0.1 ) * 1.0
	}
	
	search_text = search_surface.add_text(s_text, osd_search.x, osd_search.y, osd_search.width, osd_search.height)
	search_text.align = Align.Left
	search_text.font = uifonts.gui
	search_text.set_rgb( 255, 255, 255 )
	search_text.alpha = 255
	search_text.char_size = 80*scalerate
	
	
	//draw the search key objects
	foreach( key,val in key_names ) {
		
		local key_name = (key == "_") ? " " : ( key == "-" ) ? "CLR" : ( key == " " ) ? "SPC" : ( key == "<" ) ? "DEL" : ( key == "~" ) ? "DONE" : key.toupper()
		
		local textkey = search_surface.add_text( key_name, -1, -1, 1, 1 )
		textkey.font = uifonts.gui
		textkey.char_size = 80*scalerate
		
		textkey.set_rgb( key_low,key_low,key_low)
		textkey.alpha = 255
		
		keys[ key.tolower() ] <- textkey
		
	}
	
	
	//set search key positions
	local row_count = 0
	foreach ( row in key_rows )
	{
		local col_count = 0
		local osd = {
			x = ( search_surface.width * 0.1 ) * 1.0,
			y = ( search_surface.height * 0.4 ) * 1.0,
			width = ( search_surface.width * 0.8 ) * 1.0,
			height = ( search_surface.height * 0.5 ) * 1.0
		}
		//local keynumcol = (row == "- <~") ? 4 : 10
		local key_width = ( osd.width / row.len() ) * 1.0
		local key_height = ( osd.height / key_rows.len() ) * 1.0
		foreach ( char in row )
		{
			//local key_image = keys[ iii ]
			local key_image = keys[ char.tochar() ]
			local pos = {
				x = osd.x + ( key_width * col_count ),
				y = osd.y + key_height * row_count,
				w = key_width,
				h = key_height
			}
			key_image.set_pos( pos.x, pos.y, pos.w, pos.h )

			col_count++
		}
		row_count++
	}
}

draw_osd()
search_select (key_selected[0],key_selected[1])


/// History Page  

local hist_direction = 0

local hist_split_h = 0.55

local hist_titleT = {
	x = flw*hist_split_h + 15*scalerate,
	y = 0+15*scalerate,
	w = flw*(1.0 - hist_split_h)-30*scalerate,
	h = flh*0.25-30*scalerate
   transparency = 50
}

local hist_screenT = {
	x = 0,
	y = (flh-flw*hist_split_h)*0.5,
	w = flw*hist_split_h,
	h = flw*hist_split_h
}

hist_screenT.y += hist_screenT.y % 2.0
hist_screenT.w += hist_screenT.w % 2.0
hist_screenT.h += hist_screenT.h % 2.0

if (hist_screenT.h > flh){
	hist_screenT.x = (flw*hist_split_h-flh)*0.5
	hist_screenT.y = 0
	hist_screenT.x += hist_screenT.x % 2.0
	hist_screenT.w = flh
	hist_screenT.w += hist_screenT.w % 2.0
	hist_screenT.h = flh
	hist_screenT.h += hist_screenT.h % 2.0
}

local hist_textT = {
	x = flw*hist_split_h,
	y = flh*0.25,
	w = flw*(1.0-hist_split_h),
	h = flh*0.75
}

if (vertical){
	hist_titleT.x = 0
	hist_titleT.y = flh*hist_split_h
	hist_titleT.w = flw
	hist_titleT.h = flh*(1.0 - hist_split_h)*0.3

	hist_screenT.x = (flw-flh*hist_split_h)*0.5
	hist_screenT.x += hist_screenT.x % 2.0
	hist_screenT.y = 0
	hist_screenT.w = flh*hist_split_h
	hist_screenT.w += hist_screenT.w % 2.0
	hist_screenT.h = flh*hist_split_h
	hist_screenT.h += hist_screenT.h % 2.0

	if (hist_screenT.w > flw){
		hist_screenT.x = 0
		hist_screenT.y = (flh*hist_split_h - flw)*0.5
		hist_screenT.y += hist_screenT.y % 2.0
		hist_screenT.w = flw
		hist_screenT.w += hist_screenT.w % 2.0
		hist_screenT.h = flw
		hist_screenT.h += hist_screenT.h % 2.0
	}

	hist_textT.x = 0
	hist_textT.y = flh*hist_split_h + flh*(1.0 - hist_split_h)*0.3
	hist_textT.w = flw
	hist_textT.h = flh*(1.0 - hist_split_h)*0.7
}

local shadowscale = 0.025

hist_titleT.x = hist_titleT.x+hist_titleT.w*shadowscale
hist_titleT.y = hist_titleT.y+hist_titleT.h*shadowscale
hist_titleT.w = hist_titleT.w*(1-shadowscale*2)
hist_titleT.h = hist_titleT.h*(1-shadowscale*2)


local historypadding = (hist_screenT.w * 0.025)
historypadding += historypadding % 2.0

local hist_curr_rom = ""
local history_surface = fe.add_surface(flw,flh)
 
local hist_bg = history_surface.add_text ("",0,0,history_surface.width,history_surface.height)
hist_bg.set_bg_rgb(0,0,0)
hist_bg.bg_alpha = 1

local hist_white = null

if (prf.HISTORYPANEL){
   if (vertical) {
      hist_white = history_surface.add_image("white.png",0,flh*hist_split_h,hist_textT.w,flh-hist_screenT.h)
   }
   else{
      hist_white = history_surface.add_image("white.png",hist_textT.x,0,hist_textT.w,flh)
   }
   hist_white.alpha = 200
}

local hist_title = history_surface.add_image ("transparent.png",hist_titleT.x,hist_titleT.y,hist_titleT.w,hist_titleT.h)
hist_title.preserve_aspect_ratio = true


local hist_title_top = null
local hist_titletxt_bot = null



if (prf.HISTORYPANEL){
   hist_title_top = history_surface.add_clone (hist_title)
   
   hist_title_top.preserve_aspect_ratio = true

   hist_title.set_pos (hist_titleT.x-hist_titleT.w*shadowscale  ,hist_titleT.y+2*shadowscale*hist_titleT.h,hist_titleT.w*(1+shadowscale*2),hist_titleT.h*(1+shadowscale*2))
   hist_title.set_rgb(0,0,0)
   hist_title.alpha = hist_titleT.transparency

   hist_titletxt_bot = history_surface.add_text("...",hist_title.x, hist_title.y, hist_title.width,hist_title.height)

   hist_titletxt_bot.char_size = 150*scalerate
   hist_titletxt_bot.word_wrap = true
   hist_titletxt_bot.margin = 0
   hist_titletxt_bot.align = Align.MiddleCentre
   hist_titletxt_bot.char_spacing = 0.7

   hist_titletxt_bot.font = uifonts.arcadeborder 
   hist_titletxt_bot.line_spacing = 0.6
   hist_titletxt_bot.set_rgb(0,0,0)
   hist_titletxt_bot.alpha = hist_titleT.transparency

}

local hist_titletxt_bd = history_surface.add_text("...",hist_titleT.x,hist_titleT.y,hist_titleT.w,hist_titleT.h)
local hist_titletxt = history_surface.add_text("...",hist_titleT.x,hist_titleT.y,hist_titleT.w,hist_titleT.h)

hist_titletxt_bd.char_size = hist_titletxt.char_size = 150*scalerate
hist_titletxt_bd.word_wrap = hist_titletxt.word_wrap = true
hist_titletxt_bd.margin = hist_titletxt.margin = 0
hist_titletxt_bd.align = hist_titletxt.align = Align.MiddleCentre
hist_titletxt_bd.char_spacing = hist_titletxt.char_spacing = 0.7

hist_titletxt_bd.font = uifonts.arcadeborder
hist_titletxt_bd.line_spacing = 0.6
hist_titletxt_bd.set_rgb (80,80,80)
hist_titletxt_bd.alpha = 200
hist_titletxt_bd.set_rgb (135,135,135)
hist_titletxt_bd.alpha = 255

hist_titletxt.font = uifonts.arcade 
hist_titletxt.line_spacing = 0.6
//hist_titletxt.set_bg_rgb(200,0,0)
//hist_titletxt.bg_alpha = 255

local histgr = {
   black = null
   g1 = null
   g2 = null
}

if (!vertical){
	histgr.black = history_surface.add_image("black.png",0,0,flw*hist_split_h,flh)
	histgr.g1 = history_surface.add_image("wgradient2.png",0,0,flw*hist_split_h,flh*0.5) 
	histgr.g2 = history_surface.add_image("wgradient.png",0,flh*0.5,flw*hist_split_h,flh*0.5)
}
else{
	histgr.black = history_surface.add_image("black.png",0,0,flw,flh*hist_split_h)
	histgr.g1 = history_surface.add_image("wgradient3.png",0,0,flw*0.5,flh*hist_split_h)
	histgr.g2 = history_surface.add_image("wgradient4.png",flw*0.5,0,flw*0.5,flh*hist_split_h)
}

histgr.black.set_rgb (0,0,0)
histgr.g1.set_rgb (0,0,0)
histgr.g2.set_rgb (0,0,0)

histgr.g1.alpha = histgr.g2.alpha = 150
histgr.black.alpha = prf.DARKPANEL ? 180 : 50

local CRTprf = null

if (prf.SCANLINEMODE == "Scanlines"){
   CRTprf = {
      aperature_type = 0.0
      hardScan = -15.0
      hardPix = -2.0
      maskDark = 0.4
      maskLight = 1.5
      saturation = 1.0
      tint = 0.0
      blackClip = 0.1
      brightMult = 1.4
      distortion = 0.2
      cornersize = 0.05
      cornersmooth = 60
      scanresample = 1.0
   }
}

if (prf.SCANLINEMODE == "Aperture"){
   CRTprf = {
      aperature_type = 3.0
      hardScan = -3.0
      hardPix = -2.0
      maskDark = 0.6
      maskLight = 1.3
      saturation = 1.0
      tint = 0.0
      blackClip = 0.1
      brightMult = 1.1
      distortion = 0.2
      cornersize = 0.05
      cornersmooth = 60
      scanresample = 1.0
   }
}

if (prf.SCANLINEMODE == "Half Resolution"){
   CRTprf = {
      aperature_type = 0.0
      hardScan = -15.0
      hardPix = -4.0
      maskDark = 0.4
      maskLight = 1.5
      saturation = 1.0
      tint = 0.0
      blackClip = 0.1
      brightMult = 1.4
      distortion = 0.2
      cornersize = 0.05
      cornersmooth = 60
      scanresample = 0.5
   }
}

if (prf.SCANLINEMODE == "None"){
   CRTprf = {
      aperature_type = 0.0
      hardScan = -3.0
      hardPix = -2.0
      maskDark = 0.4
      maskLight = 1.5
      saturation = 1.0
      tint = 0.0
      blackClip = 0.1
      brightMult = 1.0
      distortion = 0.2
      cornersize = 0.05
      cornersmooth = 60
      scanresample = 1.0
   }
}

local LCDprf = null

if (prf.LCDMODE == "Matrix"){
   LCDprf = {
      matrix = 1.0
      scaler = 1.0
   }
}
if (prf.LCDMODE == "Half Resolution"){
   LCDprf = {
      matrix = 1.0
      scaler = 0.5
   }
}
if (prf.LCDMODE == "None"){
   LCDprf = {
      matrix = 0.0
      scaler = 1.0
   }
}

local shader_lottes = null;
shader_lottes=fe.add_shader(Shader.VertexAndFragment,"CRTL-geom_vsh.glsl","CRTL-geom_fsh.glsl");
shader_lottes.set_param("aperature_type", CRTprf.aperature_type); // 0.0 = none, 1.0 = TV style, 2.0 = Aperture grille, 3.0 = VGA
shader_lottes.set_param("hardScan", CRTprf.hardScan);   // Hardness of Scanline 0.0 = none -8.0 = soft -16.0 = medium 
shader_lottes.set_param("hardPix", CRTprf.hardPix);     // Hardness of pixels in scanline -2.0 = soft, -4.0 = hard
shader_lottes.set_param("maskDark",CRTprf.maskDark);     // Sets how dark a "dark subpixel" is in the aperture pattern.
shader_lottes.set_param("maskLight", CRTprf.maskLight);    // Sets how dark a "bright subpixel" is in the aperture pattern
shader_lottes.set_param("saturation", CRTprf.saturation);   // 1.0 is normal saturation. Increase as needed.
shader_lottes.set_param("tint", CRTprf.tint);         // 0.0 is 0.0 degrees of Tint. Adjust as needed.
shader_lottes.set_param("blackClip", CRTprf.blackClip);   // Drops the final color value by this amount if GAMMA_CONTRAST_BOOST is defined
shader_lottes.set_param("brightMult", CRTprf.brightMult);   // Multiplies the color values by this amount if GAMMA_CONTRAST_BOOST is defined
shader_lottes.set_param("distortion", CRTprf.distortion);  // 0.0 to 0.2 seems right
shader_lottes.set_param("cornersize", CRTprf.cornersize);  // 0.0 to 0.1
shader_lottes.set_param("cornersmooth", CRTprf.cornersmooth);  // Reduce jagginess of corners
shader_lottes.set_param("vignettebase", 0.3,1.0,2.0);  // base lightness for vignette

shader_lottes.set_texture_param("texture")

local pixelpic = fe.add_image("pixel8.png",0,0)
pixelpic.visible = false
local shader_lcd = null
shader_lcd = fe.add_shader (Shader.Fragment,"lcd.glsl")
shader_lcd.set_texture_param( "texture")
shader_lcd.set_texture_param( "pixel",pixelpic)
shader_lcd.set_param ("pixelsize", 10,10)
shader_lcd.set_param ("matrix", LCDprf.matrix)
shader_lcd.set_param("color1",rgb.a.R,rgb.a.G,rgb.a.B)   
shader_lcd.set_param("color2",rgb.b.R,rgb.b.G,rgb.b.B)  
shader_lcd.set_param ("green", false)

local hist_text_surf = history_surface.add_surface( hist_textT.w, hist_textT.h )
hist_text_surf.set_pos (hist_textT.x, hist_textT.y )

local hist_text = hist_text_surf.add_text( "", 0,0, hist_textT.w, hist_textT.h )
hist_text.char_size = (prf.LOWRES ? 55*scalerate : (40 * scalerate > 8 ? 40*scalerate : 8))
hist_text.align = Align.TopCentre

hist_text.first_line_hint = 3
hist_text.visible = true
if (prf.HISTORYPANEL) {
   hist_text.set_rgb(themeT.themehistorytextcolor,themeT.themehistorytextcolor,themeT.themehistorytextcolor)
   hist_text_surf.set_rgb(themeT.themehistorytextcolor,themeT.themehistorytextcolor,themeT.themehistorytextcolor)
}
else {
   hist_text.set_rgb(themeT.themetextcolor,themeT.themetextcolor,themeT.themetextcolor)
  hist_text_surf.set_rgb(themeT.themetextcolor,themeT.themetextcolor,themeT.themetextcolor)
 
}

local gradshader = fe.add_shader (Shader.Fragment, "blackgrad2.glsl")
gradshader.set_texture_param( "texture")
gradshader.set_param ("limits", 40 * scalerate * 1.7 / hist_textT.h , 40 * scalerate * 5.0 / hist_textT.h)

//hist_text_surf.shader = gradshader
hist_text_surf.shader = noshader

local histglow = {
   w = hist_screenT.w - 2 * historypadding
   x = hist_screenT.x + historypadding
   y = hist_screenT.y + historypadding
}

// shadow parameters
local shadow = {
   radius = histglow.w*0.25
   downsample = 64.0/histglow.w
   enlarge = 0.97
}

// creation of first surface with safeguards area
local shadowsurf1 = fe.add_surface (shadow.downsample * (histglow.w + 2 * shadow.radius), shadow.downsample * (histglow.w + 2 * shadow.radius))

// add a clone of the picture to topmost surface
local hist_glow_pic = shadowsurf1.add_image("transparent.png",(shadow.radius-0.5*histglow.w*(shadow.enlarge - 1.0))*shadow.downsample,(shadow.radius-0.5*histglow.w*(shadow.enlarge - 1.0))*shadow.downsample,histglow.w*shadow.enlarge*shadow.downsample,histglow.w*shadow.enlarge*shadow.downsample)
//hist_glow_pic.mipmap = 1
hist_glow_pic.preserve_aspect_ratio = true

local hist_glow_shader = fe.add_shader(Shader.Fragment, "gbgreen.glsl")
hist_glow_shader.set_texture_param ("texture")
hist_glow_shader.set_param ("green",false)
hist_glow_shader.set_param("color1",rgb.a.R,rgb.a.G,rgb.a.B)   
hist_glow_shader.set_param("color2",rgb.b.R,rgb.b.G,rgb.b.B)  
hist_glow_pic.shader = hist_glow_shader

// creation of second surface
local shadowsurf2 = fe.add_surface (shadowsurf1.width, shadowsurf1.height)

// nesting of surfaces
shadowsurf1.visible = false
shadowsurf1 = shadowsurf2.add_clone(shadowsurf1)
shadowsurf1.visible = true

shadowsurf2.visible = false
shadowsurf2 = history_surface.add_clone(shadowsurf2)
shadowsurf2.visible = true

local blursizeglow = {
   x = 1.0/shadowsurf2.width
   y = 1.0/shadowsurf2.height
}

local kerneldat = {
   size = shadow.downsample * (shadow.radius * 2) + 1
   sigma = shadow.downsample * shadow.radius * 0.3
}

local shadowshader = {
   h = fe.add_shader( Shader.Fragment, "gauss_kernsigma_o_glow.glsl" )
   v = fe.add_shader( Shader.Fragment, "gauss_kernsigma_o_glow.glsl" )
}
shadowshader.h.set_texture_param("texture")
shadowshader.h.set_param("kernelData", kerneldat.size, kerneldat.sigma)
shadowshader.h.set_param("offsetFactor", blursizeglow.x, 0.0)
//shadowsurf1.shader = shadowshader.h
shadowsurf1.shader = noshader

shadowshader.v.set_texture_param("texture")
shadowshader.v.set_param("kernelData", kerneldat.size, kerneldat.sigma)
shadowshader.v.set_param("offsetFactor", 0.0, blursizeglow.y)
//shadowsurf2.shader = shadowshader.v
shadowsurf2.shader = noshader

shadowsurf2.set_pos (histglow.x-shadow.radius,histglow.y-shadow.radius, histglow.w + 2 * shadow.radius , histglow.w + 2 * shadow.radius)

//local hist_screen_ar = hist_screenT.w * 1.0 / hist_screenT.h 

local hist_screensurf = history_surface.add_surface (hist_screenT.w-2.0*historypadding,hist_screenT.h-2.0*historypadding)
hist_screensurf.set_pos(hist_screenT.x+historypadding,hist_screenT.y+historypadding)

local hist_screen = hist_screensurf.add_clone(hist_glow_pic) 
hist_screen.set_pos(0,0,hist_screenT.w-2.0*historypadding,hist_screenT.h-2.0*historypadding)
hist_screen.preserve_aspect_ratio = true
if (!prf.AUDIOVIDHISTORY) hist_screen.video_flags = Vid.NoAudio
hist_screen.shader = noshader


history_surface.visible = false
history_surface.alpha = 0

function history_updatesnap(){
	hist_screen.file_name = fe.get_art ("snap")
	hist_screen.shader = ((islcd(0,regsys.LCD)) ? shader_lcd : shader_lottes)
   if (islcd(0,regsys.MONO)) {
      hist_screen.shader.set_param("green",prf.GBGREENON)
      hist_glow_shader.set_param("green",prf.GBGREENON)
   }
   else{
      hist_screen.shader.set_param("green",false)      
      hist_glow_shader.set_param("green",false)
   }

   shadowsurf1.shader = shadowshader.h
   shadowsurf2.shader = shadowshader.v

	hist_screen.width = hist_screensurf.subimg_width;
   hist_screen.height = hist_screensurf.subimg_height;

   local nativeres = null
   
   try{
      nativeres = native_resolution[fe.game_info(Info.System).tolower()]
   }
   catch (err){
      nativeres = [hist_screen.texture_width,hist_screen.texture_height]
   }

   if (!islcd(0,regsys.LCD)){
      hist_screen.smooth = true
      hist_screen.shader.set_param("vert", (nativeres[0] >= nativeres[1] ? 0.0 : 1.0));
      hist_screen.shader.set_param("color_texture_sz", nativeres[0]*CRTprf.scanresample, nativeres[1]*CRTprf.scanresample);
      hist_screen.shader.set_param("color_texture_pow2_sz", nativeres[0]*CRTprf.scanresample, nativeres[1]*CRTprf.scanresample);
   }
   else {
      hist_screen.smooth = false
      hist_screen.shader.set_param("pixelsize", nativeres[0]*LCDprf.scaler,nativeres[1]*LCDprf.scaler )
   }
}

function history_updatetext(){
   hist_title.file_name = fe.get_art ("wheel")
   
   local char_rows = ( ((hist_titleT.w/hist_titleT.h) > 3.0) ? 2 : 3)
   local charfontsize = 1.1*hist_titleT.h/char_rows
   local char_cols = floor (hist_titleT.w / (charfontsize*0.6))

   local hist_logotitle = wrapme( fe.game_info (Info.Title, 0),char_cols,char_rows )

   /*
   local teststrip0 = "OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO".slice (0,char_cols)
   local teststrip = teststrip0

   for (local i = 1 ; i < char_rows ; i++){
      teststrip = teststrip+"\n"+teststrip0
   }

   testpr(teststrip)
   */

   hist_titletxt_bd.msg = hist_titletxt.msg = hist_logotitle.text
   if (prf.HISTORYPANEL) hist_titletxt_bot.msg = hist_logotitle.text

   hist_titletxt_bd.char_size = hist_titletxt.char_size  = min( ((charfontsize*0.95)*char_cols)/hist_logotitle.cols ,  ((charfontsize*0.95)*char_rows)/hist_logotitle.rows )

   if (prf.HISTORYPANEL) hist_titletxt_bot.char_size = hist_titletxt.char_size * (hist_titletxt_bot.width/hist_titletxt.width)
   
   hist_titletxt_bd.x = hist_titletxt.x + 0.015 * hist_titletxt.char_size
   hist_titletxt_bd.y = hist_titletxt.y - 0.025 * hist_titletxt.char_size

   hist_titletxt_bd.visible = hist_titletxt.visible = (hist_title.subimg_height == 0)
   if (prf.HISTORYPANEL) hist_titletxt_bot.visible = (hist_title.subimg_height == 0)

   hist_text_surf.shader = gradshader

	local sys = split( fe.game_info( Info.System ), ";" )
	local rom = fe.game_info( Info.Name )

	//
	// we only go to the trouble of loading the entry if
	// it is not already currently loaded
	//
	if ( hist_curr_rom != rom )
	{
		hist_curr_rom = rom
		local alt = fe.game_info( Info.AltRomname )
		local cloneof = fe.game_info( Info.CloneOf )

		local lookup = get_history_offset( sys, rom, alt, cloneof )
		
		if ( lookup >= 0 )
		{
			//fe.overlay.splash_message(lookup + " " + my_config)
			hist_text.first_line_hint = 3
			try {
				hist_text.msg = get_history_entry( lookup, my_config )
				} catch ( err ) { hist_text.msg = "\n\n\nThere was an error loading game data, please check history.dat preferences in the layout options"; }
		}
		else
		{
         
			if ( lookup == -2 )
				hist_text.msg = "\n\n\nIndex file not found. Try generating an index from the history.dat plug-in configuration menu."
			else	
			//	hist_text.msg = "\n\n\nUnable to locate: "+ rom
		
      		//	hist_text.first_line_hint = 3

         hist_text.msg = "\n\n\n" + fe.game_info (Info.Title) + "\n" + "© " + fe.game_info(Info.Year) + " by " + fe.game_info(Info.Manufacturer) +"\n\n"+ fe.game_info(Info.Overview) +"\n\n\n"
      }
	}
}

function history_show(h_startup)
{
   if ((prf.AUDIOVIDSNAPS) && (prf.THUMBVIDEO)) vidszTable[newfocusindex].video_flags = Vid.NoAudio

   history_updatesnap()
   history_updatetext()

   if (h_startup) {
   	history_surface.visible=true
	   flowT.history = startfade (flowT.history,0.05,3.0)
  	   flowT.histtext = startfade (flowT.histtext,0.05,-3.0)
  	   flowT.data = startfade (flowT.data,-0.08,-3.0)
  	   flowT.fg = startfade (flowT.fg,0.08,-3.0)
      flowT.historyscroll = [0.5,0.5,0.5,0.0,0.0]
   }
}


function history_hide() {
	//history_surface.visible = false
   if ((prf.AUDIOVIDSNAPS) && (prf.THUMBVIDEO)) vidszTable[newfocusindex].video_flags = Vid.Default

	flowT.history = startfade (flowT.history,-0.05,-3.0)
  	flowT.histtext = startfade (flowT.histtext,-0.5,0.0)
   flowT.data = startfade (flowT.data,0.06,3.0)
  	flowT.fg = startfade (flowT.fg,-0.06,3.0)
}

function history_visible() {
	return ((history_surface.visible) && (flowT.history[3] >= 0))
}

function on_scroll_up() {
	hist_text.first_line_hint--
}

function on_scroll_down() {
	hist_text.first_line_hint++
}

function history_exit () {
//	hist_title.file_name = "transparent.png"
//	hist_screen.file_name = "transparent.png"
	history_hide()
}

// Fade helper functions

function fadeupdate(fadearray){
   local t_counter = fadearray[0]
   local t_value = fadearray[1]
   local t_starter = fadearray[2]
   local t_increaser = fadearray[3]
   local t_easer = fadearray[4]

   t_counter = t_counter + t_increaser 

   if (t_easer == 0)
      t_value = t_counter
   else if (t_easer > 0)
      t_value = t_starter + pow (t_counter-t_starter,t_easer)
   else if (t_easer < 0)
      t_value = t_starter + 1 - pow (1.0 - t_counter + t_starter, -1*t_easer)

   return ([t_counter,t_value,t_starter,t_increaser,t_easer])
}

function checkfade(fadearray) {
   return (fadearray[3] != 0)
}

function startfade (fadearray,t_increaser,t_easer) {
   local t_data = fadearray[1]
   return ([t_data,t_data,t_data,t_increaser,t_easer])
}

function history_changegame(direction){
   
   if ((prf.AUDIOVIDSNAPS) && (prf.THUMBVIDEO)) vidszTable[newfocusindex].video_flags = Vid.NoAudio

   flowT.historyscroll = startfade (flowT.historyscroll,0.0751,0.0)
   flowT.historyblack = startfade (flowT.historyblack,flowT.historyscroll[3]*2.0,0.0)
   flowT.historydata = startfade (flowT.historydata,0.101,0.0)
   scrollreset = true
   hist_direction = direction
}


/// Display Menu Page  


local disp0 = {
   w = flw
   h = flh-header_h-footer_h-overlay.labelsize
}


local disp = {
   items = []
   tile = ((disp0.h > disp0.w*0.5) ? disp0.w*0.5 : disp0.h)
   pos0 = []
   xstart = 0
   xstop = 0
   speed = null
   pad = 40 * scalerate
   width =  null
   height = flh-header_h-footer_h-overlay.labelsize
   spacing = null
   x = null
   y = header_h + overlay.labelsize
   starter = false
}

disp.width = disp.tile
disp.speed = disp.tile * 0.1
disp.spacing = disp.tile
disp.x = flw- disp.tile

local display_surface = fe.add_surface (disp.width,disp.height)
display_surface.set_pos (disp.x,disp.y)


function drawdisplays(){
   local artname = ""
   local filename = ""
   local logoname = ""
   local zippo = null
   local pad = disp.pad
   for (local i = 0 ; i < fe.displays.len() ; i++){

      artname = FeConfigDirectory+"menu-art/snap/"+fe.displays[i].name
      logoname = FeConfigDirectory+"menu-art/wheel/"+fe.displays[i].name+".png"
      filename ="transparent.png"
      if ( file_exist (artname+".jpg") ) filename =  artname+".jpg"
      if ( file_exist (artname+".png") ) filename =  artname+".png"

      zippo = display_surface.add_image( "transparent.png", pad + display_surface.width*0.5  - 0.5*disp.tile , pad + display_surface.height*0.5-disp.tile*0.5 + i*disp.spacing , disp.tile - 2.0*pad , disp.tile -2.0*pad )
      zippo.preserve_aspect_ratio = true
      zippo.file_name = filename
      disp.items.push(zippo)
      disp.pos0.push (zippo.y)
      zippo = display_surface.add_image( "transparent.png", pad*2.0 + display_surface.width*0.5  - 0.5*disp.tile, pad*2.0 + display_surface.height*0.5-disp.tile*0.5 + i*disp.spacing  , disp.tile - pad * 4.0, disp.tile*0.25 )
      zippo.preserve_aspect_ratio = true
      zippo.file_name = logoname
      disp.items.push (zippo)
      disp.pos0.push (zippo.y)

   }
}


display_surface.zorder = 1
local sh_scaler2 = 0.5*sh_scaler
drawdisplays()
/*
for (local i = 0;i <  fe.displays.len();i++) {
   disp.items[i].x = disp.items[i].x - fe.list.display_index * disp.tile
}
*/
disp.xstop = - fe.list.display_index * disp.spacing

local display_surface_sh = fe.add_surface(display_surface.width * sh_scaler2 , display_surface.height * sh_scaler2)
local display_surface_sh1 = display_surface_sh.add_clone(display_surface)
display_surface_sh1.set_pos (0 , 0 , display_surface.width * sh_scaler2 , display_surface.height * sh_scaler2)

display_surface_sh.set_rgb(0,0,0)
display_surface_sh1.set_rgb(0,0,0)

local shader_tx2 = {
   h = fe.add_shader( Shader.Fragment, "gauss_kernsigma_o.glsl" )
   v = fe.add_shader( Shader.Fragment, "gauss_kernsigma_o.glsl" )
}

shader_tx2.v.set_texture_param( "texture")
shader_tx2.v.set_param("kernelData",9,3.0)
shader_tx2.v.set_param("offsetFactor",0.000,1.0/(flh*sh_scaler2))

shader_tx2.h.set_texture_param( "texture")
shader_tx2.h.set_param("kernelData",9,3.0)
shader_tx2.h.set_param("offsetFactor",1.0/(flw*sh_scaler2),0.000)

display_surface_sh.shader = noshader
display_surface_sh1.shader = noshader


display_surface_sh.alpha = themeT.themeshadow

display_surface_sh.zorder = 0

display_surface_sh.set_pos(display_surface.x + 4*scalerate,display_surface.y + 8*scalerate,display_surface.width,display_surface.height)

display_surface.visible = display_surface_sh.visible = false

disp.starter = true 


/// Layout fades  

function layoutfadein () {
   if (prf.SPLASHON){
      flowT.fg = [1.0,1.0,1.0,-0.011,1.0]
      flowT.data = [0.0,0.0,0.0,0.011,1.0]
      flowT.logo = [1.0,1.0,1.0,-0.017,1.0]
   }
   else {
      flowT.fg = [1.0,1.0,1.0,-0.016,-1.0]
      flowT.data = [0.0,0.0,0.0,0.016,-1.0]
      flowT.logo = [1.0,1.0,1.0,-0.02,1.0]   
   }
}

data_surface.alpha = data_surface_sh.alpha = 0
fg_surface.alpha = 255

// moved after the fade if ((!prf.AMENABLE) || (!prf.AMSTART)) layoutfadein ()

/// Attract mode  
local attract = {
   start = true
  // updatesnap = false
   rolltext = false
   gametimer = false
   starttimer = false

   scanrows = 180.0
   scansize = 5

   textshadow = 80
   game_interval = 1000 * prf.AMCHANGETIMER
   attract_interval = 1000 * prf.AMTIMER
   timer = fe.layout.time
   w = 0 
   nw = 0 
   x = 0 
   y = 0 
   msg = prf.AMMESSAGE
   sound = prf.AMSOUND
}

// If the screen resolution is so low that 5 pixels per scanline would not fit, 
// pixels per scanlines are calculated as integer and no rescaling is applied.
// otherwise scanlines are 5 pixel tall and image is 900x900 and rescaled to fit
// the actual screen resolution (to improve performance)

if (attract.scansize <= ceil (bgT.w/attract.scanrows)){
   attract.nw = attract.scansize * attract.scanrows
   attract.w = bgT.w * 1.01
   attract.x = bgT.x - bgT.w * 0.005
   attract.y = bgT.y - bgT.w * 0.005
}
else {
   attract.scansize = ceil (bgT.w/attract.scanrows)
   attract.nw = attract.scansize * attract.scanrows
   attract.w = attract.nw
   attract.x = bgT.x - (attract.nw - bgT.w)*0.5
   attract.y = bgT.y - (attract.nw - bgT.w)*0.5   
}


local attract_surface = null
local attract_snap = null
local attract_black = null
local attract_text_surface = null
local attract_text = null
local attract_text2 = null

local attract_fade = null
local attract_vignette = null
local shader_2_lottes = null

function attractkick(){
   if (history_visible()) history_hide()
   if (overmenu_visible()) overmenu_hide(true)
   attract.start = true
   attract.starttimer = false
   attract_surface.visible = true
   attract_text.visible = attract_text2.visible = true
   attract_snap.shader = shader_2_lottes

   flowT.attract = startfade (flowT.attract, 0.1,0.0)
   flowT.logo = startfade (flowT.logo,0.1,0.0)
   flowT.fg = startfade (flowT.fg,0.1,0.0)
}

function attractupdatesnap(){
   attract_snap.file_name = fe.get_art("snap",fe.list.size*rand()/RAND_MAX)
   // attract_snap.file_name = fe.get_art("snap")

   if (attract_snap.texture_width >= attract_snap.texture_height){
      attract_snap.subimg_y = attract_snap.texture_height * 0.5 - attract.scanrows * 0.5
      attract_snap.subimg_height = attract.scanrows
      attract_snap.subimg_x = attract_snap.texture_width * 0.5 - attract.scanrows * 0.5 * ((attract_snap.texture_width * 3.0/4.0)/attract_snap.texture_height)
      attract_snap.subimg_width = attract.scanrows * ((attract_snap.texture_width * 3.0/4.0)/attract_snap.texture_height)
   }
   else
   {
      attract_snap.subimg_x = attract_snap.texture_width * 0.5 - attract.scanrows * 0.5
      attract_snap.subimg_width = attract.scanrows
      attract_snap.subimg_y = attract_snap.texture_height * 0.5 - attract.scanrows * 0.5 * ((attract_snap.texture_height * 3.0/4.0)/attract_snap.texture_width)
      attract_snap.subimg_height = attract.scanrows * ((attract_snap.texture_height * 3.0/4.0)/attract_snap.texture_width)
   }

   shader_2_lottes.set_param("vert", (attract_snap.texture_width >= attract_snap.texture_height ? 0.0 : 1.0))
   shader_2_lottes.set_param("color_texture_sz", attract_snap.texture_width, attract_snap.texture_height)
   shader_2_lottes.set_param("color_texture_pow2_sz", attract_snap.texture_width, attract_snap.texture_height)
}

if (prf.AMENABLE){

   shader_2_lottes = fe.add_shader(Shader.VertexAndFragment,"CRTL-geom_vsh.glsl","CRTL-geom_fsh.glsl");


   attract_surface = fe.add_surface (attract.nw,attract.nw)
   attract_surface.set_pos(attract.x,attract.y,attract.w,attract.w)
   attract_snap = attract_surface.add_image("abg.jpg",0,0,attract.nw,attract.nw)
   attract_snap.preserve_aspect_ratio = false

   attract_black = attract_surface.add_text("",0,0,attract.nw,attract.nw)
   attract_black.set_bg_rgb(0,0,0)
   attract_black.bg_alpha = 0

   //attract_text_surface = fe.add_surface (attract.w,attract.w)
   //attract_text_surface.set_pos(attract.x,attract.y)

   if (prf.SPLASHON) {
      attract_text = fe.add_text(attract.msg,attract.x,attract.y-attract_surface.y+flh-140*scalerate,attract_surface.width,140*scalerate)
   }
   else {
      attract_text = fe.add_text(attract.msg,attract.x,attract.y,attract.w,attract.w)
   }

   attract_text.char_size = 72 * scalerate
   attract_text.font = uifonts.gui
   attract_text.set_rgb (0,0,0)
   attract_text.alpha = attract.textshadow

   attract_text2 = fe.add_text(attract.msg,attract_text.x,attract_text.y-10*scalerate,attract_text.width,attract_text.height)
   
   attract_text2.char_size = 70*scalerate
   attract_text2.font = uifonts.gui
   attract_text2.set_rgb(255,255,255)

   attract_fade = attract_surface.add_image("abg.jpg",0,0,attract.nw,attract.nw)
   attract_fade.alpha = 80
   attract_fade.blend_mode = BlendMode.Add

   attract_vignette = attract_surface.add_image("vignette.png",0,0,attract.nw,attract.nw)
   // attract_vignette.alpha = 80


   //attract_snap.shader = shader_2_lottes
   attract_snap.shader = noshader

   //fg_surface.visible = false

   shader_2_lottes.set_param("aperature_type", 0.0); // 0.0 = none, 1.0 = TV style, 2.0 = Aperture grille, 3.0 = VGA
   shader_2_lottes.set_param("hardScan", -16.0);   // Hardness of Scanline 0.0 = none -8.0 = soft -16.0 = medium 
   shader_2_lottes.set_param("hardPix", -2.0);     // Hardness of pixels in scanline -2.0 = soft, -4.0 = hard
   shader_2_lottes.set_param("maskDark",0.65);     // Sets how dark a "dark subpixel" is in the aperture pattern.
   shader_2_lottes.set_param("maskLight", 1.35);    // Sets how dark a "bright subpixel" is in the aperture pattern
   shader_2_lottes.set_param("saturation", 1.0);   // 1.0 is normal saturation. Increase as needed.
   shader_2_lottes.set_param("tint", 0.0);         // 0.0 is 0.0 degrees of Tint. Adjust as needed.
   shader_2_lottes.set_param("blackClip", 0.3);   // Drops the final color value by this amount if GAMMA_CONTRAST_BOOST is defined
   shader_2_lottes.set_param("brightMult", 2.0);   // Multiplies the color values by this amount if GAMMA_CONTRAST_BOOST is defined
   shader_2_lottes.set_param("distortion", 0.2);  // 0.0 to 0.2 seems right
   shader_2_lottes.set_param("cornersize", 0.05);  // 0.0 to 0.1
   shader_2_lottes.set_param("cornersmooth", 60);  // Reduce jagginess of corners
   shader_2_lottes.set_param("vignettebase", 0.0,1.0,3.0); 

}

if (prf.AMENABLE){
   if (prf.AMSTART) {
      attract_surface.alpha = 255
      attract_text.alpha = attract.textshadow
      attract_text2.alpha = 255
      attract.start = true
   }
   else {
      attract_snap.file_name = "transparent.png"
      attract_snap.shader = noshader
      attract_surface.visible = false
      attract_text.visible = attract_text2.visible = false
      attract_surface.alpha = 0
      attract_text.alpha = attract_text2.alpha = 0
      if(prf.AMTUNE != "") snd.attracttune.playing=false
      attract.start = false
      attract.timer = fe.layout.time
      attract.starttimer = true
   }
}


/// Splash Screen  

//local aflogo_surface = fe.add_surface(flw,flh)

// adds logo image to the logo surface
local aflogo = fe.add_image (prf.SPLASHLOGOFILE,0,0,flw,flh)
aflogo.visible = false

local aflogoT = {
	w = flw,
	h = flh,
	x = 0,
	y = 0,
	ar = aflogo.texture_width*1.0 / aflogo.texture_height
}

if (aflogoT.ar >= flw/(flh*1.0)){
	aflogoT.w = flw
	aflogoT.h = aflogoT.w / aflogoT.ar*1.0
	aflogoT.y = - (aflogoT.h - flh)*0.5
	aflogoT.x = 0
}
else {
	aflogoT.h = flh
	aflogoT.w = aflogoT.h * aflogoT.ar
	aflogoT.y = 0
	aflogoT.x = - (aflogoT.w - flw)*0.5
}

local aflogo_surface = fe.add_image (prf.SPLASHLOGOFILE,aflogoT.x,aflogoT.y,aflogoT.w,aflogoT.h)

if (!prf.SPLASHON) aflogo_surface.visible = false


/// Blanker for custom resolution  

local blanker = {
   bl1 = null
   bl2 = null
}

if ((prf.CUSTOMSIZE != "") && (displayAR != layoutAR)){

	if (displayAR > layoutAR){
		blanker.bl1 = fe.add_image("black.png",-5+(flh/frostpic.h)*frost_picT.x,0,5-(flh/frostpic.h)*frost_picT.x,flh)
		blanker.bl2 = fe.add_image("black.png",flw,0,5-(flh/frostpic.h)*frost_picT.x,flh)
	}
	else{
		blanker.bl1 = fe.add_image("black.png",0,(flw/frostpic.w)*frost_picT.y,flw,-(flw/frostpic.w)*frost_picT.y)
		blanker.bl2 = fe.add_image("black.png",0,flh,flw,-(flw/frostpic.w)*frost_picT.y)
	}


}

/// Layout fade from black  

local layoutblacker = fe.add_image("black.png",0,0,flw,flh)

flowT.blacker = [1.0,1.0,1.0,-0.09,1.0]



/// FPS MONITOR  

local fps = {
   monitor = null
   monitor2 = null
   x0 = null
   tick000 = null
   tickinterval = 10
}


if (prf.FPSON){
fps.monitor = fe.add_text ("",fe.layout.width*0.5-75*scalerate,0,150*scalerate,80*scalerate)
fps.monitor.set_bg_rgb (50,50,50)
fps.monitor.bg_alpha = 200
fps.monitor.set_rgb (255,255,255)
fps.monitor.char_size = 50*scalerate
fps.monitor.zorder = 20000

fps.monitor2 = fe.add_text ("",0,0,10,10)
fps.monitor2.set_bg_rgb (255,0,0)
fps.monitor2.visible = true

fps.tick000 = 0
fps.x0 = 0

fe.add_ticks_callback(this,"monitortick")
}

function monitortick(tick_time){

	fps.monitor2.x ++
	if (fps.monitor2.x - fps.x0 == fps.tickinterval) {
		fps.monitor.msg = fps.tickinterval*1000/(tick_time - fps.tick000)
		fps.monitor2.y = (flh/60)*(60 - fps.tickinterval*1000/(tick_time - fps.tick000))
      fps.tick000 = tick_time
		fps.x0 = fps.monitor2.x
	}
	if (fps.monitor2.x >= fe.layout.width) {
		fps.monitor2.x = 0
		fps.x0 = 0
		fps.tick000=0
	}

}

/// Pre-Transition functions for labels jumps  

function gamesorter( offset ) {
   local sresult = "-"

   if ((fe.filters.len() > 0) && (fe.list.filter_index < fe.filters.len())){

      if (fe.filters[fe.list.filter_index].sort_by == Info.Year){
         local s = fe.game_info( Info.Year, offset )
         if(s != "") s = s.slice (0,3)+"x"
         sresult = s
      }
      else if (fe.filters[fe.list.filter_index].sort_by == Info.Manufacturer){
         local s = fe.game_info( Info.Manufacturer, offset )
         if (s == "<unknown>") sresult = "?"
         else if (s.find ( "bootleg") != null) sresult = "*"
         else if (s != "") sresult = s.slice(0,1)		
      }
      else if (fe.filters[fe.list.filter_index].sort_by == Info.Category){
         	local sout = ""
            local s0 = fe.game_info( Info.Category, offset )
            if (s0 == "") sresult = "" 
            else {   
               local s = split( s0, "/" )
               if ( s.len() > 1 ) {
                  sout = strip(s[0]).toupper()
               }
               else sout = strip(s0).toupper()

               switch (sout){
                  case "ADVENTURE": return "ADVN"
                  case "ROLE-PLAYING": return "RPG" 
                  case "ACTION": return "ACTN" 
                  case "PLATFORM": return "PLATF" 
                  case "MULTIPLAY": return "MULTI"
                  case "BALL & PADDLE": return "PADDL"
		            case "BEATEMUP":	return "BEAT"
                  case "FIGHTER":	return "FIGHT"
                  case "DRIVING":	return "DRIVE"
                  case "MAZE":	return "MAZE"
                  case "MISC.": return "MISC"
   		         case "SHOOTEMUP": return "SHOOT"
                  case "CASINO": return "CASINO"
                  case "SHOOTER": return "SHOOT"
                  case "PUZZLE": return "PUZZL"
                  case "SPORTS": return "SPORT"
                  case "WHAC-A-MOLE": return "WHAC"                  
                  case "MISCELLANEOUS": return "MISC"
                  case "FLYING": return "FLY"
                  case "STRATEGY": return "STRT"
                  case "SIMULATION": return "SIM"
                  case "BOARDGAMES": return "BOARD"
                  case "GUN": return "GUN"
                  default: return ""
               }	
            }
         }
      else  {
         local s = fe.game_info( Info.Title, offset )
         if ((s == null) || (s == "")) s = "-"
         //testpr("Z sort")
         if (prf.STRIPARTICLE) s = nameclean (s)
         
         local s2 ="?"
         if (s.len() > 0)  s2 = s.slice(0,1)
         if ("'1234567890".find (s2) != null ){
            s2="#"
         }
         sresult = s2
      }
      
   }
   
   else {
         local s = fe.game_info( Info.Title, offset )
         if ((s == null) || (s == "")) s = "-"
         //testpr("Z sort")
         if (prf.STRIPARTICLE) s = nameclean (s)
         
         local s2 ="?"
         if (s.len() > 0)  s2 = s.slice(0,1)
         if ("'1234567890".find (s2) != null ){
            s2="#"
         }
         sresult = s2
      }
   return sresult
}

local sortlabels = {}
local sortticks = {}

function downkey (order){
   sortlabels [order].set_rgb (255,255,255)
   sortlabels [order].set_bg_rgb (0,0,0)
   sortlabels [order].bg_alpha = 255
}

function upkey (order){
   try{
      sortlabels [order].set_rgb (0,0,0)
      sortlabels [order].set_bg_rgb (255,255,255)
      sortlabels [order].bg_alpha = 255
   }
   catch (err){}
}

local labelorder = []
local labelcounter = {}

function doorderjump(jumpsize){
   local tmp_current = labelorder.find(gamesorter(0))
   local tmp_next = tmp_current + jumpsize

   local tmp_outindex = 0

   if ( (tmp_next >= 0) && (tmp_next < labelorder.len()) ){

      for (local i = 0 ; i < tmp_next ; i++){
         tmp_outindex = tmp_outindex + labelcounter[labelorder[i]]
      }
      fe.list.index = tmp_outindex
   }
}


function updatebgsnap (index){
   bgs.bgpic_array[bgs.stacksize-1].file_name = fe.get_art((prf.BOXARTMODE ? (prf.LAYERSNAP ? "snap" : "flyer") : "snap") , offseTable[index],0,Art.ImagesOnly)
   bgs.bg_lcd[bgs.stacksize-1] = islcd ( offseTable[index] , regsys.LCD) 
   bgs.bg_mono[bgs.stacksize-1] = islcd ( offseTable[index] , regsys.MONO) 
}

function ishorizgame (tileindex, tile2, var, boxart){
   local horizgame = fe.game_info(Info.Rotation, tileindex + var) 
   if ((horizgame == "") || (boxart)){
      horizgame = boxorient(tile2,var)
      return horizgame
   }
   horizgame = ((horizgame == "0") || (horizgame == "180") || (horizgame == "horizontal") || (horizgame == "Horizontal"))
   return horizgame
}

function boxorient (tile, var){
   local orientation = null
   local results = [true, null, false]
   local aspects = [4.0/3.0,1.0,3.0/4.0]
   for (local i = 0 ; i < 3 ; i++) {
      aspects[i] =  (aspects[i] - (1.0*tile.texture_width / tile.texture_height))
      if (aspects[i] < 0) aspects[i] = -1.0*aspects[i]
   }
   local minval = 0
   
   if ((aspects[0] < aspects[1]) && (aspects[0] < aspects[2]))
      minval = aspects[0]
   else if ((aspects[1] < aspects[0]) && (aspects[1] < aspects[2]))
      minval = aspects[1]
   else if ((aspects[2] < aspects[0]) && (aspects[2] < aspects[1]))
      minval = aspects[2]

   for (local i = 0 ; i < 3;i++) {
      if (aspects[i] == minval) orientation = results[i]
   }

   return orientation
}

function update_gradient(i){
   if ((prf.SNAPGRADIENT) && (!prf.BOXARTMODE))
      snapzTable[i].shader.set_param ("enabled",true)
   if ((prf.BOXARTMODE) && (!prf.LOWSPECMODE) ) 
      snapzTable[i].shader.set_param ("enabled",false)
   if ((loshzTable[i].subimg_width == 0) && (!prf.MISSINGWHEEL )) snapzTable[i].shader.set_param("enabled",false) 
    txshzTable[i].visible = txt1zTable[i].visible = txt2zTable[i].visible = ((loshzTable[i].subimg_width == 0) && !(prf.BOXARTMODE) && (prf.MISSINGWHEEL))
}

// Function that updates snap position, size and internal crop
function update_snapcrop (i,var,orient){
//   local horizgame = ishorizgame (loshzTable[i],snapzTable[i], var)
   local horizgame = orient
   if ((prf.CROPSNAPS) && (!prf.BOXARTMODE))
   {
      // CROPSNAPS IS ENABLED
      snapzTable[i].set_pos (selectorscale*padding*10.0/8.0,selectorscale*(padding*10.0/8.0-verticalshift),selectorscale*width*44.0/48.0,selectorscale*height*44.0/48.0)
   //   vid2zTable[i].set_pos (selectorscale*padding*10.0/8.0,selectorscale*(padding*10.0/8.0-verticalshift),selectorscale*width*44.0/48.0,selectorscale*height*44.0/48.0)
   //   vidszTable[i].set_pos (selectorscale*padding*10.0/8.0,selectorscale*(padding*10.0/8.0-verticalshift),selectorscale*width*44.0/48.0,selectorscale*height*44.0/48.0)
      
      if ((!islcd(offseTable[i] + var , regsys.LCD) ) && (!prf.DISPLAYMENUON)){
         if (horizgame == true){
            snapzTable[i].subimg_x = snapzTable[i].texture_width/8.0
            snapzTable[i].subimg_width = snapzTable[i].texture_width*3.0/4.0
            }
         if (horizgame == false){
            snapzTable[i].subimg_y = snapzTable[i].texture_height/8.0
            snapzTable[i].subimg_height = snapzTable[i].texture_height*3.0/4.0
         }
      }
      else {
         snapzTable[i].subimg_width = snapzTable[i].subimg_height = min(snapzTable[i].texture_width,snapzTable[i].texture_height)
         snapzTable[i].subimg_y = 0.5*(snapzTable[i].texture_height - snapzTable[i].subimg_height)               
         snapzTable[i].subimg_x = 0.5*(snapzTable[i].texture_width - snapzTable[i].subimg_width) 
      }
   }
   else 
   {
      // SNAP IS POSITIONED ACCORDING TO FUZZY ORIENTATION OF GAME OR BOXART
      if (horizgame == true){
         snapzTable[i].set_pos (selectorscale*padding,selectorscale*(padding-verticalshift + height/8.0 ),selectorscale*width,selectorscale*height*3.0/4.0)
      }
      if (horizgame == false){
         snapzTable[i].set_pos (selectorscale*(padding+width/8.0),selectorscale*(padding-verticalshift),selectorscale*width*3.0/4.0,selectorscale*height)
      }
      if (horizgame == null){
         snapzTable[i].set_pos (selectorscale*padding*10.0/8.0,selectorscale*(padding*10.0/8.0-verticalshift),selectorscale*width*44.0/48.0,selectorscale*height*44.0/48.0)
      }
      // WHILE TV SYSTEMS ARE STRETCHED TO THE 4:3 or 3:4 AR, HANDHELD OR BOXARTS ARE CROPPED TO THE CLOSEST AR
      if ((islcd(offseTable[i] + var , regsys.LCD) ) || (prf.BOXARTMODE == true)){
         if (horizgame == true){
            if (1.0*snapzTable[i].texture_width / snapzTable[i].texture_height >= 4.0/3.0){
               snapzTable[i].subimg_width = snapzTable[i].texture_height * 4.0/3.0
               snapzTable[i].subimg_height = snapzTable[i].texture_height            
            }
            else {
               snapzTable[i].subimg_width = snapzTable[i].texture_width
               snapzTable[i].subimg_height = snapzTable[i].texture_width * 3.0/4.0                 
            }
         }

         if (horizgame == false) {
            if (1.0*snapzTable[i].texture_height / snapzTable[i].texture_width >= 4.0/3.0){
               snapzTable[i].subimg_height = snapzTable[i].texture_width*4.0/3.0
               snapzTable[i].subimg_width = snapzTable[i].texture_width             
            }
            else {
               snapzTable[i].subimg_height = snapzTable[i].texture_height
               snapzTable[i].subimg_width = snapzTable[i].texture_height * 3.0/4.0 
            }
         }

         if (horizgame == null){
            snapzTable[i].subimg_height = snapzTable[i].subimg_width = min (snapzTable[i].texture_width,snapzTable[i].texture_height)
         }

         snapzTable[i].subimg_y = 0.5*(snapzTable[i].texture_height - snapzTable[i].subimg_height)               
         snapzTable[i].subimg_x = 0.5*(snapzTable[i].texture_width - snapzTable[i].subimg_width) 
      }
   }

   if ((!prf.BOXARTMODE) && (islcd(offseTable[i] + var , regsys.MONO))) {
      snapzTable[i].shader.set_param ("green",prf.GBGREENON)
   }
   else {
      snapzTable[i].shader.set_param ("green",false)
   }

   if ( (islcd(offseTable[i] +var , regsys.MONO))) {
      vidszTable[i].shader.set_param ("green",prf.GBGREENON)
   }
   else {
      vidszTable[i].shader.set_param ("green",false)
   }

   update_gradient(i)
}

function update_borderglow(i,var,orient){

   bd_mxTable[i].visible = true
   glomxTable[i].visible = prf.SNAPGLOW
   if (prf.SNAPGLOW) glomxTable[i].shader = snap_glow[i] 

   if ((prf.CROPSNAPS) && (!prf.BOXARTMODE)){
      glomxTable[i].file_name = "glow_sq3.png"
      bd_mxTable[i].set_pos (selectorscale*padding*10.0/8.0*(1.0-whitemargin),selectorscale*(-verticalshift + padding*(10.0/8.0)*(1.0 - whitemargin)),selectorscale*(width*44.0/48.0 + padding*10.0/8.0*2.0*whitemargin),selectorscale*(height*44.0/48.0 + padding*10.0/8.0*2.0*whitemargin))
      if (prf.SNAPGLOW) glomxTable[i].set_pos(0,-selectorscale*verticalshift)         
   }
   else{
      if (orient == true){
         if (prf.SNAPGLOW) snap_glow[i].set_param ("vertical",false)
         glomxTable[i].file_name = "glowx5d.png"
         bd_mxTable[i].set_pos (selectorscale*padding*(1.0-whitemargin),selectorscale*(-verticalshift + height/8.0 + padding*(1.0 - whitemargin)),selectorscale*(width + padding*2.0*whitemargin),selectorscale*(height*(3.0/4.0)+padding*2.0*whitemargin))  
         if (prf.SNAPGLOW) glomxTable[i].set_pos(0,-selectorscale*verticalshift)
      }

      else if (orient == false){
         if (prf.SNAPGLOW) snap_glow[i].set_param ("vertical",true)
         glomxTable[i].file_name = "glowx5d.png"
         bd_mxTable[i].set_pos (selectorscale*(width/8.0 + padding*(1.0 - whitemargin)), selectorscale*(-verticalshift + padding*(1.0 - whitemargin)),selectorscale*(width*(3.0/4.0)+padding*2.0*whitemargin),selectorscale*(height + padding*2.0*whitemargin))
         if (prf.SNAPGLOW) glomxTable[i].set_pos(0,-selectorscale*verticalshift)
      }
      else { 
         glomxTable[i].file_name = "glow_sq3.png"
         bd_mxTable[i].set_pos (selectorscale*padding*10.0/8.0*(1.0-whitemargin),selectorscale*(-verticalshift + padding*(10.0/8.0)*(1.0 - whitemargin)),selectorscale*(width*44.0/48.0 + padding*10.0/8.0*2.0*whitemargin),selectorscale*(height*44.0/48.0 + padding*10.0/8.0*2.0*whitemargin))
         if (prf.SNAPGLOW) glomxTable[i].set_pos(0,-selectorscale*verticalshift)
      }
   }   
}

function update_thumbdecor(i,var,orient){ 

   favezTable[i].visible = (fe.game_info(Info.Favourite, offseTable[i] + var) == "1")
   donezTable[i].visible = ((fe.game_info(Info.Tags, offseTable[i] + var)).tolower().find("completed") != null)       
   logozTable[i].visible = loshzTable[i].visible = !(prf.BOXARTMODE)
   nw_mxTable[i].visible = (fe.game_info(Info.PlayedCount, offseTable[i]+var) == "0") 
   // TEST54 ADD CONTROL WHEN ONLY ONE TAG IS PRESENT AND IS "Completed"
   local tagcheckerlist = fe.game_info(Info.Tags, offseTable[i] + var)
   tagcheckerlist = split (tagcheckerlist,";")
   if ((tagcheckerlist.len() == 1) && (tagcheckerlist[0].tolower() == "completed")) {
      tg_mxTable[i].visible = false
   } 
   else tg_mxTable[i].visible = ((fe.game_info(Info.Tags, offseTable[i] + var)).tolower().find(prf.TAGNAME.tolower()) != null)
   
   
   if ((prf.CROPSNAPS) && (!prf.BOXARTMODE)){
      sh_hzTable[i].visible = false
      sh_vzTable[i].visible = false
      sh_sqTable[i].visible = true                     
      nw_mxTable[i].set_pos(selectorscale*padding*10.0/8.0,selectorscale*(-verticalshift + padding*10.0/8.0+height*(44.0/48.0)*(7.0/8.0)),width*selectorscale*(44.0/48.0)/8.0,height*selectorscale*(44.0/48.0)/8.0)
      tg_mxTable[i].set_pos(selectorscale*(padding*10.0/8.0+width*(7.0/8.0)*(44.0/48.0)),selectorscale*(-verticalshift + padding*10.0/8.0+height*(44.0/48.0)*(7.2/8.0)))
   }
   else {
      if (orient == true){
         sh_hzTable[i].visible = true
         sh_vzTable[i].visible = false
         sh_sqTable[i].visible = false
         nw_mxTable[i].set_pos (selectorscale*padding,selectorscale*(padding-verticalshift+height*6.0/8.0))
         tg_mxTable[i].set_pos (selectorscale*(padding + width*7.0/8.0),selectorscale*(padding-verticalshift+height*6.2/8.0))

      }
      if (orient == false){
         sh_hzTable[i].visible = false
         sh_vzTable[i].visible = true
         sh_sqTable[i].visible = false
         nw_mxTable[i].set_pos (selectorscale*(padding+width/8.0),selectorscale*(padding-verticalshift+height*7.0/8.0))
         tg_mxTable[i].set_pos (selectorscale*(padding+width*6.0/8.0),selectorscale*(padding-verticalshift+height*7.2/8.0))
      }
      if (orient == null){
         sh_hzTable[i].visible = false
         sh_vzTable[i].visible = false
         sh_sqTable[i].visible = true
         nw_mxTable[i].set_pos(selectorscale*padding*10.0/8.0,selectorscale*(-verticalshift + padding*10.0/8.0+height*(44.0/48.0)*(7.0/8.0)),width*selectorscale*(44.0/48.0)/8.0,height*selectorscale*(44.0/48.0)/8.0)
         tg_mxTable[i].set_pos(selectorscale*(padding*10.0/8.0+width*(7.0/8.0)*(44.0/48.0)),selectorscale*(-verticalshift + padding*10.0/8.0+height*(44.0/48.0)*(7.2/8.0)))
      }
   }   
}

// Function that updates the whole tiles when changing from boxart to snapshots
function modeupdater(){
   // engage or disengage gradients

   updatebgsnap (newfocusindex)
   
   local index = - (floor(tiles.total/2) -1) + corrector 

   for ( local i = 0; i < tiles.total ; i++ ) {

      local indexTemp = wrap( i + tilesTablePos.Offset, tiles.total )

      gradzTable[indexTemp].file_name = fe.get_art((prf.BOXARTMODE ? "flyer" : "snap") , index,0,Art.ImagesOnly)
       
      local horizgame = ishorizgame(offseTable[indexTemp],snapzTable[indexTemp],0,prf.BOXARTMODE)
      
      update_snapcrop (indexTemp , 0, horizgame)         

      tilesTable[indexTemp].zorder = -2

      favezTable[indexTemp].visible = (fe.game_info(Info.Favourite, offseTable[indexTemp] + 0) == "1")
      donezTable[indexTemp].visible = ((fe.game_info(Info.Tags, offseTable[indexTemp] + 0)).tolower().find("completed") != null)

      
      logozTable[indexTemp].visible = loshzTable[indexTemp].visible = !(prf.BOXARTMODE)
            
      nw_mxTable[indexTemp].visible = (fe.game_info(Info.PlayedCount, offseTable[indexTemp]+0) == "0") 
      tg_mxTable[indexTemp].visible = true
      // Update of horizontal or vertical shadows, glow, indicator etc
      update_thumbdecor(indexTemp,0,horizgame)
      
      update_borderglow(indexTemp,0,horizgame)
     
      if  (prf.THUMBVIDEO)  {
         vidszTable[indexTemp].alpha = 0
         vid2zTable[indexTemp].alpha = 0
         vidpos[indexTemp] = 0
         vidszTableFade[indexTemp]=[0.0,0.0,0.0,0.0,0.0]
         vidszTable[indexTemp].file_name = "transparent.png"              
      }  

      index++
   }

   if (prf.THUMBVIDEO) vidpos[newfocusindex] = vidstarter

   squarizer = true
   frg.grabdither = 2
}


function switchmode(){
   prf.BOXARTMODE = !prf.BOXARTMODE

   modeupdater()

   DISPLAYTABLE [fe.displays[fe.list.display_index].name] <- (prf.BOXARTMODE ? "BOXES" : "SNAPS")
   fe.nv["AF_Display_Type"] <- DISPLAYTABLE
}

function utilitymenu(){
   if (prf.FROSTEDGLASS){
      if (frg.immediatesignal){
      //snd.wooshsound.playing=true	
      frg.immediatesignal = false
      }
      else{
      getsnap(prf.UTILITYMENUBUTTON)
      return true
      }
   }
   else {
      if(prf.THEMEAUDIO) snd.wooshsound.playing=true
         }

   local switcharray1 = [
      "Filters",
      "Displays",
      "Search for...",
      "Layout options",
      "Attract mode",
      (prf.BOXARTMODE ? "Screenshot tiles" : "Box Art tiles"),
      "Reset Box Art"
   ]

   local result1 = fe.overlay.list_dialog(switcharray1,"Utility Menu")

   if (result1 == 0){
      //	snd.wooshsound.playing=true
      frg.immediatesignal = true
      fe.signal("filters_menu")
   if(prf.THEMEAUDIO) snd.wooshsound.playing=true
   }
   
   if (result1 == 1){
      //	snd.wooshsound.playing=true
      frg.immediatesignal = true
      fe.signal("displays_menu")
   if(prf.THEMEAUDIO) snd.wooshsound.playing=true
   }

   if (result1 == 5){
      //	snd.wooshsound.playing=true
      switchmode()
      if(prf.THEMEAUDIO) snd.wooshsound.playing=true
   }

   if (result1 == 6){
      //	snd.wooshsound.playing=true
      DISPLAYTABLE = {}
      fe.nv["AF_Display_Type"] <- DISPLAYTABLE
      fe.signal("reload")
      if(prf.THEMEAUDIO) snd.wooshsound.playing=true
   }

   if ((result1 == 4) && (prf.AMENABLE)){
      attractkick()
   }

   if (result1 == 3){
      //	snd.wooshsound.playing=true
   fe.signal("layout_options")
   if(prf.THEMEAUDIO) snd.wooshsound.playing=true
   }	

   if (result1 == 2){
   if(prf.THEMEAUDIO) snd.wooshsound.playing=true

   searchtext =""
   local switcharray2 = [
      "Title",
      "Manufacturer",
      "Year",
      "Category",
      "RESET"
   ]
   local result = fe.overlay.list_dialog(switcharray2,"Search for...")
   
   if(result==4){
      //fe.list.index += corrector + rows 
      fe.list.search_rule =""
      searchdata.msg = ""
      if (backs.index != -1){
         fe.list.index = backs.index
         //corrector = backs.corrector
         backs.index = -1
      }
      //return
   }

   if ((result != 4)&&(result !=-1)){
      if (prf.KEYBOARD) 
         searchtext = fe.overlay.edit_dialog("Search "+switcharray2[result]+": ",searchtext)
      else
         search_base_rule = switcharray2[result]
      
      if (backs.index == -1){
         backs.index = fe.list.index
         //backs.corrector = corrector
      }
      
      if (prf.KEYBOARD)
      {
         fe.list.search_rule = switcharray2[result]+" contains "+ recalculate(searchtext)
         corrector = (rows == 1 ? -1 : 0)
         if(fe.list.search_rule == ""){
            searchdata.msg = ""
            if (backs.index != -1){
               fe.list.index = backs.index
               //corrector = backs.corrector
               backs.index = -1
            }
         }
         else
         searchdata.msg = fe.list.search_rule
      }
      else{
         search_toggle()
      }
      
      return true
      
   }
   return true
   }
}

fe.add_signal_handler( this, "on_signal" )
fe.add_transition_callback( this, "on_transition" )
fe.add_ticks_callback( this, "tick" )	


/// On Transition  


function on_transition( ttype, var0, ttime ) {

   if ((tags.decortr == true) && (ttype == Transition.ToNewSelection)){
      update_thumbdecor (newfocusindex,0,ishorizgame(offseTable[newfocusindex],snapzTable[newfocusindex],0,prf.BOXARTMODE))
      tags.decortr = false
   }

   local logotitle = null

   //DEBUG transition
   debugpr ("\nTr:" + transdata[ttype] +" var:" + var0 + "\n")

   // PREVENT ATTRACT MODE ENGAGE WHEN RETURNING FROM GAME
   if (ttype == Transition.FromGame){
      attract.timer = fe.layout.time
   }

   // Check if list is sorted with article
   if ((ttype == Transition.ToNewList) || (ttype == Transition.StartLayout)) {
      detectstriparticle()
   }
   
   // MANAGE DISPLAYS LIST
   if (ttype == Transition.ShowOverlay) {
      if (var0 == Overlay.Displays ){
         display_surface_sh.shader = (prf.DATASHADOWSMOOTH ? shader_tx2.v : noshader)
         display_surface_sh1.shader = (prf.DATASHADOWSMOOTH ? shader_tx2.h : noshader)
         
         display_surface.visible = display_surface_sh.visible = true
         prf.DISPLAYLISTON = true 
         overlay_listbox.width = flw - disp.width
         disp.xstop = - fe.list.display_index * disp.spacing

         disp.xstart = disp.xstop
         for (local i = 0;i <  disp.items.len() ; i++) {
            disp.items[i].y = disp.pos0[i] + disp.xstop
         }      
      }
      else {
         display_surface.visible = display_surface_sh.visible = false
         prf.DISPLAYLISTON = false
         overlay_listbox.width = flw
      }
   }

   if ((ttype == Transition.NewSelOverlay ) && (prf.DISPLAYLISTON) ){
      /*for (local i = 0 ; i <  fe.displays.len() ; i++) {
         disp.items[i].x = disp.pos0[i] - var0*disp.tile
      }*/
      disp.xstop = -var0*disp.spacing

   }
   

   // DISPLAY CHANGE REACTION
   if ((ttype == Transition.ToNewList) && (fe.list.display_index != displaystore)){
      fade.display = fade.displayzoom = 1
      disp.xstop =  - fe.list.display_index * disp.spacing

      // restore global settings
      prf.CROPSNAPS = ( (my_config["cropsnaps"] == "Square") ? true : false)
      prf.THUMBVIDEO = ( (my_config["thumbvideo"] == "Yes") ? true : false)
      prf.LAYERSNAP = ( (my_config["layersnap"] == "Yes") ? true : false)
      prf.SNAPGRADIENT = ( (my_config["snapgradient"] == "Yes") ? true : false)
      prf.BOXARTMODE = ( (my_config["boxartmode"] == "Yes") ? true : false)
      
      if (prf.LOWSPECMODE){
         prf.FROSTEDGLASS = false
         prf.DATASHADOWSMOOTH = false
         prf.LOGOSHADOW = false
         prf.SNAPGRADIENT = false
         prf.SNAPGLOW = false
      }

      try {
         prf.BOXARTMODE = ( (DISPLAYTABLE[fe.displays[fe.list.display_index].name] == "BOXES") ? true : false )
      }
      catch (err){}

      displaystore = fe.list.display_index
   }
   


   // UPDATE LABEL WHEN NEW SELECTION
   if ((prf.SCROLLERTYPE == "LabelList") && (ttype == Transition.ToNewSelection)){
      local sortl1 = gamesorter(0)
      local sortl2 = gamesorter(var0)

      if (sortl1 != sortl2){
         downkey (sortl1)
         upkey (sortl2)
      }
   }

   // UPDATE SCROLLER LABELS WHEN CHANGING LIST
   if ((prf.SCROLLERTYPE != "Scroller") && (ttype == Transition.ToNewList)){

      // Clean old ticks and labels
      try {
         foreach (label in sortlabels){
            label.visible = false
         }
         foreach (tick in sortticks){
            tick.visible = false
         }
      }
      catch (err){}
      
      // Reinitialize tables
      labelorder = []
      labelcounter = {}
      sortlabels = {}
      sortticks = {}

      // Count how many games are in each label
      for (local i = 0 ; i < fe.list.size ; i++){
         local s =  (gamesorter (i-fe.list.index))

         try { labelcounter[s]++ }
         catch (err) { 
               labelcounter[s] <- 1 
               labelorder.push (s)            
         }
      }

      local i = 0
      local w0 = flw - 2 * footermargin
      local x0 = footermargin
      local x00 = 0
      local label = {
         w = 100*scalerate,
         h = 40 * scalerate,
         font = 30 * scalerate
      }
      
      local label_obj = null

      if (prf.SCROLLERTYPE == "LabelList"){

         w0 = (prf.LOWRES ? (flw-2*footermargin)*0.9 : (flw-2*footermargin)*0.75)
         x0 = (flw-w0) * 0.5
         x00 = 0
         label = {
            w = 100 * scalerate,
            h = 40 * scalerate,
            font = 30 * scalerate
         }

         if (prf.LOWRES){
            label = {
               w = 150 * scalerate,
               h = 70 * scalerate,
               font = 45 * scalerate
            }            
         }

         labelstrip.set_pos (x0,flh-footer_h*0.5-label.h*0.5,w0,label.h)
         labelstrip.set_rgb (themeT.themetextcolor,themeT.themetextcolor,themeT.themetextcolor)
         labelstrip.alpha = 100
         //labelstrip.visible = false

         //labelsurf.set_pos (0,0,w0,label.h)
         labelsurf.add_image("black.png",0,0,w0,label.h)
         foreach (key in labelorder){
            label_obj = labelsurf.add_text(key,x00,0,w0/labelorder.len(),label.h)
            label_obj.char_size = label.font
            label_obj.font = uifonts.gui
            label_obj.margin = 0
            label_obj.align = Align.MiddleCentre
            label_obj.set_rgb (255,255,255)
            label_obj.set_bg_rgb (0,0,0)
            label_obj.bg_alpha = 255
            label_obj.alpha = 255
            x00 = x00 + w0/labelorder.len()
            sortlabels[key] <- label_obj 
            downkey (key)
         }
         labelsurf.set_rgb(themeT.themetextcolor,themeT.themetextcolor,themeT.themetextcolor)
         labelsurf.shader = txtoalpha

         local labelsurf0 = data_surface.add_clone (labelsurf)
         labelsurf0.set_pos(x0,flh-footer_h*0.5-label.h*0.5)
         labelsurf.visible = false
      if (prf.SCROLLERTYPE == "LabelList") upkey (gamesorter(0))   
      }        

      if (prf.SCROLLERTYPE == "Timeline"){
         labelstrip.set_pos(x0,flh - footer_h * 0.5,w0,label.h)
         labelstrip.set_rgb (themeT.themetextcolor,themeT.themetextcolor,themeT.themetextcolor)
         labelstrip.alpha = 100
         //labelstrip.visible = false
         foreach (key in labelorder){
            i=1 // REMOVE FOR ALTERNATING LETTERS
            local labelspacer = labelcounter[key]*w0/fe.list.size
            label_obj = data_surface.add_text(key,x0 + labelspacer*0.5 - label.w*0.5, flh - footer_h * 0.5 , label.w,label.h)
            local tick_obj = data_surface.add_image("white.png",x0,flh - footer_h * 0.5 - 0.5*label.h*0.5,1,0.5*label.h+1)
            label_obj.char_size = label.font
            label_obj.font = uifonts.lite
            label_obj.margin = 0
            label_obj.align = Align.MiddleCentre
            label_obj.set_rgb (themeT.themetextcolor,themeT.themetextcolor,themeT.themetextcolor)
            tick_obj.set_rgb (themeT.themetextcolor,themeT.themetextcolor,themeT.themetextcolor)
            i++
            label_obj.visible = !( (labelspacer < 0.5*label.h) || ((fe.list.search_rule != "") && (abs(x0-flw*0.5) < 10*scalerate*fe.list.search_rule.len())))
            x0 = x0 + labelspacer
            sortlabels[key] <- label_obj
            sortticks[key] <- tick_obj
         }

         if (labelorder.len() != 0) sortticks[labelorder[0]].visible = false

      }
   }
   


   // UPDATE TILES FROM OLD SELECTION
   if (ttype == Transition.FromOldSelection) {
      updatebgsnap (newfocusindex)
      //squarizer = true
   }


   // UPDATE GAME DATA
   if ((ttype == Transition.StartLayout) || (ttype == Transition.ToNewList) ){
      if (!prf.DISPLAYMENUON) dat.manufacturer_array[dat.stacksize - 1].file_name = manufacturer_pic (0)
      if (!prf.DISPLAYMENUON) dat.cat_array[dat.stacksize - 1].file_name = category_pic (0)
      dat.manufacturername_array[dat.stacksize - 1].visible = (dat.manufacturer_array[dat.stacksize - 1].subimg_width == 0)
      dat.but_array[dat.stacksize - 1].file_name = (prf.DISPLAYMENUON ? "white.png" : "button_images/" + fe.game_info(Info.Buttons, 0)+"button.png")
      dat.ply_array[dat.stacksize - 1].file_name = (prf.DISPLAYMENUON ? "white.png" :"players_images/players_" + fe.game_info(Info.Players,0)+".png")
      dat.ctl_array[dat.stacksize - 1].file_name = (prf.DISPLAYMENUON ? "white.png" : controller_pic (0))

      updatebgsnap (newfocusindex)   
   }


   // cleanup frosted glass grabs when exiting AM
   if ((prf.FROSTEDGLASS) && (ttype == Transition.EndLayout) && (var0 == FromTo.Frontend)){
      for (local ig = 0; ig < frg.numgrabs ; ig++){
         remove(frg.createdgrabs[ig])
      }
   }


   // some fixes for the tags menu
   if (ttype == Transition.ShowOverlay){
      if (var0 == Overlay.Tags) tags.menu = true
      overlay_show() 
   }

   if (ttype == Transition.HideOverlay){
      display_surface.visible = display_surface_sh.visible = false
      prf.DISPLAYLISTON = false
      overlay_listbox.width = flw
      display_surface_sh.shader = noshader
      display_surface_sh1.shader = noshader

      overlay_hide()
      // TEST ADD THIS FOR FAVS?      zoompos = 1 
      if (tags.menu) {
         tags.menu = false
         tilesTableZoom[newfocusindex] = [0.8,0.8,0.8,0.04,0.0]
         tags.decor = true
         tags.decortr = true
      }
   }
   
   // var is updated only if we are going to a new selection
   if (ttype == Transition.ToNewSelection) var = var0
   
   // scroller is always updated		
   scroller.x = footermargin + ((fe.list.index/rows)*rows*1.0/(fe.list.size - 1 ))*(flw - 2.0*footermargin-scrollersize)
   scroller2.x = scroller.x-scrollersize*0.5


   // RESET TILES WHEN GOING TO NEW LIST
   if ((ttype == Transition.ToNewList)) {
      // Reset vars and positions
      debugpr ("TRANSBLOCK 1 - TNL - RESET VAR CENTERCORRECTION ETC \n")
      var = 0
      tilesTablePos.Offset = 0
      surfacePos = 0.5
      column.offset = 0
      centercorrection = 0
      centercorrectionshift = centercorrection0

      // loop for all tiles
      for ( local i = 0; i < tiles.total ; i++ ) {
         // reset gradient data
         //print("C")
         //update_gradient(i)

         // reset video fade data
         if  (prf.THUMBVIDEO)  {
            vidszTable[i].alpha = 0
            vid2zTable[i].alpha = 0
            vidpos[i] = 0
            vidszTableFade[i]=[0.0,0.0,0.0,0.0,0.0]
            vidszTable[i].file_name = "transparent.png"              
         }  

         // cleanup position of tiles
         picsize (tilesTable[i] , widthpadded, heightpadded,0,-0.025)
         tilesTable[i].zorder = -2
         tilesTableZoom[i] = [0.0,0.0,0.0,0.0,0.0]
         bd_mxTable[i].alpha = 0
         glomxTable[i].alpha = 0
      }         
   }


   // UPDATE TILES DATA AND POSITION
   if ((ttype == Transition.ToNewList) || (ttype == Transition.ToNewSelection) ) {
      debugpr ("TRANSBLOCK 2 - TNL TNS - UPDATE TILES \n")
     
      corrector = (rows == 1 ? -1 : -((fe.list.index + var) % rows) )

      column.stop = floor((fe.list.index + var)*1.0/rows)
      column.start = floor((fe.list.index)*1.0/rows)
           
      column.offset = (column.stop - column.start)
      tilesTablePos.Offset += column.offset*rows

      local index = - (floor(tiles.total/2) -1) + corrector 

      // Determine center position correction when reaching beginning or end of list
      centercorrectionshift = 0	
      centercorrection = 0

      if ((column.stop < deltacol) && (var < 0) ) {
         if (column.stop == deltacol - 1 ) 
            centercorrectionshift = centercorrection0 + (deltacol - 1)*(width+padding)
         else 
            centercorrectionshift = - (width+padding)
      }
      else if ((column.start < deltacol) && (var > 0)) {
         if (column.start == deltacol - 1 ) 
            centercorrectionshift = - centercorrection0 - (deltacol - 1)* (width+padding)
         else 
            centercorrectionshift = (width+padding)
      }

      if (fe.list.index + var <= deltacol*rows -1){
         centercorrection = centercorrection0 + ((fe.list.index + var)/rows)*(width+padding)
      }
      
      if (column.offset == 0) centercorrectionshift = 0

      // updates all the tiles
      debugpr ("TRANSBLOCK 2 - TNL TNS - CHANGE ALL TILES \n")	

      for ( local i = 0; i < tiles.total ; i++ ) {   

         local indexTemp = wrap( i + tilesTablePos.Offset, tiles.total )

         offseTable[indexTemp] = index

         //txshzTable[indexTemp].index_offset = txt1zTable[indexTemp].index_offset = index
         //txt1zTable[indexTemp].char_size = 300.0/txt1zTable[indexTemp].msg.find("\\n")
         //txshzTable[indexTemp].char_size = 10.0
         
         //txt1zTable[indexTemp].char_size = 2000.0/txshzTable[indexTemp].msg_width   

         
         if ((ttype == Transition.ToNewList) || ((ttype == Transition.ToNewSelection) && (( ( (column.stop>column.start) && (i/rows >= tiles.total/rows - column.offset) ) || ( (column.stop < column.start) && (i/rows < -column.offset) ))))) {
            loshzTable[indexTemp].file_name = fe.get_art("wheel" , index + var,0,Art.ImagesOnly)
            gradzTable[indexTemp].file_name = fe.get_art((prf.BOXARTMODE ? "flyer" : "snap") , index + var,0,Art.ImagesOnly)
            //RESIZER

            logotitle = wrapme( fe.game_info (Info.Title, index+var) ,9,3)
            txt2zTable[indexTemp].msg = txt1zTable[indexTemp].msg = txshzTable[indexTemp].msg = logotitle.text

            txshzTable[indexTemp].char_size  = min( ((txshzTable[indexTemp].width*100.0/600.0)*9)/logotitle.cols ,  ((txshzTable[indexTemp].width*100.0/600.0)*3)/logotitle.rows )
            txt2zTable[indexTemp].char_size = txt1zTable[indexTemp].char_size = txshzTable[indexTemp].char_size * txt1zTable[indexTemp].width / txshzTable[indexTemp].width

            txt2zTable[indexTemp].x = txt1zTable[indexTemp].x + 0.015 * txt1zTable[indexTemp].char_size
            txt2zTable[indexTemp].y = txt1zTable[indexTemp].y - 0.025 * txt1zTable[indexTemp].char_size

            update_snapcrop (indexTemp , var, ishorizgame(offseTable[indexTemp],snapzTable[indexTemp],var,prf.BOXARTMODE))
         

            local horizgame = ishorizgame(offseTable[indexTemp],snapzTable[indexTemp],var,prf.BOXARTMODE)
            // Update visibility of horizontal or vertical shadows, glow, indicator etc
            update_thumbdecor(indexTemp,var,horizgame)
            if (bd_mxTable[indexTemp].alpha != 0) update_borderglow(indexTemp,var,horizgame)
         

         }
         
         tilesTable[indexTemp].zorder = -2


         tilesTablePos.X[indexTemp] = (i/rows) * (width+padding) + carrierT.x + centercorrection + widthpadded*0.5
         tilesTablePos.Y[indexTemp] = (i%rows) * (height + padding) + carrierT.y + verticalshift + widthpadded*0.5

         tilesTable[indexTemp].visible = (( (fe.list.index + var + index < 0) || (fe.list.index + var + index > fe.list.size-1) ) == false)

         index++
      }
      
      // updates the size and features of the previously selected item and new selected item
      newfocusindex = wrap( floor(tiles.total/2)-1-corrector + tilesTablePos.Offset, tiles.total )
      oldfocusindex = wrap( floor(tiles.total/2)-1-corrector -var + tilesTablePos.Offset, tiles.total )

      tilesTableZoom[oldfocusindex] = startfade (tilesTableZoom[oldfocusindex],-0.055,1.0)
      tilesTableZoom[newfocusindex] = startfade (tilesTableZoom[newfocusindex],0.035,-5.0)
 
      //activate video load counter
      if ((prf.THUMBVIDEO) ){
         vidszTableFade[oldfocusindex] = startfade (vidszTableFade[oldfocusindex],-0.01,1.0)
         vidpos[oldfocusindex] = 0

         if (vidszTable[newfocusindex].alpha == 0) {
            vidpos[newfocusindex] = vidstarter
            vidindex[newfocusindex] = offseTable[newfocusindex] 
         }
         else {
            vidszTableFade[newfocusindex] = startfade (vidszTableFade[newfocusindex],0.03,1.0)
         }
      }
      tilesTable[oldfocusindex].zorder = -2
      tilesTable[newfocusindex].zorder = -1
      letterobj.zorder = 0
      
      //favezTable[newfocusindex].visible = (fe.game_info(Info.Favourite, offseTable[newfocusindex]+var) == "1")		
      //donezTable[newfocusindex].visible = ((fe.game_info(Info.Tags, offseTable[newfocusindex]+var)).find("Completed") != null)
       
      local horizgame = ishorizgame(offseTable[newfocusindex],snapzTable[newfocusindex],var,prf.BOXARTMODE)

      // Update decorations related to newly focused index image
      update_borderglow(newfocusindex,0,horizgame)


      // trigger squaring of background thumbs
      squarizer = true
   }
   
   // if the transition is to a new selection initialize crossfade, scrolling and surfacepos
   if( (ttype == Transition.ToNewSelection) ){
      
      debugpr ("TRANSBLOCK 3.0 - TNS - TRANSITION TO NEW SELECTION ONLY \n")

      local l1 = gameletter (0)
      local l2 = gameletter(var)
      
      if (l1 != l2){
         fade.letter = 1
      }

      //bgs.bgpic_array[0].file_name = fe.get_art((prf.BOXARTMODE ? "flyer" : "snap") , loshzTable[newfocusindex].index_offset+var,0,Art.ImagesOnly)

      for (local i = 0; i < bgs.stacksize-1;i++){
         bgs.bgpic_array[i].swap(bgs.bgpic_array[i+1])
         bgs.alphapos[i] = bgs.alphapos[i+1]
         bgs.bg_lcd[i] = bgs.bg_lcd[i+1]
         bgs.bg_mono[i] = bgs.bg_mono[i+1]
      }


      //TEST50
    //  updatebgsnap (oldfocusindex)
    //  squarizer = true


      for (local i = 0; i < dat.stacksize - 2;i++){
         dat.var_array[i] = - var + dat.var_array[i+1]
      }
      dat.var_array [dat.stacksize - 1] = 0
      dat.var_array [dat.stacksize - 2] = - var 

      for (local i=0 ; i< dat.stacksize -1 ; i++){
         //			dat.manufacturer_array[i].rawset_index_offset(dat.var_array[i])
         //			dat.cat_array[i].rawset_index_offset(dat.var_array[i])

         dat.manufacturer_array[i].swap (dat.manufacturer_array[i+1])
         dat.cat_array[i].swap (dat.cat_array[i+1])
         dat.but_array[i].swap (dat.but_array[i+1])
         dat.ply_array[i].swap (dat.ply_array[i+1])
         dat.ctl_array[i].swap (dat.ctl_array[i+1])

         dat.mainctg_array[i].index_offset = dat.var_array[i]
         dat.gamename_array[i].index_offset = dat.var_array[i]
         dat.gamesubname_array[i].index_offset = dat.var_array[i]
         dat.gameyear_array[i].index_offset = dat.var_array[i]
         dat.manufacturername_array[i].index_offset = dat.var_array[i]

         dat.manufacturername_array[i].visible = (dat.manufacturer_array[i].subimg_width == 0)

         if (i != dat.stacksize -2 )
            dat.alphapos[i] = dat.alphapos[i+1]
         else
            dat.alphapos[i] = 1.0 - dat.alphapos[i+1]
      }

      if (!prf.DISPLAYMENUON) dat.manufacturer_array[dat.stacksize - 1].file_name = manufacturer_pic (var) 
      if (!prf.DISPLAYMENUON) dat.cat_array[dat.stacksize - 1].file_name = category_pic (var)
      dat.manufacturername_array[dat.stacksize - 1].visible = (dat.manufacturer_array[dat.stacksize - 1].subimg_width == 0)
      dat.but_array[dat.stacksize - 1].file_name = (prf.DISPLAYMENUON ? "white.png" :"button_images/"+fe.game_info(Info.Buttons, var)+"button.png")
      dat.ply_array[dat.stacksize - 1].file_name = (prf.DISPLAYMENUON ? "white.png" :"players_images/players_" + fe.game_info (Info.Players , var)+".png")
      dat.ctl_array[dat.stacksize - 1].file_name = (prf.DISPLAYMENUON ? "white.png" :controller_pic (var))
      dat.alphapos [dat.stacksize - 1] = 1

      bgs.alphapos [bgs.stacksize - 1]= 255
      
      surfacePos += (column.offset * (width + padding) ) - centercorrectionshift
      
   }

   return false
}


/// On Tick  
function tick( tick_time ) {

   
   if (tags.decor == true){
      update_thumbdecor (newfocusindex,0,ishorizgame(offseTable[newfocusindex],snapzTable[newfocusindex],0,prf.BOXARTMODE))
      tags.decor = false
   }

   if (disp.starter){
      foreach (bob in disp.items){
         local extension = bob.file_name.slice (bob.file_name.len()-3,bob.file_name.len())
         if ( extension.tolower( )!= "png") {
            local sizew = min(bob.texture_width,bob.texture_height)
            bob.subimg_width = sizew
            bob.subimg_height = sizew
            bob.subimg_x = (bob.texture_width - sizew )*0.5
            bob.subimg_y = (bob.texture_height - sizew )*0.5
         }
      }
      disp.starter = false
   }


   if (disp.xstart != disp.xstop){
     disp.speed = (0.2 * (disp.xstop - disp.xstart))
      if (absf(disp.speed) > 0.0005*disp.tile) {

         if ((absf(disp.xstart - disp.xstop)) > disp.spacing * (fe.displays.len()-2)) {
            disp.xstart = disp.xstop
            for (local i = 0;i <  disp.items.len() ; i++) {
               disp.items[i].y = disp.pos0[i] + disp.xstop 
            }        
         }
         else {
            for (local i = 0;i <  disp.items.len() ; i++) {
               disp.items[i].y = disp.pos0[i] + disp.xstart +  disp.speed 
            }
            disp.xstart = disp.xstart + disp.speed 
         }
      }
      else {
         disp.xstart = disp.xstop
         for (local i = 0;i <  disp.items.len() ; i++) {
            disp.items[i].y = disp.pos0[i] + disp.xstop
         }
      }
   }
   
   // Attract mode management
   if (prf.AMENABLE) {

      if (attract.start){
         // block theme videos and set snap audio
         if (prf.LAYERVIDEO) bgs.bgvid_array[bgs.stacksize - 1].video_playing = false
         if (prf.THUMBVIDEO) vidszTable[newfocusindex].video_playing = false
         if (!attract.sound) attract_snap.video_flags = Vid.NoAudio

         if(prf.AMTUNE != "") snd.attracttune.playing=true

         attract.start = false
         attract.rolltext = true
         attract.gametimer = true
         //attract.updatesnap = true
         attractupdatesnap()
         attract.timer = tick_time
      }

      if (attract.rolltext){
         attract_text2.alpha = 255*(0.5+0.5*cos(tick_time/500.0))
         attract_text.alpha =  attract.textshadow * attract_text2.alpha / 255
      }

      if (attract.gametimer){
         if ((tick_time - attract.timer) > attract.game_interval){
            flowT.gametoblack = startfade (flowT.gametoblack,0.1,0.0)
         }         
      }

      if (attract.starttimer){
         if ((tick_time - attract.timer) > attract.attract_interval){
            attractkick()
         }
      }
   }

   // Apply square screen cropping for background artwork
   if (squarizer){
      squarizer = false
      squarebg()
   }

   if ((count.right != 0) && (fe.get_input_state("right")==false)){
      count.right = 0
   }
   
   if ((count.left != 0) && (fe.get_input_state("left")==false)){
      count.left = 0
   }
   
   // crossfade of the blurred background
   for (local i = 0 ; i < bgs.stacksize ; i++){
      if (bgs.alphapos[i] !=0){
         if ((bgs.alphapos[i] < 1) && (bgs.alphapos[i] > -1) ) bgs.alphapos[i] = 0
         bgs.alphapos[i] = bgs.alphapos[i] * spdT.bgfadespeed
         bgs.bgpic_array[i].alpha = 255-bgs.alphapos[i]
         if (prf.LAYERSNAP) bgs.bgvid_array[i].alpha = 255-bgs.alphapos[i] 
      }
   }

   // fading of the initial letter of the name
   if (fade.letter != 0){
      if(fade.letter < 0.01) fade.letter = 0
      fade.letter = fade.letter * spdT.letterspeed
      letterobj.alpha = 255*(1-4.0*pow((0.5-fade.letter),2))
      letterobj.charsize = lettersize.name * (1.0 + 0.5*pow((1-fade.letter),2))
   }

   // fading of the initial letter of the name
   if (fade.display != 0){
      if(fade.display < 0.001) fade.display = 0
      fade.display = fade.display * spdT.displayspeed
      displayname.alpha = 255*(1.0 - 4.0*pow((0.5-fade.display),2))
   }

   if (fade.displayzoom != 0){
      if(fade.displayzoom < 0.001) fade.displayzoom = 0
      fade.displayzoom = fade.displayzoom * spdT.displayzoomspeed
      displayname.charsize = lettersize.display * (1.0 + 0.5*pow((1.0-fade.displayzoom),2))
   }

   // Manage tiles zoom and unzoom
   for(local i = 0 ; i < tiles.total ; i++){
      if (checkfade(tilesTableZoom[i])){
         tilesTableZoom[i] = fadeupdate(tilesTableZoom[i])
         local zoomtemp = tilesTableZoom[i]
         if ((zoomtemp[1] + zoomtemp[3] < 0) || (zoomtemp[1] + zoomtemp[3] > 1)){
            tilesTableZoom[i] = (zoomtemp[3] > 0 ? [1.0,1.0,1.0,0.0,0.0] : [0.0,0.0,0.0,0.0,0.0])
            zoomtemp = tilesTableZoom[i]
         }

         // hide glow image and border image when zero is reached
         if ((zoomtemp[1] == 0)){
            glomxTable[i].visible = false
            glomxTable[i].shader = noshader
            bd_mxTable[i].visible = false
         }

         // update size and glow alpha
         picsize(tilesTable[i], widthpadded + (selectorwidth-widthpadded)*(zoomtemp[1]), widthpadded + (selectorwidth-widthpadded)*(zoomtemp[1]) , 0, -0.025)
         if (zoomtemp[3] < 0){ 
            glomxTable[i].alpha = 255*pow(zoomtemp[1],5)
            bd_mxTable[i].alpha = 240*pow(zoomtemp[1],5)
          //  vidszTable[i].alpha = vid2zTable[i].alpha = 255*(zoomtemp[1])
         }
         else{
            glomxTable[i].alpha = 255*(zoomtemp[1])
            bd_mxTable[i].alpha = 240*(zoomtemp[1])
         }
      }
   }


   // Manage video fade and unfade
   for(local i = 0 ; i < tiles.total ; i++){
      if (checkfade(vidszTableFade[i])){
         vidszTableFade[i] = fadeupdate(vidszTableFade[i])
         local fadetemp = vidszTableFade[i]
         if ((fadetemp[1] + fadetemp[3] < 0) || (fadetemp[1] + fadetemp[3] > 1)){
            vidszTableFade[i] = (fadetemp[3] > 0 ? [1.0,1.0,1.0,0.0,0.0] : [0.0,0.0,0.0,0.0,0.0])
            fadetemp = vidszTableFade[i]
         }

         // hide glow image and border image when zero is reached
         if ((fadetemp[1] == 0)){
               vidszTable[i].file_name = "transparent.png"
               vidszTable[i].alpha = 0
         }

         // update size and glow alpha
         vidszTable[i].alpha = vid2zTable[i].alpha = 255*(fadetemp[1])
      }
   }


   // crossfade of game data
   for (local i = 0 ; i < dat.stacksize ; i++){
      if (dat.alphapos[i] != 0 ){
         if ((dat.alphapos[i] <0.01) && (dat.alphapos[i] > -0.01)) dat.alphapos[i] = 0

         if (i != dat.stacksize -1){
            dat.alphapos[i] = dat.alphapos[i] * spdT.dataspeedout
            dat.ply_array[i].alpha = dat.ctl_array[i].alpha = dat.but_array[i].alpha = dat.cat_array[i].alpha = dat.mainctg_array[i].alpha = dat.manufacturer_array[i].alpha = dat.gamename_array[i].alpha = dat.gamesubname_array[i].alpha = dat.manufacturername_array[i].alpha = dat.gameyear_array[i].alpha = 255 * (dat.alphapos[i])*1.0
         }
         else {
            dat.alphapos[dat.stacksize -1] = dat.alphapos[dat.stacksize - 1] * spdT.dataspeedin
            dat.ply_array[i].alpha = dat.ctl_array[i].alpha = dat.but_array[dat.stacksize - 1].alpha = dat.cat_array[dat.stacksize - 1].alpha = dat.mainctg_array[dat.stacksize - 1].alpha = dat.manufacturer_array[dat.stacksize - 1].alpha = dat.gamename_array[dat.stacksize - 1].alpha = dat.gamesubname_array[dat.stacksize - 1].alpha =  dat.manufacturername_array[dat.stacksize - 1].alpha =dat.gameyear_array[dat.stacksize - 1].alpha = 255 * (1.0 - dat.alphapos[dat.stacksize - 1])*1.0
         }
      }
   }

   // tiles scrolling
   if ((surfacePos != 0)) {	
      
      if ((surfacePos < 0.1) && (surfacePos > -0.1)) surfacePos = 0      
      surfacePos = surfacePos * spdT.scrollspeed

      if (surfacePos > surfacePosOffset) surfacePos = surfacePosOffset
      if (surfacePos < -surfacePosOffset) surfacePos = -surfacePosOffset
      
      // repositioning of tiles		
      for ( local i = 0; i < tiles.total; i++ ) {
         tilesTable[i].x = surfacePos - surfacePosOffset + tilesTablePos.X[i]
         tilesTable[i].y = tilesTablePos.Y[i]
      }

      globalposnew = tilesTable[newfocusindex].x 
   }

   // crossfade of video snaps, tailored to skip initial fade in
   for (local i = 0 ; i < tiles.total; i++){  
      if ( vidpos[i] != 0 ) {
         vidpos[i] = vidpos[i] - 1
         //if (vidpos[i] == 0) vidpos[i] = 0
         // newfocusindex = wrap( tiles.total/2-1-corrector + tilesTablePos.Offset, tiles.total )

         if ((vidpos[i] == delayvid) ){
            //vidszTable[newfocusindex].visible = true
            if ((prf.THUMBVIDEO)){
               vidszTable[i].file_name = fe.get_art("snap",vidindex[i])
               if ((prf.AUDIOVIDSNAPS) && (!history_visible())) vidszTable[i].video_flags = Vid.Default
            }
            if (prf.AMENABLE) {
               if (attract.rolltext) vidszTable[i].video_playing = false
            }

            vidszTable[i].alpha = vid2zTable[i].alpha = 0		

            vid2zTable[i].set_pos(snapzTable[i].x,snapzTable[i].y,snapzTable[i].width,snapzTable[i].height)

            local horizgame = ishorizgame(offseTable[i],snapzTable[i],0,prf.BOXARTMODE)

            if ((prf.CROPSNAPS) && (!prf.BOXARTMODE)){
               vid2zTable[i].subimg_width = vidszTable[i].subimg_width = vid2zTable[i].subimg_height = vidszTable[i].subimg_height = min(vidszTable[i].texture_height,vidszTable[i].texture_width)             
            }
            else if (prf.BOXARTMODE)
            {
               if (horizgame == true){
                  vid2zTable[i].subimg_width = vidszTable[i].subimg_width = vidszTable[i].texture_width
                  vid2zTable[i].subimg_height = vidszTable[i].subimg_height = vidszTable[i].texture_width*3.0/4.0
               }
               if (horizgame == false){
                  vid2zTable[i].subimg_height = vidszTable[i].subimg_height = vidszTable[i].texture_height
                  vid2zTable[i].subimg_width = vidszTable[i].subimg_width = vidszTable[i].texture_height*3.0/4.0            
               }
               if (horizgame == null){                  
                  vid2zTable[i].subimg_width = vidszTable[i].subimg_width = vidszTable[i].subimg_height = vid2zTable[i].subimg_height =min(vidszTable[i].texture_width,vidszTable[i].texture_height)
               }
            }
            else 
            {
               if (horizgame == true){
                  vid2zTable[i].subimg_width = vidszTable[i].subimg_width = vidszTable[i].texture_height*4.0/3.0
                  vid2zTable[i].subimg_height = vidszTable[i].subimg_height = vidszTable[i].texture_height
               }
               if (horizgame == false){
                  vid2zTable[i].subimg_height = vidszTable[i].subimg_height = vidszTable[i].texture_width*4.0/3.0
                  vid2zTable[i].subimg_width = vidszTable[i].subimg_width = vidszTable[i].texture_width            
               }
               if (horizgame == null){
                  vid2zTable[i].subimg_width = vidszTable[i].subimg_width = vidszTable[i].subimg_height = vid2zTable[i].subimg_height =min(vidszTable[i].texture_width,vidszTable[i].texture_height)
               }
            }
   
            vid2zTable[i].subimg_x = vidszTable[i].subimg_x = 0.5*(vidszTable[i].texture_width - vidszTable[i].subimg_width)
            vid2zTable[i].subimg_y = vidszTable[i].subimg_y = 0.5*(vidszTable[i].texture_height - vidszTable[i].subimg_height)

         }
         
         if (vidpos[i] == fadevid){
            vidszTableFade[i] = startfade (vidszTableFade[i],0.03,1.0)
            vidpos[i] = 0
            //vidszTable[i].alpha = vid2zTable[i].alpha = 255.0*(1-0.01*vidpos[i]*(1/fadevid))
            //else
            //vidszTable[newfocusindex].alpha = vid2zTable[newfocusindex].alpha = 0
         }
      }

   }
   
   // screen grabbing for frosted surface
	if (frg.grabdither != 0) {
		frg.grabdither --
		pixelpic.x = frg.grabdither
      if (prf.FROSTEDGLASS){
         if (frost.top.file_name != "transparent.png") frost.top.file_name = "transparent.png" 
	   }
   }

	if (frg.grabticker != 0)
	{
		frg.grabticker --
		if (frg.grabticker == 0){
			try{
            rename (frg.firstpath,frg.grabpath)
         } catch (err) {}
         frost.pic.file_name = frg.grabpath

         frost.top.alpha = 255
         flowT.frostfade = [1.0,1.0,1.0,0.0,0.0]
         frost.top.file_name = frg.grabpath
         flowT.frostfade = startfade (flowT.frostfade, -0.1,0.0)
			if (rotate90){
				
			}
		frg.immediatesignal = true
		fe.signal(frg.grabsignal)
		}
	}

   // context menu fade in fade out

	if ((overmenu.visible) && (flowT.overmenu[3] >= 0) && (surfacePos != 0)) {
		overmenu.x = globalposnew  - overmenuwidth*0.5 
	}


   if (checkfade (flowT.frostfade)){
      flowT.frostfade = fadeupdate(flowT.frostfade)
      if ((flowT.frostfade[1] + flowT.frostfade[3] < 0) || (flowT.frostfade[1] + flowT.frostfade[3] > 1)){
         flowT.frostfade = (flowT.frostfade[3] > 0 ? [1.0,1.0,1.0,0.0,0.0] : [0.0,0.0,0.0,0.0,0.0])
      }
      frost.top.alpha = 255  * (flowT.frostfade[1])
   }


   if (checkfade (flowT.historyblack)){
      flowT.historyblack = fadeupdate(flowT.historyblack)

      if ((flowT.historyblack[1] + flowT.historyblack[3] < 0) || (flowT.historyblack[1] + flowT.historyblack[3] > 1)){
         flowT.historyblack = (flowT.historyblack[3] > 0 ? [1.0,1.0,1.0,0.0,0.0] : [0.0,0.0,0.0,0.0,0.0])
         if (flowT.historyblack[1] == 1) {
            // history_updatesnap()
            flowT.historyblack = startfade (flowT.historyblack,-flowT.historyscroll[3]*2.0,0.0)
         }       
      }

      hist_screensurf.set_rgb (255  * (1.0 - flowT.historyblack[1]),255  * (1.0 - flowT.historyblack[1]),255  * (1.0 - flowT.historyblack[1]))
      hist_glow_pic.set_rgb (255  * (1.0 - flowT.historyblack[1]),255  * (1.0 - flowT.historyblack[1]),255  * (1.0 - flowT.historyblack[1]))      
      hist_glow_pic.alpha =  hist_screensurf.alpha = 255  * (1.0 - flowT.historyblack[1])

   }

   if (checkfade (flowT.historyscroll)){
      flowT.historyscroll = fadeupdate(flowT.historyscroll)

      if ((flowT.historyscroll[1] + flowT.historyscroll[3] < 0) || (flowT.historyscroll[1] + flowT.historyscroll[3] > 1)){
         flowT.historyscroll = (flowT.historyscroll[3] > 0 ? [1.0,1.0,1.0,0.0,0.0] : [0.0,0.0,0.0,0.0,0.0])
         if (flowT.historyscroll[1] == 1) {
            history_updatesnap()
            scrollreset = false
            flowT.historyscroll = [0.0,0.0,0.0,0.0751,0.0]
         } 
      }

      if ((flowT.historyscroll[1] < 0.5) && (flowT.historyscroll[1] > 0.5 - flowT.historyscroll[3]) && (!scrollreset)) flowT.historyscroll = [0.5,0.5,0.5,0.0,0.0]

      if (!vertical){
         hist_screensurf.y = hist_screenT.y + historypadding - hist_direction * 1.50 * flh * (flowT.historyscroll[1] - 0.5)
         shadowsurf2.y =  histglow.y - shadow.radius  - hist_direction * 1.50 * flh * (flowT.historyscroll[1] - 0.5)
      }
      else
      {
         hist_screensurf.x = hist_screenT.x + historypadding - hist_direction * 1.50 * flw * (flowT.historyscroll[1] - 0.5)
         shadowsurf2.x =  histglow.x - shadow.radius - hist_direction * 1.50 * flw * (flowT.historyscroll[1] - 0.5)  
      }
   }


   if (checkfade (flowT.historydata)){
      flowT.historydata = fadeupdate(flowT.historydata)

      if ((flowT.historydata[1] + flowT.historydata[3] < 0) || (flowT.historydata[1] + flowT.historydata[3] > 1)){
         flowT.historydata = (flowT.historydata[3] > 0 ? [1.0,1.0,1.0,0.0,0.0] : [0.0,0.0,0.0,0.0,0.0])
         if (flowT.historydata[1] == 1) {
            history_updatetext()
            flowT.historydata = startfade (flowT.historydata,-0.101,3.0)
         }    
      }

      hist_text.alpha = 255  * (1.0 - flowT.historydata[1])

      if (prf.HISTORYPANEL) {
         hist_titletxt_bot.alpha = hist_title.alpha = hist_titleT.transparency  * (1.0 - flowT.historydata[1])
         hist_titletxt_bd.alpha = hist_titletxt.alpha = hist_title_top.alpha = 255  * (1.0 - flowT.historydata[1])
      }
      else {
         hist_titletxt_bd.alpha = hist_titletxt.alpha = hist_title.alpha = 255  * (1.0 - flowT.historydata[1])
      }

   }


   if (checkfade(flowT.overmenu)){
      flowT.overmenu = fadeupdate(flowT.overmenu)

      if ((flowT.overmenu[1] + flowT.overmenu[3] < 0) || (flowT.overmenu[1] + flowT.overmenu[3] > 1)){
         flowT.overmenu = (flowT.overmenu[3] > 0 ? [1.0,1.0,1.0,0.0,0.0] : [0.0,0.0,0.0,0.0,0.0])
         if (flowT.overmenu[1] == 0) {
            overmenu.visible = false
         }
      }

      overmenu.alpha = 255  * flowT.overmenu[1]
   }

   // splash logo fade in fade out
   if (checkfade(flowT.logo)){
      flowT.logo = fadeupdate(flowT.logo)

      if ((flowT.logo[1] + flowT.logo[3] < 0) || (flowT.logo[1] + flowT.logo[3] > 1)){
         flowT.logo = (flowT.logo[3] > 0 ? [1.0,1.0,1.0,0.0,0.0] : [0.0,0.0,0.0,0.0,0.0])
      }

      aflogo_surface.alpha = 255  * flowT.logo[1]
   }


   // data surface fade in and fade out
   if (checkfade(flowT.data)){
      flowT.data = fadeupdate(flowT.data)

      if ((flowT.data[1] + flowT.data[3] < 0) || (flowT.data[1] + flowT.data[3] > 1)){
         flowT.data = (flowT.data[3] > 0 ? [1.0,1.0,1.0,0.0,0.0] : [0.0,0.0,0.0,0.0,0.0])
      }

      data_surface.alpha = 255  * flowT.data[1]
	   data_surface_sh.alpha = themeT.themeshadow * flowT.data[1]
   }

   // foreground surface fade in and fade out
   if (checkfade(flowT.fg)){
      flowT.fg = fadeupdate(flowT.fg)

      if ((flowT.fg[1] + flowT.fg[3] < 0) || (flowT.fg[1] + flowT.fg[3] > 1)){
         flowT.fg = (flowT.fg[3] > 0 ? [1.0,1.0,1.0,0.0,0.0] : [0.0,0.0,0.0,0.0,0.0])
      }
      fg_surface.alpha = 255  * flowT.fg[1]
   }

   // attract mode surface fade
   if (checkfade(flowT.attract)){
      flowT.attract = fadeupdate(flowT.attract)

      if ((flowT.attract[1] + flowT.attract[3] < 0) || (flowT.attract[1] + flowT.attract[3] > 1)){
         flowT.attract = (flowT.attract[3] > 0 ? [1.0,1.0,1.0,0.0,0.0] : [0.0,0.0,0.0,0.0,0.0])
         
         if (flowT.attract[1] == 0) {
            attract_snap.file_name = "transparent.png"
            attract_snap.shader = noshader
            attract_surface.visible = false
            attract_text.visible = attract_text2.visible = false
            attract.starttimer = true
            if(prf.AMTUNE != "") snd.attracttune.playing=false

         }
      }
      attract_surface.alpha = attract_text2.alpha = 255  * flowT.attract[1]
      attract_text.alpha = attract.textshadow * flowT.attract[1]
   }

   // Fade to black games in attract mode
   if (checkfade(flowT.gametoblack)){
      
      flowT.gametoblack = fadeupdate(flowT.gametoblack)

      if ((flowT.gametoblack[1] + flowT.gametoblack[3] < 0) || (flowT.gametoblack[1] + flowT.gametoblack[3] > 1)){
         flowT.gametoblack = (flowT.gametoblack[3] > 0 ? [1.0,1.0,1.0,0.0,0.0] : [0.0,0.0,0.0,0.0,0.0])
         if (flowT.gametoblack[1] == 1) {

            attract_snap.alpha = 255
            attractupdatesnap()
            attract.timer = tick_time
            flowT.gametoblack = startfade (flowT.gametoblack,-0.02,0.0)
         }
      }
      attract_black.bg_alpha = 255 * flowT.gametoblack[1]
   }

   // Fade whole layout from black
   if (checkfade(flowT.blacker)){
      flowT.blacker = fadeupdate(flowT.blacker)

      if ((flowT.blacker[1] + flowT.blacker[3] < 0) || (flowT.blacker[1] + flowT.blacker[3] > 1)){
         flowT.blacker = (flowT.blacker[3] > 0 ? [1.0,1.0,1.0,0.0,0.0] : [0.0,0.0,0.0,0.0,0.0])
         if (flowT.blacker[1] == 0) {
            layoutblacker.visible = false
            if ((!prf.AMENABLE) || (!prf.AMSTART)) layoutfadein ()

         }
      }
      layoutblacker.alpha = 255 * flowT.blacker[1]
   }

   // history text fade
   if (checkfade(flowT.histtext)){
      flowT.histtext = fadeupdate(flowT.histtext)

      if ((flowT.histtext[1] + flowT.histtext[3] < 0) || (flowT.histtext[1] + flowT.histtext[3] > 1)){
         flowT.histtext = (flowT.histtext[3] > 0 ? [1.0,1.0,1.0,0.0,0.0] : [0.0,0.0,0.0,0.0,0.0])  
      }

      hist_text.y = hist_textT.h * (1.0 - flowT.histtext[1])
   }

   // history page fade in fade out
   if (checkfade(flowT.history)){
      flowT.history = fadeupdate(flowT.history)

      if ((flowT.history[1] + flowT.history[3] < 0) || (flowT.history[1] + flowT.history[3] > 1)){
         flowT.history = (flowT.history[3] > 0 ? [1.0,1.0,1.0,0.0,0.0] : [0.0,0.0,0.0,0.0,0.0])
         if (flowT.history[1] == 0) {
            hist_title.file_name = "transparent.png"
            hist_screen.file_name = "transparent.png"
            hist_screen.shader = noshader
            shadowsurf1.shader = noshader
            shadowsurf2.shader = noshader
            hist_text_surf.shader = noshader
            history_surface.visible = false
         }
      }

      history_surface.alpha = 255  * flowT.history[1]
   }
}


/// On Signal  
function on_signal( sig ){
   debugpr ("\n Si:" + sig )

   if ((sig == "select") && ((prf.DISPLAYMENUON)) ) {
      if (fe.list.index < fe.displays.len()) 
         fe.set_display(fe.list.index)
      else
         fe.signal("exit")
      return true
   }

   if ((sig == prf.SWITCHMODEBUTTON) && (!prf.DISPLAYMENUON)){
      switchmode()
      return true
   }

   //if (sig == "exit") snd.wooshsound.playing = true

   // frosted glass effect signal response
   if (prf.FROSTEDGLASS){

      if (sig == "exit"){
         if (frg.immediatesignal){
            frg.immediatesignal = false
            return false
         }
         else{
            getsnap("exit")
            return true
         }
      }

      if (sig == "filters_menu"){
         if (frg.immediatesignal){
            frg.immediatesignal = false
            return false
         }
         else{
            getsnap("filters_menu")
            return true
         }
      }


      if (sig == "displays_menu"){
         if (frg.immediatesignal){
            frg.immediatesignal = false
            return false
         }
         else{
            getsnap("displays_menu")
            return true
         }
      }

      if (sig == "add_favourite"){
         if (frg.immediatesignal){
            frg.immediatesignal = false
            return false
         }
         else{
            getsnap("add_favourite")
            return true
         }
      }

      if (sig == "add_tags"){
         if (frg.immediatesignal){
            frg.immediatesignal = false
            return false
         }
         else{
            getsnap("add_tags")
            return true
         }
      }
   }

   // rotation controls signal response
   if(sig == "toggle_rotate_right"){
      if (fe.layout.toggle_rotation == RotateScreen.None)
      {
         fe.layout.toggle_rotation = RotateScreen.Right
         fe.signal ("reload")
      }
      else{
         fe.layout.toggle_rotation = RotateScreen.None
         fe.signal ("reload")
      }
      return true
   }

   if(sig == "toggle_rotate_left"){
      if (fe.layout.toggle_rotation == RotateScreen.None)
      {
         fe.layout.toggle_rotation = RotateScreen.Left
         fe.signal ("reload")
      }
      else{
         fe.layout.toggle_rotation = RotateScreen.None
         fe.signal ("reload")
      }
      return true
   }


   // Key response when attract mode is enabled (running or not)
   if (prf.AMENABLE){
      // Resets attract timer so when attract is not running the wait time is reset
      attract.timer = fe.layout.time
      
      if (attract.rolltext){
         // If attract is running stops attract unless we are taking screenshots

         if (sig == "screenshot") return false

         flowT.attract = [1.0,1.0,1.0,-0.09,1.0]
         attract.start = false
         attract.rolltext = false
         attract.gametimer = false

         layoutfadein()
 
         return true
      }

   }


   // context menu signal response
   if (overmenu_visible())
   {
      debugpr (" OVERMENU \n")

      if (sig == "up"){
         
         if (prf.FROSTEDGLASS){
            if (frg.immediatesignal){
            if(prf.THEMEAUDIO) snd.wooshsound.playing=true
               frg.immediatesignal = false
            }
            else{
               getsnap("up")
               return true
            }
         }

         overmenu_hide(true)
         //snd.wooshsound.playing=true
         searchtext =""
         local taglist =  split(fe.game_info(Info.Tags),";")
         local switcharray = [
            "Year",
            "Decade",
            "Manufacturer",
            "Main Category",
            "Sub Category",
            "Orientation",
            "Favourite state",
         ]
         local numset = switcharray.len()
         
         switcharray.extend(         taglist.map (function(value){ return ("TAG: "+value)}) )
         local numtag =  switcharray.len()
         switcharray.push ("RESET")

         local result = fe.overlay.list_dialog(switcharray,"More of the same...")
         
         if(result==numtag){
            //fe.list.index += corrector + rows 
            fe.list.search_rule =""
            searchdata.msg = ""
            if (backs.index != -1){
               fe.list.index = backs.index
               //corrector = backs.corrector
               backs.index = -1
            }					 
         }
         
         if (result == 0) {
            searchtext = "Year contains "+ fe.game_info(Info.Year)
         }

         if (result == 1) {
            searchtext = "Year contains "+ fe.game_info(Info.Year).slice(0,3)
         }

         if (result == 2) {
            searchtext = "Manufacturer contains "+fe.game_info(Info.Manufacturer)
         }

         if (result == 3) {
            searchtext = (fe.game_info(Info.Category))
            local s = split( searchtext, "/" )
            searchtext = "Category contains "+s[0]
         }

         if (result == 4) {	
            searchtext = "Category equals "+fe.game_info(Info.Category)		
         }
         
         if (result == 5) {	
            searchtext = "Rotation equals "+fe.game_info(Info.Rotation)		
         }

         if (result == 6) {	
            searchtext = "Favourite equals "+fe.game_info(Info.Favourite)		
         }

         if ((result >= numset) && (result < numtag)) {
            searchtext = "Tags contains " + taglist[result - numset]
         }

         // GOOD
         if ((result != numtag) && (result != -1)) {
            local currentname = fe.game_info(Info.Name)
            local currentsystem = fe.game_info(Info.System)
            if (backs.index == -1) {
               backs.index = fe.list.index
            }
            fe.list.search_rule = searchtext

            for (local i = 0 ; i < fe.list.size -1;i++){
               if( (fe.game_info(Info.Name,i) == currentname) && (fe.game_info(Info.System,i) == currentsystem) ) {
                  fe.list.index = i
                  break
               }
            }

            corrector = (rows == 1 ? -1 : 0)
            searchdata.msg = searchtext
         }
         return true
      }

      else if (sig == "down") {
         overmenu_hide(false)
         //try {
            history_show(true)
         //} catch ( err ) { print( "History Error\n" ); }

         return true
      }

      else if (sig == "left") {
         // add tags
         overmenu_hide(true)
            if(prf.THEMEAUDIO) snd.wooshsound.playing=true
         fe.signal ("add_tags")
         return true
      }

      else if (sig == "right") {
         // add current game to favorites
         overmenu_hide(true)
            if(prf.THEMEAUDIO) snd.wooshsound.playing=true
         fe.signal("add_favourite")
         return true
      }

      else if (sig == "back") {
         overmenu_hide(false)
         return true
      }

      else if (sig == "select") {
         overmenu_hide(true)
         return false
      }
      else if ((sig == prf.OVERMENUBUTTON) && (prf.OVERMENUBUTTON != "select")) {
         overmenu_hide(false)
         return true
      }
      
      return false 
   }
   
   // history page signal response
   else if (history_visible())
   {
      debugpr (" HISTORY \n")

      if (sig == "up") {
         on_scroll_up()
         return true
      }

      else if (sig == "down") {
         on_scroll_down()
         return true
      }

      else if ((sig == "left")) {
         if (fe.list.index > 0) {
            fe.list.index --
            history_changegame(-1)
         }
         else{
            fe.list.index = fe.list.size - 1
            history_changegame(1)
         }
         //history_show(false)
         return true
      }

      else if ((sig == "right") ) {
         if (fe.list.index < (fe.list.size -1 )) {
            fe.list.index ++
            history_changegame(1)
         }
         else {
            fe.list.index = 0
            history_changegame (-1)
         }
         //history_show(false)
         return true
      }

      else if ( (sig == "random_game") || (sig == "next_favourite")  ||(sig == "next_letter")  || (sig == "next_game") || (sig == "next_page")){
         
         //if (sig == "random_game") fe.list.index = fe.list.size*rand()/RAND_MAX
         history_changegame(1)
         //history_show(false)
         return false         
      }

      else if ((sig == "prev_favourite") || (sig == "prev_letter")  || (sig =="prev_game") || (sig =="prev_page") ){
         history_changegame(-1)
         //history_show(false)
         return false         
      }

      else if (sig == "back") {
         history_exit()
         return true
      }

      return false 
   }

   // search page signal response
   else if (search_visible())
   {
      debugpr (" SEARCH \n")

      if ( sig == "up" ) {
         search_select_relative( 0, -1 )
         while (key_rows[key_selected[1]][key_selected[0]].tochar()=="_") search_select_relative( 0, -1 )
      }

      else if ( sig == "down" ) {
         search_select_relative( 0, 1 )
         while (key_rows[key_selected[1]][key_selected[0]].tochar()=="_") search_select_relative( 0, 1 )
      }

      else if ( sig == "left" ) {
         search_select_relative( -1, 0 )
         while (key_rows[key_selected[1]][key_selected[0]].tochar()=="_") search_select_relative( -1, 0 )
      }

      else if ( sig == "right" ) {
         search_select_relative( 1, 0 )
         while (key_rows[key_selected[1]][key_selected[0]].tochar()=="_") search_select_relative( 1, 0 )
      }

      else if ( sig == "select" ) search_type( key_rows[key_selected[1]][key_selected[0]].tochar() )
      //else if ( sig == "back" ) search_type("<")
      //else if ( sig == "exit" ) search_toggle()
      else if ( sig == "back" ) search_toggle()
   
      else if (sig == "screenshot"){
         return false
      }

      return true
   }
   
   // normal signal response
   else {
         // next and previous game or page signal response
      if(sig == "next_game"){
         if (fe.list.index < (fe.list.size -1 )) fe.list.index ++
         else fe.list.index = 0
         return true
      }
      if(sig == "prev_game"){
        if (fe.list.index > 0) fe.list.index --
        else fe.list.index = fe.list.size - 1
         return true
      }
      if(sig == "prev_page"){
         if (fe.list.index > rows*(cols - 2)) fe.list.index = fe.list.index - rows*(cols - 2)
         else (fe.list.index = 0)
         return true
      }
      if(sig == "next_page"){
         if (fe.list.index < fe.list.size - 1 - rows*(cols - 2)) fe.list.index = fe.list.index + rows*(cols -2)
         else fe.list.index = (fe.list.size -1 )
         return true
      }

      if (sig == "random_game"){
         fe.list.index = fe.list.size*rand()/RAND_MAX
         return true
      }  

      if ((sig == prf.UTILITYMENUBUTTON) && (prf.UTILITYMENUBUTTON != "up")){
         utilitymenu()
         return true
      }

      debugpr (" NORMAL \n")
      switch ( sig ){			

         
         case prf.OVERMENUBUTTON:
         if (!prf.DISPLAYMENUON) overmenu_show()
         return true

         case "left":

         if (sortjump){
            doorderjump (-1)
            return true
         }

         if (fe.list.index > scrollstep - 1) {
            if (count.left == 0) {
               fe.list.index -= scrollstep
               if(prf.THEMEAUDIO) snd.ticksound.playing=true
               count.left ++
            }
            else {
               count.left ++
               if (count.left == count.move)	count.left = 0			
            }
         }
         else if ((count.left == 0)){
            fe.list.index = fe.list.size -1
            count.forceleft = false
            return true
         }
         else if ((!count.forceleft) &&  (count.left != 0)){
            tilesTableZoom[newfocusindex] = [0.8,0.8,0.8,0.04,0.0]
            count.forceleft = true
            return true
         }

         //tilesTableZoom[newfocusindex] = [0.8,0.8,0.8,0.04,0.0]
         return true
        


         case "right":
         if (sortjump){
            doorderjump (1)
            return true
         }
         if ((fe.list.index < fe.list.size - scrollstep)){
            if (count.right == 0) {
               fe.list.index += scrollstep
               if(prf.THEMEAUDIO) snd.ticksound.playing=true
               count.right ++
            }
            else {
               count.right ++
               if (count.right == count.move)	count.right = 0			
            }
         }
         else if ((count.right == 0)){
            fe.list.index = 0
            count.forceright = false
            return true
         }
         else if ((!count.forceright) &&  (count.right != 0)){
            tilesTableZoom[newfocusindex] = [0.8,0.8,0.8,0.04,0.0]
            count.forceright = true
            return true
         } 
         
         
         //tilesTableZoom[newfocusindex] = [0.8,0.8,0.8,0.04,0.0]
         return true
         
         case "up":
         if ((fe.list.index % rows > 0) && (scrolljump == false) && (sortjump == false)) {
            fe.list.index --
            if(prf.THEMEAUDIO) snd.ticksound.playing=true
         }
         else if (scrolljump == true){
            if(prf.THEMEAUDIO) snd.wooshsound.playing=true
            scrolljump = false
            scrollstep = rows
            scroller2.visible = scrollineglow.visible = false
         }
         else if (sortjump == true){
            if(prf.THEMEAUDIO) snd.wooshsound.playing=true
            sortjump = false
            labelstrip.visible = false
            foreach (key in sortlabels) {
               key.style = Style.Regular
               key.char_size = 30 * scalerate

            }
            if (prf.SCROLLERTYPE != "LabelList") {
               scrolljump = true
               scrollstep = rows*(cols-2)
               scroller2.visible = scrollineglow.visible = true   
            }         
         }

         else {
            if (prf.UTILITYMENUBUTTON == "up") utilitymenu()
         }
         return true
         
         case "down":
         if  ((scrolljump == false) && (sortjump == false) &&  ((fe.list.index % rows < rows -1) && ( ! ( (fe.list.index / rows == fe.list.size / rows)&&(fe.list.index%rows + 1 > (fe.list.size -1)%rows) ))) ){
            if ((corrector == 0) && (fe.list.index == fe.list.size-1)) return true
            fe.list.index ++
            if(prf.THEMEAUDIO) snd.ticksound.playing=true
         }

         // if you go down and label list is not active, activate scrolljump
         else if ((scrolljump == false) && (sortjump == false) && (prf.SCROLLERTYPE != "LabelList")){
            if(prf.THEMEAUDIO) snd.wooshsound.playing=true
            scrolljump = true
            scrollstep = rows*(cols-2)
            scroller2.visible = scrollineglow.visible = true	
            sortjump = false
         }
         
         // if scrolljump is enabled and we are not in scrollbar mode, or if we are in labellist mode, activate sortjump
         else if (((scrolljump == true)  && (sortjump == false) && (fe.list.size > 0) && (prf.SCROLLERTYPE != "Scrollbar")) || ((prf.SCROLLERTYPE == "LabelList") && (fe.list.size > 0) && (sortjump == false))){
            if(prf.THEMEAUDIO) snd.wooshsound.playing=true
            scrolljump = false
            scroller2.visible = scrollineglow.visible = false
            sortjump = true
            labelstrip.visible = true
            foreach (key in sortlabels) {
               key.style = Style.Bold
               key.char_size = 38 * scalerate
            }

         }

         return true

         // All other cases
         default:
            if(prf.THEMEAUDIO) snd.wooshsound.playing=true
         
      }// END OF SWITCH SIGNAL LOOP 
   }// CLOSE ELSE GROUP
   return false
}
